function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

// @ts-ignore
import fetch from 'dva/fetch';
import notification from '../notification'; // 白名单

var urlWhiteList = ['/rest/getUrlConfig', '/rest/userInfo', '/system/getButtonPermission', '/system/getMenu', '/rest/msgInfo', '/system/getDataDictionary', '/import/progress', '/minima/language/save']; // 刚打开页面前3S不进行防重复

var allowRepeat = true;
setTimeout(function () {
  allowRepeat = false;
}, 5000);

var uuidCompact = function uuidCompact() {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    // tslint:disable-next-line:no-bitwise
    var r = Math.random() * 16 | 0; // tslint:disable-next-line:no-bitwise

    var v = c === 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
}; // @ts-ignore


var store = window._store;
var token = uuidCompact();
var codeMessage = {
  200: '服务器成功返回请求的数据。',
  201: '新建或修改数据成功。',
  202: '一个请求已经进入后台排队（异步任务）。',
  204: '删除数据成功。',
  400: '发出的请求有错误，服务器没有进行新建或修改数据的操作。',
  401: '用户没有权限（令牌、用户名、密码错误）。',
  403: '用户得到授权，但是访问是被禁止的。',
  404: '发出的请求针对的是不存在的记录，服务器没有进行操作。',
  406: '请求的格式不可得。',
  410: '请求的资源被永久删除，且不会再得到的。',
  422: '当创建一个对象时，发生一个验证错误。',
  500: '服务器发生错误，请检查服务器。',
  502: '网关错误。',
  503: '服务不可用，服务器暂时过载或维护。',
  504: '网关超时。'
};
var globalUrls = {};

window.onhashchange = function () {
  token = uuidCompact();
  globalUrls = {};
};

function checkStatus(response) {
  var url = response.url;
  clearTimeout(globalUrls["".concat(url, "id")]);
  delete globalUrls[url];
  delete globalUrls["".concat(url, "id")];

  if (response.status >= 200 && response.status < 300) {
    return response;
  }

  var errortext = codeMessage[response.status] || response.statusText;
  notification.error({
    message: "\u8BF7\u6C42\u9519\u8BEF ".concat(response.status, ": ").concat(response.url),
    description: errortext
  });
  var error = new Error(errortext);
  error.name = response.status;
  error.response = response;
  throw error;
}
/**
 * Requests a URL, returning a promise.
 *
 * @param  {string} url       The URL we want to request
 * @param  {object} [options] The options we want to pass to "fetch"
 * @return {object}           An object containing either "data" or "err"
 */
// 通过请求参数设置允许重复提交


export default function request(url, options) {
  var allowRepeatPost = false;
  var controller = new AbortController();
  var signal = controller.signal;
  var tmplate = "http://".concat(window.location.host).concat(url.replace('..', ''));
  var defaultOptions = {
    credentials: 'include'
  };

  var newOptions = _extends({}, defaultOptions, options); // tslint:disable-next-line:no-unused-expression


  newOptions.method && (newOptions.method = newOptions.method.toLocaleUpperCase()); // newOptions.headers.asgasf = token;

  var newUrl = "".concat(url);

  if (newOptions.allowRepeat || url.indexOf(allowRepeat) > -1) {
    delete newOptions.allowRepeat;
    newUrl = newUrl.replace('allowRepeat=true', '');
    allowRepeatPost = true;
  }

  if (newOptions.method === 'POST' || newOptions.method === 'PUT' || newOptions.method === 'DELETE') {
    if (!(newOptions.body instanceof FormData)) {
      newOptions.headers = _extends({
        Accept: 'application/json',
        'Content-Type': 'application/json; charset=utf-8',
        'X-Requested-With': 'XMLHttpRequest'
      }, newOptions.headers);
      newOptions.body = JSON.stringify(newOptions.body);
    } else {
      // newOptions.body is FormData
      newOptions.headers = _extends({
        Accept: 'application/json'
      }, newOptions.headers);
    }
  }

  newOptions.headers = _extends({
    token: token
  }, newOptions.headers); // if (globalUrls[tmplate] && !allowRepeat) {
  //   globalUrls[tmplate] = true;
  //   (urlid => {
  //     clearTimeout(globalUrls[`${urlid}id`]);
  //     globalUrls[`${urlid}id`] = window.setTimeout(() => {
  //       delete globalUrls[urlid];
  //       delete globalUrls[`${urlid}id`];
  //     }, 3000);
  //   })(tmplate);
  //   return new Promise((_, reject) => {
  //     reject()
  //   })
  // }
  // @ts-ignore

  var fch = fetch(newUrl, _extends({}, newOptions, {
    signal: signal
  })).then(checkStatus).then(function (response) {
    var res = {};

    if (newOptions.method === 'DELETE' || response.status === 204) {
      res = response.text();
    }

    res = response.json();
    return res;
  }).then(function (response) {
    // console.log(tmplate, 'tmplate1');
    if (response.errorCode === 500) {
      notification.error({
        message: "\u8BF7\u6C42\u9519\u8BEF ".concat(response.errorCode),
        description: response.message
      });
      throw new Error(response);
    } else {
      var pageIndex = response.pageIndex,
          pageSize = response.pageSize,
          rowsCount = response.rowsCount,
          data = response.data;

      if (pageIndex && pageSize && rowsCount && data && (pageIndex - 1) * pageSize > rowsCount && data.length === 0) {
        options.body.pageNumber = Math.ceil(rowsCount / pageSize);
        return request(url, options);
      }

      return response;
    }
  })["catch"](function (e) {
    // const { dispatch } = store;
    var status = e.name;

    if (status === 'TypeError') {
      window.location.href = '../rest/redirect?url=' + encodeURIComponent(window.location.href); //window.location.href = '../logout';

      return;
    }

    if (status === 401) {
      window.location.href = '../rest/redirect?url=' + encodeURIComponent(window.location.href); // window.location.href = '../logout';

      return;
    }

    if (status === 403) {
      // dispatch(routerRedux.push('/exception/403'));
      window.location.href = '../rest/redirect?url=' + encodeURIComponent(window.location.href); // window.location.href = '../logout';

      return;
    }

    if (status <= 504 && status >= 500) {
      // dispatch(routerRedux.push('/exception/500'));
      return;
    }

    if (status >= 404 && status < 422) {// dispatch(routerRedux.push('/exception/404'));
    }
  });

  if (globalUrls[tmplate] && !allowRepeat) {
    controller.abort();
  } // 只对 post 请求进行拦截


  if (urlWhiteList.indexOf(url.replace('..', '')) === -1 && !allowRepeatPost) {
    if (newOptions.method === 'POST' || newOptions.method === 'PUT' || newOptions.method === 'DELETE') {
      globalUrls[tmplate] = true;

      (function (urlid) {
        clearTimeout(globalUrls["".concat(urlid, "id")]);
        globalUrls["".concat(urlid, "id")] = window.setTimeout(function () {
          delete globalUrls[urlid];
          delete globalUrls["".concat(urlid, "id")];
        }, 3000);
      })(tmplate);
    }
  } // console.log(globalUrls, 'globalUrls');


  return fch;
}