function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import Icon from "antd/es/icon";
import Layout from "antd/es/layout";
import Menu from "antd/es/menu";
import * as React from 'react';
import { Link } from 'react-router-dom';

var pathToRegexp = require('path-to-regexp'); // import { urlToList } from '../_util/pathTools';


var Sider = Layout.Sider;
var SubMenu = Menu.SubMenu;
var preCls = 'ant-sidermenu'; // Allow menu.js config icon as string or ReactNode
//   icon: 'setting',
//   icon: 'http://demo.com/icon.png',
//   icon: <Icon type="setting" />,

function urlToList(url) {
  var urllist = url.split('/').filter(function (i) {
    return i;
  }); // @ts-ignore

  return urllist.map(function (urlItem, index) {
    return "/".concat(urllist.slice(0, index + 1).join('/'));
  });
}

var getIcon = function getIcon(icon) {
  if (typeof icon === 'string') {
    if (icon.indexOf('http') === 0) {
      return React.createElement("img", {
        src: icon,
        alt: "icon",
        className: "".concat(preCls, "-icon sider-menu-item-img")
      });
    }

    return React.createElement(Icon, {
      type: icon
    });
  }

  return icon;
};
/**
 * Recursively flatten the data
 * [{path:string},{path:string}] => [path,path2]
 * @param  menu
 */


export var getFlatMenuKeys = function getFlatMenuKeys(menu) {
  return menu.reduce(function (keys, item) {
    keys.push(item.path);

    if (item.children) {
      return keys.concat(getFlatMenuKeys(item.children));
    }

    return keys;
  }, []);
};
/**
 * Find all matched menu keys based on paths
 * @param  flatMenuKeys: [/abc, /abc/:id, /abc/:id/info]
 * @param  paths: [/abc, /abc/11, /abc/11/info]
 */

export var getMenuMatchKeys = function getMenuMatchKeys(flatMenuKeys, paths) {
  return paths.reduce(function (matchKeys, path) {
    return matchKeys.concat(flatMenuKeys.filter(function (item) {
      return pathToRegexp(item).test(path);
    }));
  }, []);
};

var SiderMenu =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(SiderMenu, _React$PureComponent);

  function SiderMenu(props) {
    var _this;

    _classCallCheck(this, SiderMenu);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SiderMenu).call(this, props));
    /**
     * 判断是否是http链接.返回 Link 或 a
     * Judge whether it is http link.return a or Link
     * @memberof SiderMenu
     */

    _this.getMenuItemPath = function (item) {
      var itemPath = _this.conversionPath(item.path);

      var icon = getIcon(item.icon);
      var target = item.target,
          name = item.name; // Is it a http link

      if (/^https?:\/\//.test(itemPath)) {
        return React.createElement("a", {
          href: itemPath,
          target: target
        }, icon, React.createElement("span", null, name));
      }

      var _this$props = _this.props,
          location = _this$props.location,
          isMobile = _this$props.isMobile,
          onCollapse = _this$props.onCollapse;
      return React.createElement(Link, {
        to: itemPath,
        target: target,
        replace: itemPath === location.pathname,
        onClick: isMobile ? function () {
          onCollapse(true);
        } : undefined
      }, icon, React.createElement("span", null, name));
    };
    /**
     * get SubMenu or Item
     */


    _this.getSubMenuOrItem = function (item) {
      if (item.children && item.children.some(function (child) {
        return child.name;
      })) {
        var childrenItems = _this.getNavMenuItems(item.children); // 当无子菜单时就不展示菜单


        if (childrenItems && childrenItems.length > 0) {
          return React.createElement(SubMenu, {
            title: item.icon ? React.createElement("span", null, getIcon(item.icon), React.createElement("span", null, item.name)) : item.name,
            key: item.path
          }, childrenItems);
        }

        return null;
      }

      return React.createElement(Menu.Item, {
        key: item.path
      }, _this.getMenuItemPath(item));
    };
    /**
     * 获得菜单子节点
     * @memberof SiderMenu
     */


    _this.getNavMenuItems = function (menusData) {
      if (!menusData) {
        return [];
      }

      return menusData.filter(function (item) {
        return item.name && !item.hideInMenu;
      }).map(function (item) {
        // make dom
        var ItemDom = _this.getSubMenuOrItem(item);

        return _this.checkPermissionItem(item.authority, ItemDom);
      }).filter(function (item) {
        return item;
      });
    }; // Get the currently selected menu


    _this.getSelectedMenuKeys = function () {
      var pathname = _this.props.location.pathname;
      return getMenuMatchKeys(_this.flatMenuKeys, urlToList(pathname));
    }; // conversion Path
    // 转化路径


    _this.conversionPath = function (path) {
      if (path && path.indexOf('http') === 0) {
        return path;
      }

      return "/".concat(path || '').replace(/\/+/g, '/');
    }; // permission to check


    _this.checkPermissionItem = function (authority, ItemDom) {
      var Authorized = _this.props.Authorized;

      if (Authorized && Authorized.check) {
        var check = Authorized.check;
        return check(authority, ItemDom);
      }

      return ItemDom;
    };

    _this.isMainMenu = function (key) {
      var menuData = _this.props.menuData;
      return menuData.some(function (item) {
        return key && (item.key === key || item.path === key);
      });
    };

    _this.handleOpenChange = function (openKeys) {
      var lastOpenKey = openKeys[openKeys.length - 1];
      var moreThanOne = openKeys.filter(function (openKey) {
        return _this.isMainMenu(openKey);
      }).length > 1;

      _this.setState({
        openKeys: moreThanOne ? [lastOpenKey] : _toConsumableArray(openKeys)
      });
    };

    _this.toggle = function () {
      var _this$props2 = _this.props,
          collapsed = _this$props2.collapsed,
          onCollapse = _this$props2.onCollapse;

      if (collapsed) {
        _this.setState({
          iconWidth: '212px'
        });
      } else {
        _this.setState({
          iconWidth: '80px'
        });
      }

      onCollapse(!collapsed);
    };

    _this.flatMenuKeys = getFlatMenuKeys(props.menuData);
    _this.state = {
      openKeys: _this.getDefaultCollapsedSubMenus(props),
      iconWidth: '212px'
    };
    return _this;
  }

  _createClass(SiderMenu, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var location = this.props.location;

      if (nextProps.location.pathname !== location.pathname) {
        this.setState({
          openKeys: this.getDefaultCollapsedSubMenus(nextProps)
        });
      }
    }
    /**
     * Convert pathname to openKeys
     * /list/search/articles = > ['list','/list/search']
     * @param  props
     */

  }, {
    key: "getDefaultCollapsedSubMenus",
    value: function getDefaultCollapsedSubMenus(props) {
      var _ref = props || this.props,
          pathname = _ref.location.pathname;

      return getMenuMatchKeys(this.flatMenuKeys, urlToList(pathname));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          menuData = _this$props3.menuData,
          collapsed = _this$props3.collapsed,
          onCollapse = _this$props3.onCollapse;
      var openKeys = this.state.openKeys; // Don't show popup menu when it is been collapsed

      var menuProps = collapsed ? {} : {
        openKeys: openKeys
      }; // if pathname can't match, use the nearest parent's key

      var selectedKeys = this.getSelectedMenuKeys();

      if (!selectedKeys.length) {
        selectedKeys = [openKeys[openKeys.length - 1]];
      }

      return React.createElement(Sider, {
        trigger: null,
        collapsible: true,
        collapsed: collapsed,
        breakpoint: "lg",
        onCollapse: onCollapse,
        width: 212,
        className: "".concat(preCls, "-sider")
      }, React.createElement(Menu, _extends({
        key: "Menu",
        theme: "light",
        mode: "inline"
      }, menuProps, {
        onOpenChange: this.handleOpenChange,
        selectedKeys: selectedKeys,
        style: {
          padding: '16px 0',
          width: '100%'
        }
      }), this.getNavMenuItems(menuData)), React.createElement("div", {
        className: "fixedBottom",
        style: {
          width: this.state.iconWidth
        }
      }, React.createElement(Icon, {
        className: "trigger",
        type: collapsed ? 'right' : 'left',
        onClick: this.toggle
      })));
    }
  }]);

  return SiderMenu;
}(React.PureComponent);

export { SiderMenu as default };