function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import Layout from "../layout";
import message from "../message";
import Modal from "../modal";
import classNames from 'classnames';
import { connect } from 'dva';
import { Redirect, Route, Switch } from 'dva/router';
import PropTypes from 'prop-types';
import * as React from 'react';
import { ContainerQuery } from 'react-container-query'; // @ts-ignore

import store from 'store';
import NotFound from './404';
import Authorized from './Authorized';
import SiderMenu from './SiderMenu';
import { getRoutes } from './utils';
import { intlFormat } from '../_util/utils'; // @ts-ignore

var pathToRegexp = require('path-to-regexp');

var DocumentTitle = require('react-document-title');

var _require = require('enquire-js'),
    enquireScreen = _require.enquireScreen,
    unenquireScreen = _require.unenquireScreen;

var logo = require('./img/logo.png');

var mailUsers = require('./img/mail_users.png');

var logoPic = require('./img/logo_pic.png');

var logoutSub = require('./img/logoutSub.png');

var Content = Layout.Content,
    Header = Layout.Header;
var AuthorizedRoute = Authorized.AuthorizedRoute,
    check = Authorized.check;
var confirm = Modal.confirm;
/**
 * 根据菜单取得重定向地址.
 */

var redirectData = [];

var getRedirect = function getRedirect(item) {
  if (item && item.children) {
    if (item.children[0] && item.children[0].path) {
      redirectData.push({
        from: "".concat(item.path),
        to: "".concat(item.children[0].path)
      });
      item.children.forEach(function (children) {
        getRedirect(children);
      });
    }
  }
};
/* queryMenu().then(data => {
  data.forEach(getRedirect);
}); */
// getMenuData().forEach(getRedirect);

/**
 * 获取面包屑映射
 * @param {Object} menuData 菜单配置
 * @param {Object} routerData 路由配置
 */


var getBreadcrumbNameMap = function getBreadcrumbNameMap(menuData, routerData) {
  var result = {};
  var childResult = {};
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = menuData[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var i = _step.value;

      if (!routerData[i.path]) {
        result[i.path] = i;
      }

      if (i.children) {
        _extends(childResult, getBreadcrumbNameMap(i.children, routerData));
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return _extends({}, routerData, result, childResult);
};

var query = {
  'screen-xs': {
    maxWidth: 575
  },
  'screen-sm': {
    minWidth: 576,
    maxWidth: 767
  },
  'screen-md': {
    minWidth: 768,
    maxWidth: 991
  },
  'screen-lg': {
    minWidth: 992,
    maxWidth: 1199
  },
  'screen-xl': {
    minWidth: 1200,
    maxWidth: 1599
  },
  'screen-xxl': {
    minWidth: 1600
  }
};
var isMobile;
enquireScreen(function (b) {
  isMobile = b;
});

var BasicLayout =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(BasicLayout, _React$PureComponent);

  function BasicLayout(props) {
    var _this;

    _classCallCheck(this, BasicLayout);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BasicLayout).call(this, props));

    _this.getBaseRedirect = function () {
      // According to the url parameter to redirect
      // 这里是重定向的,重定向到 url 的 redirect 参数所示地址
      var urlParams = new URL(window.location.href);
      var redirect = urlParams.searchParams.get('redirect'); // Remove the parameters in the url

      if (redirect) {
        urlParams.searchParams["delete"]('redirect');
        window.history.replaceState(null, 'redirect', urlParams.href);
      } else {
        var routerData = _this.props.routerData; // get the first authorized route path in routerData

        var authorizedPath = Object.keys(routerData).find(function (item) {
          return check(routerData[item].authority, item) && item !== '/';
        });
        return authorizedPath;
      }

      return redirect;
    };

    _this.handleMenuCollapse = function (collapsed) {
      var dispatch = _this.props.dispatch;
      dispatch({
        type: 'global/changeLayoutCollapsed',
        payload: collapsed
      });
    };

    _this.handleNoticeClear = function (type) {
      message.success(intlFormat('jlt.jltd.clearType', '清空了{type}', {
        type: type
      }));
      var dispatch = _this.props.dispatch;
      dispatch({
        type: 'global/clearNotices',
        payload: type
      });
    };

    _this.handleMenuClick = function () {
      // const { dispatch } = this.props;
      confirm({
        title: intlFormat('jlt.jltd.checkLeaveTitle', '离开后就没有丰富的信息了哦'),
        okText: intlFormat('jlt.jltd.Confirm', '确定'),
        onOk: function onOk() {
          store.remove('menuData');
          /* dispatch({
            type: 'login/logout',
          }); */

          window.location.href = '../logout';
        },
        cancelText: intlFormat('jlt.jltd.Cancelled', '取消'),
        onCancel: function onCancel() {}
      });
    };

    _this.handleNoticeVisibleChange = function (visible) {
      var dispatch = _this.props.dispatch;

      if (visible) {
        dispatch({
          type: 'global/fetchNotices'
        });
      }
    };

    _this.state = {
      isMobile: isMobile
    };
    props.menuData.forEach(getRedirect);
    return _this;
  }

  _createClass(BasicLayout, [{
    key: "getChildContext",
    value: function getChildContext() {
      var _this$props = this.props,
          location = _this$props.location,
          routerData = _this$props.routerData,
          menuData = _this$props.menuData;
      return {
        location: location,
        breadcrumbNameMap: getBreadcrumbNameMap(menuData, routerData)
      };
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.enquireHandler = enquireScreen(function (mobile) {
        _this2.setState({
          isMobile: mobile
        });
      });
      var dispatch = this.props.dispatch;
      dispatch({
        type: 'user/fetchCurrent'
      });
      var centerPageUrl = this.props.centerPageUrl;
      /* eslint-disable */
      //    Top.init();
      // $('#21CBA9CC6CC243379206254FAF8C4B2C').addClass('cur');

      /* eslint-enable */

      this.props.dispatch({
        type: 'global/userInfo'
      }); //      .then((userInfo) => {
      //        this.refreshUserInfo(userInfo);
      //      });

      this.props.dispatch({
        type: 'global/msgInfo'
      });

      if (centerPageUrl.length === 0) {
        this.props.dispatch({
          type: 'global/getCenterPageUrl'
        }).then(function () {
          _this2.refreshData();
        });
      } else {
        this.refreshData();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      unenquireScreen(this.enquireHandler);
    }
  }, {
    key: "refreshData",
    value: function refreshData() {//    this.props.dispatch({
      //      type: 'nav/getMsgCount',
      //      payload: {
      //        urlPath: centerPageUrl[0],
      //      },
      //    });
      //    this.props.dispatch({
      //      type: 'nav/getEsServices',
      //      payload: {
      //        urlPath: centerPageUrl[0],
      //      },
      //    });
      //    this.props.dispatch({
      //      type: 'nav/getMenu',
      //      payload: {
      //        urlPath: centerPageUrl[0],
      //      },
      //    });
      //    this.props.dispatch({
      //        type: 'nav/getButtonPermission',
      //        payload: {},
      // 	});
    }
  }, {
    key: "refreshUserInfo",
    value: function refreshUserInfo(userInfo) {
      if (!userInfo) {
        return;
      }

      var condition = {};
      condition.businessPmCode = "".concat(userInfo.tenantId);
      this.props.dispatch({
        type: 'global/userLogo',
        payload: {
          condition: condition
        }
      });
      condition.businessPmCode = "".concat(userInfo.userId, "member");
      this.props.dispatch({
        type: 'global/userPic',
        payload: {
          condition: condition
        }
      });
    }
  }, {
    key: "getPageTitle",
    value: function getPageTitle() {
      var _this$props2 = this.props,
          routerData = _this$props2.routerData,
          location = _this$props2.location;
      var pathname = location.pathname;
      var title = 'Ant Design Pro';
      var currRouterData = null; // match params path
      // Object.keys(routerData).forEach(key => {
      //   if (key==pathname) {
      //     currRouterData = routerData[key];
      //   }
      // });

      Object.keys(routerData).forEach(function (key) {
        if (pathToRegexp(key).test(pathname)) {
          currRouterData = routerData[key]; // debugger
        }
      });

      if (currRouterData && currRouterData.name) {
        title = "".concat(currRouterData.name, " - Ant Design Pro");
      }

      return title;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          collapsed = _this$props3.collapsed,
          routerData = _this$props3.routerData,
          match = _this$props3.match,
          location = _this$props3.location,
          menuData = _this$props3.menuData,
          userInfo = _this$props3.userInfo,
          msgInfo = _this$props3.msgInfo;
      var logoImg;

      if (userInfo != null && userInfo.logoPic) {
        logoImg = React.createElement("img", {
          className: "logoImg",
          src: "../file/downLoadFile?pmCode=".concat(userInfo.logoPic)
        });
      } else {
        logoImg = React.createElement("img", {
          className: "logoImg",
          src: logo
        });
      }

      var userImg;

      if (userInfo != null && userInfo.userPic) {
        userImg = React.createElement("img", {
          className: "userImg",
          src: "../file/downLoadFile?pmCode=".concat(userInfo.userPic)
        });
      } else {
        userImg = React.createElement("img", {
          className: "userImg",
          src: logoPic
        });
      }

      var userName;

      if (userInfo != null && userInfo.userName) {
        userName = userInfo.userName;
      }

      var userMessage = '';

      if (msgInfo) {
        var currentUrl = window.location.href;
        var msgPageUrl = msgInfo.msgPageUrl.split('#');

        if (currentUrl.indexOf(msgPageUrl[0]) !== -1) {
          msgInfo.msgPageUrl = "#".concat(msgPageUrl[1]);
        }

        if (msgInfo.msgCount > 0) {
          userMessage = React.createElement("a", {
            className: "userMessage",
            href: "#".concat(msgPageUrl[1])
          }, React.createElement("img", {
            src: mailUsers
          }), React.createElement("i", null));
        } else {
          userMessage = React.createElement("a", {
            className: "userMessage",
            href: "#".concat(msgPageUrl[1])
          }, React.createElement("img", {
            src: mailUsers
          }));
        }
      }

      var mb = this.state.isMobile;
      var bashRedirect = this.getBaseRedirect();
      var layout = React.createElement(Layout, {
        className: "jlt-base-layout"
      }, React.createElement(Header, {
        style: {
          padding: 0
        },
        className: "headerbg"
      }, React.createElement("div", null, logoImg, React.createElement("div", {
        className: "right"
      }, userImg, userName, userMessage, React.createElement("a", {
        onClick: this.handleMenuClick
      }, React.createElement("img", {
        src: logoutSub
      }))))), React.createElement(Layout, null, React.createElement(SiderMenu // logo={logo}
      // 不带Authorized参数的情况下如果没有权限,会强制跳到403界面
      // If you do not have the Authorized parameter
      // you will be forced to jump to the 403 interface without permission
      , {
        Authorized: Authorized,
        menuData: menuData,
        collapsed: collapsed,
        location: location,
        isMobile: mb,
        onCollapse: this.handleMenuCollapse
      }), React.createElement(Content, {
        className: "content"
      }, React.createElement(Switch, null, redirectData.map(function (item) {
        return React.createElement(Redirect, {
          key: item.from,
          exact: true,
          from: item.from,
          to: item.to
        });
      }), getRoutes(match.path, routerData).map(function (item) {
        return React.createElement(AuthorizedRoute, {
          key: item.key,
          path: item.path,
          component: item.component,
          exact: item.exact,
          authority: "admin"
        });
      }), React.createElement(Redirect, {
        exact: true,
        from: "/",
        to: bashRedirect
      }), React.createElement(Route, {
        render: NotFound
      })))));
      return React.createElement(DocumentTitle, {
        title: this.getPageTitle()
      }, React.createElement(ContainerQuery, {
        query: query
      }, function (params) {
        return React.createElement("div", {
          className: classNames(params)
        }, layout);
      }));
    }
  }]);

  return BasicLayout;
}(React.PureComponent);

BasicLayout.propTypes = {
  menuData: PropTypes.array
};
BasicLayout.childContextTypes = {
  location: PropTypes.object,
  breadcrumbNameMap: PropTypes.object
};
BasicLayout.defaultProps = {
  menuData: []
};
export default connect(function (_ref) {
  var user = _ref.user,
      global = _ref.global,
      loading = _ref.loading;
  return {
    currentUser: user.currentUser,
    collapsed: global.collapsed,
    fetchingNotices: loading.effects['global/fetchNotices'],
    notices: global.notices,
    menuData: global.menuData,
    routerData: global.routerData,
    userInfo: global.userInfo,
    centerPageUrl: global.centerPageUrl,
    userPic: global.userPic,
    userLogo: global.userLogo,
    msgInfo: global.msgInfo
  };
})(BasicLayout);