import * as React from 'react';
import Button from 'antd/es/button';
import Popconfirm from 'antd/es/popconfirm';
import Icon from 'antd/es/icon';
import buttonPermission from './buttonPermission';
import { intlFormat } from '../_util/utils';

var operationButtonGroup = function operationButtonGroup() {
  var buttonList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var filterButtonList = buttonPermission.filterPermission(buttonList);
  var operationButtonList = filterButtonList.map(function (buttonInfo) {
    var renderIcon = React.createElement("a", {
      onClick: buttonInfo.onClick
    }, React.createElement(Icon, {
      type: buttonInfo.iconType,
      style: {
        color: '#0078D6',
        width: '20px',
        height: '20px'
      }
    }));
    var renderButton = buttonInfo.iconType ? renderIcon : React.createElement(Button, {
      className: "operation-btn",
      type: buttonInfo.type || 'default',
      size: buttonInfo.size || 'default',
      onClick: buttonInfo.onClick
    }, buttonInfo.text);
    var renderPopconfirm = React.createElement(Popconfirm, {
      placement: "topRight",
      title: buttonInfo.popconfirmTitle,
      onConfirm: buttonInfo.onClick,
      okText: intlFormat('jlt.jltd.Confirm', '确定'),
      cancelText: intlFormat('jlt.jltd.Cancelled', '取消')
    }, buttonInfo.iconType ? React.createElement("a", null, React.createElement(Icon, {
      type: buttonInfo.iconType,
      style: {
        color: '#0078D6',
        width: '20px',
        height: '20px',
        paddingLeft: '12px'
      }
    })) : React.createElement(Button, {
      className: "operation-btn",
      type: buttonInfo.type || 'default',
      size: buttonInfo.size || 'default'
    }, buttonInfo.text));
    return React.createElement("span", {
      key: buttonInfo.text
    }, buttonInfo.popconfirmTitle ? renderPopconfirm : renderButton);
  });
  return operationButtonList;
};

export default operationButtonGroup;