import Button from 'antd/es/button';
import Popconfirm from 'antd/es/popconfirm';
import { intlFormat } from '../_util/utils';

var getOptionDataText = function getOptionDataText(list, value) {
  var text = null;
  list && list.some(function (data) {
    if (!data || data.value !== value) {
      return false;
    }

    text = data.text;
    return true;
  });
  return text || value; // 找不到对应值，显示value
};

var searchButtonGroup = function searchButtonGroup() {
  var buttonList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return buttonList.map(function (buttonInfo) {
    var renderButton = React.createElement(Button, {
      className: "button-group",
      type: getOptionDataText([], buttonInfo.type),
      size: buttonInfo.size || 'default',
      onClick: buttonInfo.onClick
    }, buttonInfo.text);
    var renderPopconfirm = React.createElement(Popconfirm, {
      placement: "topRight",
      title: buttonInfo.popconfirmText,
      onConfirm: buttonInfo.onClick,
      okText: intlFormat('jlt.jltd.Confirm', '确定'),
      cancelText: intlFormat('jlt.jltd.Cancelled', '取消')
    }, React.createElement(Button, {
      className: "button-group",
      type: "primary",
      size: buttonInfo.size || 'default'
    }, buttonInfo.text));
    return React.createElement("span", {
      key: buttonInfo.text
    }, buttonInfo.isPopconfirm ? renderPopconfirm : renderButton);
  });
};

export default searchButtonGroup;