function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import * as React from 'react';
import Modal from '../modal';
import Button from '../button'; // import * as $ from 'jquery';

import url from '../_util/url';
import { intlFormat } from '../_util/utils';
import request from '../_util/request';

var ExceptionModalComponent =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ExceptionModalComponent, _React$Component);

  function ExceptionModalComponent(props) {
    var _this;

    _classCallCheck(this, ExceptionModalComponent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ExceptionModalComponent).call(this, props));

    _this.exceptionModelCancel = function () {
      _this.setState({
        visible: false
      });
    };

    _this.onExceptionModelConfirm = function () {
      _this.setState({
        visible: false
      });

      var errorId = _this.state.errorId;
      request(url.exception.upload(), {
        method: 'POST',
        body: {
          exceptionInfoId: errorId
        }
      });
      /* $.ajax({
        url: url.exception.upload(),
        data: { exceptionInfoId: errorId },
        cache: false,
        type: 'POST',
        dataType: 'x-www-form-urlencoded',
        success() {},
        error() {},
      }); */

      Modal.success({
        content: intlFormat('jlt.jltd.abnormalHasBeenReported', '异常已上报!')
      });
    };

    var visible = props.visible,
        errorData = props.errorData;
    _this.state = {
      visible: visible,
      errorData: errorData,
      errorId: null
    };
    return _this;
  }

  _createClass(ExceptionModalComponent, [{
    key: "visibleCheck",
    value: function visibleCheck() {
      if (this.props.visible === undefined || this.props.visible === '' || this.props.visible === null || this.props.visible === 'null' || this.props.visible === 'NULL') {
        return true;
      }

      return false;
    }
  }, {
    key: "errorDateCheck",
    value: function errorDateCheck() {
      if (this.props.errorData === undefined || this.props.errorData === '' || this.props.errorData === null || this.props.errorData === 'null' || this.props.errorData === 'NULL') {
        return true;
      }

      if (JSON.stringify(this.props.errorData) === '{}') {
        return true;
      }

      return false;
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextprops) {
      if (nextprops.visible !== this.state.visible) {
        this.setState({
          visible: nextprops.visible,
          errorId: this.errorDateCheck() ? '' : nextprops.errorData.id
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var code = this.errorDateCheck() ? '' : this.props.errorData.code;
      var message = this.errorDateCheck() ? '' : this.props.errorData.message;

      if (this.visibleCheck() || this.errorDateCheck()) {
        return React.createElement("div", null);
      }

      return React.createElement(Modal, {
        title: intlFormat('jlt.jltd.abnormalInformation', '异常信息'),
        visible: this.state.visible,
        onOk: this.onExceptionModelConfirm,
        onCancel: this.exceptionModelCancel,
        footer: [React.createElement(Button, {
          key: "close",
          onClick: this.exceptionModelCancel
        }, intlFormat('jlt.jltd.Close', '关闭')), React.createElement(Button, {
          key: "upload",
          type: "primary",
          onClick: this.onExceptionModelConfirm
        }, intlFormat('jlt.jltd.Report', '上报'))]
      }, React.createElement("p", null, intlFormat('jlt.jltd.exceptionCode', '异常代码'), ":", code), React.createElement("p", null, intlFormat('jlt.jltd.abnormalInformation', '异常信息'), ":", message));
    }
  }]);

  return ExceptionModalComponent;
}(React.Component);

export default ExceptionModalComponent;