function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import * as React from 'react';
import Form from '../form';
import Input from '../input';
import Row from '../row';
import Col from '../col';
import Select from '../select';
import DatePicker from 'antd/es/date-picker';
import Radio from '../radio';
import Cascader from '../cascader';
import Checkbox from '../checkbox';
import InputNumber from '../input-number';
import Icon from '../icon';
import classnames from 'classnames';
import moment from 'moment';
import RanderRange from '../label-with-controller/RanderRange';
import DataDictionaryComponents from '../DataDictionaryComponents';
import RadioGroupComponents from '../radio-group-components';
import Enum from '../_util/enum';
import city from '../_util/city';
var RangePicker = DatePicker.RangePicker;
var TextArea = Input.TextArea;
var Search = Input.Search;
var Option = Select.Option;
var RadioGroup = Radio.Group;
var CheckboxGroup = Checkbox.Group; //获取FormItem

var FormItem = Form.Item;

var FormComponents =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FormComponents, _React$Component);

  function FormComponents(props) {
    var _this;

    _classCallCheck(this, FormComponents);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FormComponents).call(this, props));
    /**
     * 创建FormItem
     * formItemProps: FormItem的属性
     * fileId: 控件的id，唯一标识
     * fieldOption: getFieldDecorator方法传入的option
     * field： 组件
     */

    _this.createFormItem = function (_ref, field) {
      var formItemProps = _ref.formItemProps,
          label = _ref.label,
          fileId = _ref.fileId,
          fieldOption = _ref.fieldOption;
      var getFieldDecorator = _this.props.form.getFieldDecorator;
      var formItemProp = formItemProps == null ? _this.formItemLayout : formItemProps;
      var options = fieldOption == null ? {} : fieldOption;
      /* if (!("rules" in options) && type === "input") {
        options.rules = [{}];
      }
      if ("rules" in options && type === "input") {
        const lastOptions = options.rules[options.rules.length - 1];
        if (
          !("validator" in lastOptions) ||
          ("validator" in lastOptions && !("label" in lastOptions))
        )
          options.rules.push({
            label: "",
            validator: (rule, value, cb) => {
              if (value && value.length > 0 && value.trim().length === 0 ) {
                //setFieldsValue({[fileId]:value.trim()});
                cb("有多余的空隔");
              } else {
                cb();
              }
            }
          });
      } */

      return React.createElement(FormItem, _extends({}, formItemProp, {
        label: label,
        colon: false
      }), getFieldDecorator(fileId == null ? '' : fileId, options)(field));
    };

    _this.createHiddenInput = function (_ref2, field) {
      var fileId = _ref2.fileId,
          fieldOption = _ref2.fieldOption;
      return React.createElement("div", null, _this.props.form.getFieldDecorator(fileId == null ? '' : fileId, fieldOption == null ? {} : fieldOption)(field));
    };

    _this.createDetail = function (_ref3) {
      var formItemProps = _ref3.formItemProps,
          label = _ref3.label,
          val = _ref3.val,
          customFontSize = _ref3.customFontSize;
      var formItemProp = formItemProps == null ? _this.formItemLayout : formItemProps;
      return React.createElement(FormItem, _extends({}, formItemProp, {
        label: label
      }), React.createElement("span", {
        style: {
          fontSize: null == customFontSize ? 14 : customFontSize
        }
      }, val == null ? '' : val));
    };

    _this.convertFormInfo = function (data) {
      if (data.type === 'hidden') {
        // tslint:disable-next-line:no-shadowed-variable
        var field = data.field == null ? React.createElement(Input, {
          type: "hidden"
        }) : data.field;
        return _this.createHiddenInput(data, field);
      } else if (data.type === 'detail') {
        return _this.createDetail(data);
      } else {
        var _field = data.field == null ? _this.editComponents(data) : data.field;

        return _this.createFormItem(data, _field);
      }
    };

    _this.regexValid = function (value, regex) {
      if (!regex.test(value)) {
        value = value.substring(0, value.lastIndexOf(value[value.length - 1]));
        value = _this.regexValid(value, regex);
      }

      return value;
    };

    _this.editComponents = function (props) {
      var renderController = null; // 输入框

      if (props.type === 'input') {
        var valueProps = {};

        if (props.value || props.value === '') {
          valueProps.value = props.value;
        }

        renderController = React.createElement(Input, _extends({
          maxLength: props.maxLength || 50,
          autoComplete: 'off'
        }, valueProps, {
          defaultValue: props.defaultValue,
          placeholder: props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          className: props.className || 'view-style',
          disabled: props.disabled === true,
          style: props.style,
          onBlur: _this.onBlur.bind(_assertThisInitialized(_this), _this.props),
          onChange: function onChange(e) {
            if (props.onChange) {
              props.onChange(e.target.value);
            }
          },
          onClick: function onClick(e) {
            if (props.onClick) {
              props.onClick(e.target.value);
            }
          },
          suffix: props.suffix
        }));
      }

      if (props.type === 'popWin') {
        var _valueProps = {};

        if (props.value || props.value === '') {
          _valueProps.value = props.value;
        }

        renderController = React.createElement(Input, _extends({}, _valueProps, {
          defaultValue: props.defaultValue,
          placeholder: props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          className: props.className || 'view-style',
          readOnly: true,
          disabled: props.disabled,
          style: props.style,
          suffix: props.suffix ? React.createElement("div", null, React.createElement(Icon, {
            type: "close",
            onClick: props.clearData
          }), ' ', React.createElement(Icon, {
            type: "search",
            onClick: props.modalShow
          })) : React.createElement(Icon, {
            type: "search",
            onClick: props.modalShow
          })
        }));
      } // 输入框


      if (props.type === 'inputNumber') {
        var _valueProps2 = {};

        if (props.value || props.value === '') {
          _valueProps2.value = props.value;
        }

        renderController = // <Input
        // 	maxLength={props.maxLength || 50}
        // 	{...valueProps}
        // 	defaultValue={props.defaultValue}
        // 	placeholder={props.placeholder || Enum.DEFAULT_PLACEHOLDER}
        // 	className={styles['view-style']}
        // 	disabled={props.disabled === true}
        // 	style={props.style}
        // 	onBlur={e => {
        // 		var value = e.target.value;
        // 		e.target.value = this.regexValid(value, props.regex || /^\d*\.?\d{0,3}$/);
        // 	}}
        // 	onChange={e => {
        // 		var value = e.target.value;
        // 		e.target.value = this.regexValid(value, props.regex || /^\d*\.?\d{0,3}$/);
        // 	}}
        // />}
        React.createElement(InputNumber, {
          max: props.max,
          min: props.min,
          precision: props.precision,
          disabled: props.disabled === true,
          onChange: props.onChange,
          step: props.step || 1,
          formatter: props.formatter,
          parser: props.parser,
          placeholder: props.placeholder || Enum.DEFAULT_PLACEHOLDER
        });
      } // 多选框


      if (props.type === 'checkboxGroup') {
        var _valueProps3 = {};

        if (props.value || props.value === '') {
          _valueProps3.value = props.value;
        }

        renderController = React.createElement(CheckboxGroup, {
          options: props.options
        });
      } // 多行输入框


      if (props.type === 'textarea') {
        renderController = React.createElement(TextArea, {
          onBlur: function onBlur(e) {
            if (props.fileId) {
              var value = e.target.value;

              _this.props.form.setFieldsValue(_defineProperty({}, props.fileId, value.trim()));
            }
          },
          rows: props.rows === undefined ? 4 : props.rows,
          value: props.value,
          placeholder: props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          className: classnames('view-style', props.viewStyle),
          disabled: props.disabled === true,
          style: props.style,
          maxLength: props.maxLength || 255,
          onChange: function onChange(e) {
            if (props.onChange) {
              props.onChange(e.target.value);
            }
          }
        });
      } // 查询框


      if (props.type === 'search') {
        renderController = React.createElement(Search, {
          defaultValue: props.defaultValue,
          placeholder: props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          onSearch: props.onSearch,
          className: props.className || 'view-style',
          enterButton: true,
          onClick: props.onClick,
          readOnly: props.readOnly,
          disabled: props.disabled
        });
      } // 选择框
      // 如果props.filterOption有方法，表示是带输入过滤的选择框模式


      if (props.type === 'select') {
        var renderOption = (props.optionData || []).map(function (option) {
          return React.createElement(Option, {
            key: option.value,
            value: option.value
          }, option.text);
        }); // 输入搜索模式

        var showSearch = false;
        var optionFilterProp = 'children';

        if (props.filterOption) {
          showSearch = true;
        }

        renderController = React.createElement(Select, {
          disabled: props.disabled === true || props.disabled === 'true',
          showSearch: showSearch,
          optionFilterProp: optionFilterProp,
          value: props.value,
          defaultValue: props.defaultValue,
          onChange: props.onChange,
          filterOption: props.filterOption,
          style: props.style,
          className: props.className || 'view-style',
          placeholder: _this.props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          dropdownMatchSelectWidth: props.dropdownMatchSelectWidth === undefined ? true : props.dropdownMatchSelectWidth
        }, renderOption);
      } // 日期选择器


      if (props.type === 'dataPicker') {
        renderController = React.createElement(DatePicker, {
          className: props.className || 'view-style',
          defaultValue: props.defaultValue,
          format: props.format || 'YYYY/MM/DD',
          showTime: true,
          onChange: function onChange(moments, dateStrings) {
            if (props.onChange) {
              props.onChange(dateStrings, moments);
            }
          },
          value: props.value || ''
        });
      }

      if (props.type === 'dataFormatPicker') {
        renderController = React.createElement(DatePicker, {
          className: props.className || 'view-style',
          defaultValue: props.defaultValue,
          format: props.format || 'YYYY/MM/DD',
          onChange: function onChange(dateStrings) {
            if (props.onChange) {
              props.onChange(dateStrings);
            }
          },
          value: props.value || ''
        });
      }

      if (props.type === 'rangePicker') {
        renderController = React.createElement(RangePicker, {
          value: props.DateBegin ? [moment(props.DateBegin), moment(props.DateEnd)] : [],
          onChange: function onChange(moments, dateStrings) {
            if (props.onChange) {
              props.onChange(dateStrings[0], dateStrings[1], moments);
            }
          }
        });
      } // 勾选框


      if (props.type === 'checkbox') {
        renderController = React.createElement(Checkbox, {
          defaultChecked: props.defaultValue,
          onChange: props.onChange
        });
      } // 范围输入框


      if (props.type === 'range') {
        var onChange = props.onChange,
            minValue = props.minValue,
            maxValue = props.maxValue;
        renderController = React.createElement(RanderRange, {
          onChange: onChange,
          minValue: minValue,
          maxValue: maxValue
        });
      } // br换行


      if (props.type === 'br') {
        return React.createElement("br", null);
      } // 单选按钮


      if (props.type === 'radioGroup') {
        renderController = React.createElement(RadioGroupComponents, {
          codeType: props.codeType,
          onChange: props.onChange,
          disabled: props.disabled === true || props.disabled === 'true',
          value: props.value,
          defaultValue: props.defaultValue
        });
      } // 单选按钮


      if (props.type === 'radioGroupOld') {
        var renderRadio = (props.radioData || []).map(function (data) {
          return React.createElement(Radio, {
            key: data.value,
            value: data.value
          }, data.text);
        });
        renderController = React.createElement(RadioGroup, {
          onChange: function onChange(e) {
            if (props.onChange) {
              props.onChange(e.target.value);
            }
          },
          disabled: props.disabled,
          value: props.value,
          defaultValue: props.defaultValue
        }, renderRadio);
      }

      if (props.type === 'dataDictionary') {
        renderController = React.createElement(DataDictionaryComponents, {
          codeType: props.codeType,
          editable: true,
          allowClear: props.allowClear,
          placeholder: _this.props.placeholder || Enum.DEFAULT_SELECT_PLACEHOLDER,
          disabled: props.disabled === true || props.disabled === 'true',
          value: props.value,
          defaultValue: props.defaultValue,
          className: props.className || 'view-style',
          style: props.style,
          onChange: props.onChange,
          dropdownMatchSelectWidth: props.dropdownMatchSelectWidth === undefined ? true : props.dropdownMatchSelectWidth,
          mode: props.mode ? props.mode : ''
        });
      }

      if (props.type === 'cascader') {
        renderController = React.createElement(Cascader, {
          style: props.style || {
            width: '100%'
          },
          options: city,
          placeholder: props.placeholder,
          onChange: props.onChange
        });
      }

      if (props.type === 'a') {
        renderController = React.createElement("a", {
          type: props.type // disabled={props.disabled}
          ,
          style: props.style || {
            'margin-left': '30px'
          },
          onClick: props.onClick,
          onChange: props.onChange
        }, props.text);
      }

      return renderController;
    };

    _this.state = {
      dataDictionaryList: [],
      loading: false
    }; //formItem的布局样式

    _this.formItemLayout = {
      labelCol: {
        xs: {
          span: 24
        },
        sm: {
          span: 8
        }
      },
      wrapperCol: {
        xs: {
          span: 24
        },
        sm: {
          span: 14
        }
      }
    };
    return _this;
  }

  _createClass(FormComponents, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.getRefForm != null) {
        this.props.getRefForm(this.props.form);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var renderController = [];

      if (this.props.datas != null && this.props.datas.length > 0) {
        var hiddenCount = 0;
        var tempRender = [];

        for (var i = 0; i < this.props.datas.length; i++) {
          var data = this.props.datas[i];

          if (data.col === 0) {
            if ((i - hiddenCount) % 3 === 2 || i === this.props.datas.length - 1 && tempRender.length !== 0) {
              renderController.push(React.createElement(Row, null, tempRender));
              tempRender = [];
            }

            continue;
          }

          var formInfo = this.convertFormInfo(data);

          if (data.type === 'hidden') {
            renderController.push(formInfo);
            hiddenCount++;
            continue;
          }

          tempRender.push(React.createElement(Col, {
            span: data.col || 8
          }, formInfo));

          if ((i - hiddenCount) % 3 === 2 || i === this.props.datas.length - 1 && tempRender.length !== 0) {
            renderController.push(React.createElement(Row, null, tempRender));
            tempRender = [];
          }
        }
      }

      return React.createElement(Form, {
        onSubmit: this.props.handleSubmit,
        className: 'ant-form-components'
      }, renderController);
    }
  }, {
    key: "onBlur",
    value: function onBlur(props) {
      if (props.value === '') {
        this.props.form.setFields(_defineProperty({}, props.fileId, props.fieldOption));
      }
    }
  }]);

  return FormComponents;
}(React.Component);

export default Form.create({})(FormComponents);