function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
    if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  }
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};

import Debounce from 'lodash-decorators/debounce';
import * as React from 'react';
import { Link } from 'react-router-dom';
import Divider from '../divider';
import Dropdown from '../dropdown';
import Icon from '../icon'; // import JAlert from '../j-alert';

import JIcon from '../j-icon';
import Menu from '../menu';
import { intlFormat } from '../_util/utils';
import JModal from '../j-modal'; // tslint:disable-next-line:variable-name

var mail_users = require('./images/mail_users.png');

var GlobalHeader =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(GlobalHeader, _React$PureComponent);

  function GlobalHeader(props) {
    var _this;

    _classCallCheck(this, GlobalHeader);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(GlobalHeader).call(this, props));

    _this.toggle = function () {
      var _this$props = _this.props,
          collapsed = _this$props.collapsed,
          onCollapse = _this$props.onCollapse;
      onCollapse(!collapsed);

      _this.triggerResizeEvent();
    };

    _this.renderUserinfo = function () {
      var menu = React.createElement(Menu, {
        onClick: _this.onChangeZh
      }, React.createElement(Menu.Item, {
        key: "zh"
      }, "\u4E2D\u6587"), React.createElement(Menu.Item, {
        key: "en"
      }, "English"));
      var _this$props2 = _this.props,
          _this$props2$currentU = _this$props2.currentUser,
          currentUser = _this$props2$currentU === void 0 ? {} : _this$props2$currentU,
          msgCount = _this$props2.msgCount;
      var info = [];
      var url = './HeaderView/logo_pic.png';

      if (currentUser.userPic) {
        url = "../file/downLoadFile?pmCode=".concat(currentUser.userPic);
      }

      if (currentUser.url) {
        info.push(React.createElement("a", {
          key: "message",
          className: "ant-top-handle",
          href: currentUser.url.workplat + 'workplat/index.html#/workplat/message',
          style: {
            backgroundImage: "url(".concat(mail_users, ")")
          }
        }, msgCount > 0 ? React.createElement("i", {
          id: "msgc"
        }, msgCount) : ''));
      }

      if (currentUser.userName) {
        info.push(React.createElement("span", {
          key: "username",
          className: "username"
        }, currentUser.userName));
      }

      info.push(React.createElement("div", {
        key: "antd-header-logo-pic",
        className: "antd-header-logo-pic antd-header-logo-pic-ml"
      }, React.createElement("img", {
        src: url
      })));
      info.push(React.createElement(Dropdown, {
        key: "Dropdown",
        overlay: menu
      }, React.createElement("a", {
        className: "ant-dropdown-link  react-intl-lc"
      }, _this.props.locals === 'en' ? 'English' : '中文', " ", React.createElement(Icon, {
        type: "down"
      }))));
      info.push(React.createElement("div", {
        key: "logoutSub",
        onClick: function onClick() {
          // this.setState({ visible: true });
          JModal.confirm({
            title: intlFormat('jlt.jltd.reallyToLeave', '真的要离开吗？'),
            content: intlFormat('jlt.jltd.checkLeaveTitle', '离开就没有丰富的信息了哦'),
            okText: intlFormat('jlt.jltd.Confirm', '确定'),
            cancelText: intlFormat('jlt.jltd.Cancelled', '取消'),
            onOk: function onOk() {
              window.location.href = '../logout';
            }
          });
        },
        className: _this.props.locals ? 'antd-header-logo-pic' : ' '
      }, React.createElement(JIcon, {
        type: "exit",
        className: "antd-header-exit"
      })));
      return info;
    };

    _this.onChangeZh = function (_ref) {
      var key = _ref.key;

      _this.props.dispatch({
        type: 'global/setLocalStateCall',
        payload: key
      });
    };

    _this.state = {
      visible: false
    };
    return _this;
  }

  _createClass(GlobalHeader, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      // @ts-ignore
      this.triggerResizeEvent.cancel();
    }
    /* eslint-disable*/

  }, {
    key: "triggerResizeEvent",
    value: function triggerResizeEvent() {
      var event = document.createEvent('HTMLEvents');
      event.initEvent('resize', true, false);
      window.dispatchEvent(event);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          isMobile = _this$props3.isMobile,
          logo = _this$props3.logo,
          logopic = _this$props3.logopic;
      var _window = window,
          locals = _window.locals;
      var language = locals.language;
      return React.createElement("div", {
        className: 'ant-pro-global-header'
      }, isMobile && [React.createElement(Link, {
        to: "/",
        className: 'logo',
        key: "logo"
      }, language === 'zh' ? React.createElement("img", {
        src: logo,
        alt: "logo",
        width: "32"
      }) : React.createElement("img", {
        src: "http://cdn.e-jlt.com/logo-en.png",
        alt: "logo",
        width: "32"
      })), React.createElement(Divider, {
        type: "vertical",
        key: "line"
      })], React.createElement("div", {
        className: "logo"
      }, language === 'zh' ? React.createElement("img", {
        src: logopic ? logopic : './logo.png',
        alt: "logoimg",
        height: "40"
      }) : React.createElement("img", {
        src: "http://cdn.e-jlt.com/logo-en.png",
        alt: "logo",
        height: "40"
      })), React.createElement("div", {
        className: 'right ant-userinfo'
      }, this.renderUserinfo()));
    }
  }]);

  return GlobalHeader;
}(React.PureComponent);

export { GlobalHeader as default };

__decorate([Debounce(600)], GlobalHeader.prototype, "triggerResizeEvent", null);