import _regeneratorRuntime from "@babel/runtime/regenerator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : new P(function (resolve) {
        resolve(result.value);
      }).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

import * as React from 'react';
import PageHeaderLayout from '../page-header-layout';
import JButtonGroup from '../j-button-group';
import Upload from '../upload';
import Dropdown from '../dropdown';
import Button from '../button';
import Menu from '../menu';
import Icon from '../icon';
import Popconfirm from '../popconfirm';
import Table from '../table';
import JModal from '../j-modal';
import Input from '../input';
import JMessage from '../j-message';
import { getColumns, getTemplateInfo, getDataSource, getImportBatchNum, submitData, checkDatas, getProgress, editUpdate } from './services';
import JProgress from './j-progress';
import { intlFormat } from '../_util/utils';
/**
 *  ALL("00", "全部"),
 *  REPEAT_IMPORT("20", "重复导入"),
 *  EDITED("21", "已编辑"),
 *  DATA_REPEAT("22", "数据重复"),
 *  CHECK_FAIL("30","校验失败"),
 *  CHECK_SUCCESS("40", "校验成功"),
 *  SUBMIT_SUCCESS("50", "提交成功"),
 *  SUBMIT_FAIL("60", "提交失败");
 * */

/**
 *  WAIT_IMPORT("10", "等待导入"),
 * IMPORTING("20", "导入中"),
 * IMPORTED("30", "导入完成"),
 * IMPORT_FAIL("40", "导入失败（模板不一致）"),
 * CHECKING("50","校验中"),
 * CHECKED("60","校验完成"),
 * SUBMITING("70", "提交中"),
 * PART_SUBMIT("80", "部分提交"),
 * ALL_SUBMIT("90", "全部提交成功"),
 * SUBMIT_FAIL("100", "提交失败");
 * */

var ImportTemplate =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ImportTemplate, _React$Component);

  function ImportTemplate(props) {
    var _this;

    _classCallCheck(this, ImportTemplate);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ImportTemplate).call(this, props));

    _this.getStatus = function (successNum) {
      return successNum === undefined || successNum === '0' || successNum === 0;
    };

    _this.getBtnList = function () {
      return [{
        text: intlFormat('jlt.jltd.DataValidation', '数据校验'),
        onClick: _this.onCheckClick,
        disabled: _this.state.dataList.length === 0,
        style: {
          marginLeft: '10px'
        }
      }, {
        text: intlFormat('jlt.jltd.CommitAll', '全部提交'),
        onClick: function onClick() {
          var dataInfo = _this.state.dataInfo;

          if (dataInfo.failNum > 0 || dataInfo.repeatNum > 0) {
            JModal.info({
              title: intlFormat('jlt.jltd.IsSubmitAll', '是否全部提交'),
              content: intlFormat('jlt.jltd.ErrorMessageCannotSubmit', '校验错误的数据将不能提交'),
              cancelText: intlFormat('jlt.jltd.Cancelled', '取消'),
              okText: intlFormat('jlt.jltd.CommitAll', '全部提交'),
              onOk: _this.onSubmitClick
            });
          } else {
            _this.onSubmitClick();
          }
        },
        disabled: _this.state.submitDisabled || _this.state.isEdit
      }, {
        text: intlFormat('jlt.jltd.DownloadTemplate', '下载模板'),
        onClick: _this.downloadTemplate,
        disabled: _this.state.downloadDisable
      }];
    };

    _this.getTipView = function (status, batchNum, data) {
      var textInfo = '';

      switch (status) {
        case '10':
          textInfo = intlFormat('jlt.jltd.importTipInfo1', '当前导入批次号{batchNum}，请选择导入模板文件', {
            batchNum: batchNum
          });
          break;

        case '20':
          textInfo = intlFormat('jlt.jltd.importTipInfo1', '当前导入批次号{batchNum}，请选择导入模板文件', {
            batchNum: batchNum
          });
          break;

        case '30':
          textInfo = intlFormat('jlt.jltd.importTipInfo2', '当前导入批次号{batchNum}，获取文件原始记录数为{totalNum}', {
            batchNum: batchNum,
            totalNum: data.totalNum || 0
          });
          break;

        case '40':
          textInfo = intlFormat('jlt.jltd.importTipInfo1', '当前导入批次号{batchNum}，请选择导入模板文件', {
            batchNum: batchNum
          });
          break;

        case '80':
          textInfo = React.createElement("span", null, intlFormat('jlt.jltd.importTipInfo9', '数据成功提交'), React.createElement("span", {
            className: "warningText"
          }, data.successNum || 0), intlFormat('jlt.jltd.importTipInfo7', '条，重复记录'), React.createElement("span", {
            className: "warningText"
          }, data.repeatNum), intlFormat('jlt.jltd.importTipInfo10', '条，错误且不可导入'), React.createElement("span", {
            className: "warningText"
          }, data.failNum), intlFormat('jlt.jltd.importTipInfo11', '条，请重新编辑数据，如重新导入数据，则当前错误数据将被清空不可恢复。'));
          break;

        case '60':
          textInfo = React.createElement("span", null, intlFormat('jlt.jltd.importTipInfo4', '可导入记录'), React.createElement("span", {
            className: "warningText"
          }, data.successNum || 0), Number(data.repeatNum) !== 0 ? intlFormat('jlt.jltd.importTipInfo7', '条，重复记录') : null, Number(data.repeatNum) !== 0 ? React.createElement("span", {
            className: "warningText"
          }, data.repeatNum) : null, Number(data.failNum) !== 0 ? intlFormat('jlt.jltd.importTipInfo8', '条，错误且不可导入记录为') : null, Number(data.failNum) !== 0 ? React.createElement("span", {
            className: "warningText"
          }, data.failNum) : null, intlFormat('jlt.jltd.Tiao', '条'), React.createElement("span", null, ","), Number(data.failNum) !== 0 || Number(data.repeatNum) !== 0 ? intlFormat('jlt.jltd.importTipInfo5', '请重新导入模板或编辑错误数据后重新进行数据校验') : intlFormat('Please Submit Data', '请提交数据'));
          break;

        case '90':
          textInfo = intlFormat('jlt.jltd.importTipInfo3', '提交成功，可以重新选择文件导入');
          break;

        default:
          return;
      }

      return textInfo;
    }; // 初始化模板数据


    _this.initTemplate = function () {
      var intPage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee() {
        var _this2 = this;

        var _this$state, batchNum, templateId, stateModuleName, res, _res$data, importStatus, _res$data$moduleName, moduleName, successNum, type;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$state = this.state, batchNum = _this$state.batchNum, templateId = _this$state.templateId, stateModuleName = _this$state.moduleName;
                _context.next = 3;
                return getTemplateInfo({
                  batchNum: batchNum,
                  templateId: templateId
                });

              case 3:
                res = _context.sent;

                if (res.success) {
                  _context.next = 10;
                  break;
                }

                if (!(res.success === undefined)) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return");

              case 7:
                JModal.destroyAll();
                JModal.error({
                  title: intlFormat('jlt.jltd.initError', '初始化异常'),
                  content: intlFormat('jlt.jltd.templateError', '模板ID或批次号异常,请重新操作'),
                  okCancel: false,
                  okText: intlFormat('jlt.jltd.Return', '返回'),
                  onOk: function onOk() {
                    _this2.props.history.goBack();
                  }
                });
                return _context.abrupt("return");

              case 10:
                _res$data = res.data, importStatus = _res$data.importStatus, _res$data$moduleName = _res$data.moduleName, moduleName = _res$data$moduleName === void 0 ? stateModuleName : _res$data$moduleName, successNum = _res$data.successNum;
                this.setState({
                  percent: 0,
                  importStatus: importStatus,
                  promptInfo: this.getTipView(importStatus, batchNum, res.data),
                  dataInfo: res.data || {},
                  moduleName: "".concat(moduleName.replace(/导入$/g, '')).concat(intlFormat('jlt.jltd.importResultList', '导入结果列表')),
                  submitDisabled: this.getStatus(importStatus === '90' || importStatus === '80' ? 0 : successNum)
                });
                type = '';

                if (importStatus === '20') {
                  type = 'import';
                } else if (importStatus === '50') {
                  type = 'check';
                } else if (importStatus === '70') {
                  type = 'submit';
                }

                if (type) {
                  this.setState({
                    visible: true,
                    percent: 0
                  });
                  this.getProgress(batchNum, templateId, type);
                } // let { success } = await checkRepeatImport({ batchNum: batchNum, templateId });
                // if (!success) return


                this.initColumns();

                if (intPage) {
                  this.setState({
                    pageNumber: 1,
                    showStatus: '00'
                  }, this.getDataSource);
                } else {
                  this.getDataSource();
                }

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    }; // 初始化导入模板


    _this.initColumns = function () {
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee2() {
        var _this3 = this;

        var _this$state2, templateId, columnsData, _ref, success, _ref$data, data, columns;

        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _this$state2 = this.state, templateId = _this$state2.templateId, columnsData = _this$state2.columnsData;

                if (!(columnsData.length > 3)) {
                  _context2.next = 3;
                  break;
                }

                return _context2.abrupt("return");

              case 3:
                _context2.next = 5;
                return getColumns({
                  templateId: templateId
                });

              case 5:
                _ref = _context2.sent;
                success = _ref.success;
                _ref$data = _ref.data;
                data = _ref$data === void 0 ? [] : _ref$data;

                if (success) {
                  _context2.next = 11;
                  break;
                }

                return _context2.abrupt("return");

              case 11:
                columns = data.map(function (item) {
                  return {
                    dataIndex: item.porpertyName,
                    width: item.columnName.length > 8 ? item.columnName.length * 20 : 160,
                    title: item.columnName,
                    render: function render(text, record) {
                      return record.editable ? React.createElement(Input, {
                        placeholder: intlFormat('jlt.jltd.PleaseEnter', '请输入'),
                        value: text,
                        onChange: function onChange(e) {
                          record[item.porpertyName] = e.target.value;

                          _this3.setState({
                            dataList: _this3.state.dataList
                          });
                        }
                      }) : React.createElement("div", {
                        className: _this3.errorClass(record)
                      }, text);
                    }
                  };
                });
                this.createColumns(columns);

              case 13:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));
    }; // 下载模板


    _this.downloadTemplate = function (e) {
      if (e && e.triggerCancel) {
        return;
      }

      if (typeof e === 'function') {
        e();
      }

      var templateId = _this.state.templateId;
      var downloadIframe = document.getElementById('download-iframe');

      if (downloadIframe != null) {
        downloadIframe.remove();
      }

      var iframe = document.createElement('iframe');
      iframe = document.createElement('iframe');
      iframe.id = 'download-iframe';
      iframe.style.display = 'none';
      iframe.style.visibility = 'hidden';
      iframe.style.height = '0px';
      iframe.src = "../import/".concat(templateId, "/template");
      document.body.appendChild(iframe);
    };

    _this.createColumns = function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var columns = _toConsumableArray(_this.defaultColumns);

      columns.splice.apply(columns, [2, 0].concat(_toConsumableArray(data)));

      if (data.length) {
        columns[1].width = 200;
        columns[columns.length - 2].width = 'auto';
      } else {
        columns[1].width = 'auto';
      }

      _this.setState({
        columnsData: columns
      });
    };

    _this.startImport = function () {
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee3() {
        var _this4 = this;

        var templateId, res, data, message, success, code, _batchNum, exist;

        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                templateId = this.state.templateId;
                _context3.next = 3;
                return getImportBatchNum({
                  override: false,
                  templateId: templateId
                });

              case 3:
                res = _context3.sent;
                data = res.data, message = res.message, success = res.success, code = res.code;

                if (!success) {
                  _context3.next = 12;
                  break;
                }

                _batchNum = data.batchNum, exist = data.exist;

                if (!exist) {
                  _context3.next = 10;
                  break;
                }

                JModal.confirm({
                  title: intlFormat('jlt.jltd.templateImport', '模板导入'),
                  content: intlFormat('jlt.jltd.hasImportContent', '存在正在导入的信息，是否继续上次导入操作'),
                  okText: intlFormat('jlt.jltd.continueImport', '继续导入'),
                  cancelText: intlFormat('jlt.jltd.reImport', '重新导入'),
                  onOk: function onOk() {
                    _this4.setState({
                      batchNum: _batchNum
                    }, _this4.initTemplate);
                  },
                  onCancel: function onCancel() {
                    getImportBatchNum({
                      override: true,
                      templateId: templateId
                    }).then(function (res1) {
                      _this4.setState({
                        batchNum: res1.data.batchNum
                      }, _this4.initTemplate);
                    });
                  }
                });
                return _context3.abrupt("return");

              case 10:
                this.setState({
                  batchNum: _batchNum
                }, this.initTemplate);
                return _context3.abrupt("return");

              case 12:
                if (code === 3002) {
                  JModal.error({
                    title: message,
                    content: intlFormat('jlt.jltd.templateNoFountContent', '导入模板不存在，请联系管理员修改'),
                    okCancel: false,
                    okText: intlFormat('jlt.jltd.Confirm', '确定')
                  });
                }

              case 13:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));
    }; // 编辑保存


    _this.save = function (record, index) {
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee4() {
        var _this$state3, dataList, columnsData, result, _ref2, success, data;

        return _regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _this$state3 = this.state, dataList = _this$state3.dataList, columnsData = _this$state3.columnsData;
                result = columnsData.find(function (item) {
                  return record[item.dataIndex] !== record.editTemp[item.dataIndex];
                });
                delete record.editTemp;
                delete record.editable;

                if (result) {
                  _context4.next = 8;
                  break;
                }

                dataList[index] = record;
                this.setState({
                  dataList: dataList
                });
                return _context4.abrupt("return");

              case 8:
                this.setState({
                  loading: true
                });
                _context4.next = 11;
                return editUpdate(record);

              case 11:
                _ref2 = _context4.sent;
                success = _ref2.success;
                data = _ref2.data;

                if (success) {
                  _context4.next = 17;
                  break;
                }

                this.setState({
                  loading: false
                });
                return _context4.abrupt("return");

              case 17:
                record.errorMessage = data.errorMessage;
                record.status = data.status;
                dataList[index] = record;
                this.setState({
                  dataList: dataList,
                  loading: false,
                  isEdit: true,
                  promptInfo: intlFormat('jlt.jltd.dataChange', '当前数据已修改，请重新校验')
                });

              case 21:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));
    }; // 编辑取消


    _this.cancel = function (record, index) {
      var dataList = _this.state.dataList;
      dataList[index] = record.editTemp;
      dataList[index].editable = false;

      _this.setState({
        dataList: dataList
      });
    }; // 开始编辑


    _this.edit = function (record, index) {
      var dataList = _this.state.dataList;
      dataList[index].editable = true;
      dataList[index].editTemp = _extends({}, record);

      _this.setState({
        dataList: dataList
      });
    }; // 校验点击


    _this.onCheckClick = function () {
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee5() {
        var _this$state4, batchNum, templateId, _ref3, success;

        return _regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _this$state4 = this.state, batchNum = _this$state4.batchNum, templateId = _this$state4.templateId;
                this.setState({
                  visible: true
                });
                _context5.next = 4;
                return checkDatas({
                  batchNum: batchNum,
                  templateId: templateId
                });

              case 4:
                _ref3 = _context5.sent;
                success = _ref3.success;

                if (success) {
                  _context5.next = 9;
                  break;
                }

                this.setState({
                  visible: true
                });
                return _context5.abrupt("return");

              case 9:
                this.setState({
                  isEdit: false
                });
                this.getProgress(batchNum, templateId, 'check');

              case 11:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));
    }; // 提交点击


    _this.onSubmitClick = function () {
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee6() {
        var _this$state5, batchNum, templateId, _ref4, success;

        return _regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _this$state5 = this.state, batchNum = _this$state5.batchNum, templateId = _this$state5.templateId;
                this.setState({
                  visible: true
                });
                _context6.next = 4;
                return submitData({
                  batchNum: batchNum,
                  templateId: templateId
                });

              case 4:
                _ref4 = _context6.sent;
                success = _ref4.success;

                if (success) {
                  _context6.next = 9;
                  break;
                }

                this.setState({
                  visible: false
                });
                return _context6.abrupt("return");

              case 9:
                this.getProgress(batchNum, templateId, 'submit');
                this.setState({
                  pageNumber: 1,
                  showStatus: '00'
                });

              case 11:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));
    }; // 筛选切换


    _this.onDisplayClick = function (_ref5) {
      var key = _ref5.key;

      _this.setState({
        pageNumber: 1,
        pageSize: 10,
        showStatus: key
      }, _this.getDataSource);
    }; // 渲染下拉菜单


    _this.renderMenu = function () {
      var importStatus = _this.state.importStatus;
      return React.createElement(Menu, {
        onClick: _this.onDisplayClick
      }, React.createElement(Menu.Item, {
        key: "00"
      }, intlFormat('jlt.jltd.showAllRecord', '显示全部记录')), React.createElement(Menu.Item, {
        disabled: importStatus !== '60',
        key: "30"
      }, intlFormat('jlt.jltd.showCheckErrorRecord', '显示校验失败记录')), React.createElement(Menu.Item, {
        disabled: importStatus !== '60',
        key: "40"
      }, intlFormat('jlt.jltd.showCheckRightRecord', '显示校验正确记录')), React.createElement(Menu.Item, {
        disabled: importStatus !== '60',
        key: "20"
      }, intlFormat('jlt.jltd.showRepeatImportRecord', '显示重复导入记录')), React.createElement(Menu.Item, {
        disabled: importStatus !== '60',
        key: "22"
      }, intlFormat('jlt.jltd.showRepeatDataRecord', '显示数据重复记录')), React.createElement(Menu.Item, {
        disabled: importStatus !== '80',
        key: "60"
      }, intlFormat('jlt.jltd.showSubmitErrorRecord', '显示提交失败记录')));
    }; // 导入文件前拦截判断


    _this.beforeUpload = function (file) {
      var type = '';

      if (!file.type) {
        var list = file.name.split('.');
        type = list[list.length - 1];
      }

      var isExcel = file.type === 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' || file.type === 'application/vnd.ms-excel';

      if (!file.type) {
        isExcel = type === 'xls' || type === 'xlsx';
      }

      if (!isExcel) {
        JMessage.error(intlFormat('jlt.jltd.pleaseChooseRightTypeFile', '请上传xls、xlsx文件'));
        return false;
      }

      return true;
    }; // 获取导入数据


    _this.getDataSource = function () {
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee7() {
        var _this$state6, batchNum, pageNumber, pageSize, showStatus, templateId, _ref6, success, data;

        return _regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _this$state6 = this.state, batchNum = _this$state6.batchNum, pageNumber = _this$state6.pageNumber, pageSize = _this$state6.pageSize, showStatus = _this$state6.showStatus, templateId = _this$state6.templateId;
                this.setState({
                  loading: true
                });
                _context7.next = 4;
                return getDataSource({
                  batchNum: batchNum,
                  pageNumber: pageNumber,
                  pageSize: pageSize,
                  showStatus: showStatus,
                  templateId: templateId
                });

              case 4:
                _ref6 = _context7.sent;
                success = _ref6.success;
                data = _ref6.data;

                if (success) {
                  _context7.next = 10;
                  break;
                }

                this.setState({
                  loading: false
                });
                return _context7.abrupt("return");

              case 10:
                this.setState({
                  loading: false,
                  dataList: data.data || [],
                  total: data.rowsCount
                });

              case 11:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));
    }; // 获取进度


    _this.getProgress = function (batchNum, templateId) {
      var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'import';
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee8() {
        var _this5 = this;

        var _ref7, success, data, currentNum, currentTotalNum, importStatus, allNum, percent;

        return _regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return getProgress({
                  batchNum: batchNum,
                  templateId: templateId
                });

              case 2:
                _ref7 = _context8.sent;
                success = _ref7.success;
                data = _ref7.data;

                if (success) {
                  _context8.next = 8;
                  break;
                }

                this.setState({
                  visible: false
                });
                return _context8.abrupt("return");

              case 8:
                currentNum = data.currentNum, currentTotalNum = data.currentTotalNum, importStatus = data.importStatus, allNum = data.allNum;

                if (this.state.fileAllNum !== allNum) {
                  this.setState({
                    fileAllNum: allNum
                  });
                }

                if (type === 'import' && (importStatus === '10' || importStatus === '20' || importStatus === '50') || type === 'check' && importStatus === '50' || type === 'submit' && importStatus === '70') {
                  percent = Math.floor(currentNum / currentTotalNum * 100);
                  !isNaN(percent) && this.setState({
                    percent: percent
                  });
                  this.timer = setTimeout(function () {
                    _this5.getProgress(batchNum, templateId, type);
                  }, 500);
                } else {
                  // if(type == 'import') this.onCheckClick()
                  this.setState({
                    percent: 100,
                    visible: false
                  });
                  setTimeout(function () {
                    var text = '';
                    var errtext = '';

                    if (type === 'import' && importStatus === '30') {
                      text = intlFormat('jlt.jltd.dataImportSuccess', '数据导入成功');
                    } else if (type === 'import' && importStatus === '60') {
                      text = intlFormat('jlt.jltd.dataImportAndCheckSuccess', '数据导入且校验成功');
                    } else if (type === 'check' && importStatus === '60') {
                      text = intlFormat('jlt.jltd.dataCheckSuccess', '数据校验成功');
                    } else if (type === 'submit' && importStatus === '80') {
                      text = intlFormat('jlt.jltd.dataSectionSubmitSuccess', '数据部分提交成功');
                    } else if (type === 'submit' && importStatus === '90') {
                      text = intlFormat('jlt.jltd.dataAllSubmitSuccess', '数据全部提交成功');
                    } else if (type === 'import' && importStatus === '40') {
                      errtext = intlFormat('jlt.jltd.dataImportError', '数据导入失败');
                    } else if (type === 'submit' && importStatus === '100') {
                      errtext = intlFormat('jlt.jltd.dataSubmitError', '数据提交失败');
                    }

                    text && JMessage.success(text);
                    errtext && JMessage.error(errtext);
                  }, 1000);
                }

              case 11:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));
    }; // 渲染导入按钮


    _this.renderUploadView = function () {
      var btnProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var text = arguments.length > 1 ? arguments[1] : undefined;
      var style = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var _this$state7 = _this.state,
          templateId = _this$state7.templateId,
          batchNum = _this$state7.batchNum,
          importDisabled = _this$state7.importDisabled;
      var options = {
        name: 'file',
        action: '../import/importTemplate',
        headers: {
          authorization: 'authorization-text'
        },
        data: {
          templateId: templateId,
          batchNum: batchNum
        },
        showUploadList: false,
        beforeUpload: _this.beforeUpload,
        disabled: importDisabled,
        onChange: function onChange(info) {
          if (info.file.status === 'uploading') {
            _this.setState({
              visible: true,
              percent: 0
            });

            JModal.destroyAll();
          } else if (info.file.status === 'done') {
            var result = info.file.response;

            if (result.success) {
              _this.getProgress(batchNum, templateId, 'import');

              return;
            }

            _this.setState({
              visible: false
            });

            if (result.code === 3015 || result.code === 3016 || result.code === 3017 || result.code === 3008 || result.code === 3018 || result.code === 3019) {
              _this.errorImport(result.message);
            } else if (result.code === 3001 || result.code === 3002 || result.code === 3003 || result.code === 3006 || result.code === 3020) {
              JModal.error({
                title: intlFormat('jlt.jltd.importantError', '导入失败'),
                content: result.message,
                okCancel: false,
                okText: intlFormat('jlt.jltd.Confirm', '确定')
              });
            }
          } else if (info.file.status === 'error') {
            _this.setState({
              visible: false
            });

            _this.errorImport();
          }
        }
      };
      return React.createElement(Upload, _extends({}, options, {
        className: "upload-btn",
        style: style
      }), React.createElement(Button, _extends({
        disabled: importDisabled,
        type: "default"
      }, btnProps), text ? text : intlFormat('jlt.jltd.importTemplate', '导入模板')));
    }; // 导入失败弹窗


    _this.errorImport = function (conetnt) {
      JModal.error({
        title: intlFormat('jlt.jltd.importantError', '导入失败'),
        content: conetnt || intlFormat('jlt.jltd.reImportAndNoData', '请重新导入，当前无可导入数据'),
        cancelText: intlFormat('jlt.jltd.DownloadTemplate', '下载模板'),
        onCancel: _this.downloadTemplate,
        rightBtn: _this.renderUploadView({
          type: 'primary'
        }, intlFormat('jlt.jltd.reImport', '重新导入'), {
          marginLeft: 40
        })
      });
    }; // 渲染按钮组


    _this.renderBtnView = function () {
      return React.createElement("div", {
        className: "j-btn-view"
      }, _this.renderUploadView({
        type: 'default'
      }), React.createElement(JButtonGroup, {
        data: _this.getBtnList(),
        isLocalData: true
      }), React.createElement(Dropdown, {
        overlay: _this.renderMenu(),
        placement: "bottomCenter"
      }, React.createElement(Button, {
        className: "menu-btn",
        type: "default"
      }, intlFormat('jlt.mdm.button.Filter', '列表过滤'), React.createElement(Icon, {
        type: "down"
      }))));
    }; // 判断是否错误信息获取错误样式类


    _this.errorClass = function (item) {
      return item.status === '20' || item.status === '22' || item.status === '30' || item.status === '60' ? 'error-info' : '';
    }; // 渲染table


    _this.renderTable = function () {
      var _this$state8 = _this.state,
          columnsData = _this$state8.columnsData,
          dataList = _this$state8.dataList,
          pageNumber = _this$state8.pageNumber,
          pageSize = _this$state8.pageSize,
          total = _this$state8.total,
          loading = _this$state8.loading; // tslint:disable-next-line:no-bitwise

      var scrollWidth = columnsData.reduce( // tslint:disable-next-line:no-bitwise
      function (total1, item) {
        return total1 + ~~item.width || 300;
      }, 300);
      return React.createElement(Table, {
        loading: loading,
        rowKey: "execlNum",
        dataSource: [].concat(dataList),
        columns: columnsData,
        scroll: {
          x: scrollWidth
        },
        pagination: {
          pageSize: pageSize,
          current: pageNumber,
          total: total,
          showTotal: function showTotal(total1) {
            return React.createElement("span", null, intlFormat('jlt.jltd.Gong', '共'), React.createElement("span", {
              style: {
                margin: '0 10px'
              }
            }, total1), intlFormat('jlt.jltd.Tiao', '条'));
          },
          showQuickJumper: true,
          showSizeChanger: true,
          onShowSizeChange: function onShowSizeChange(_page, pageSize1) {
            _this.setState({
              pageNumber: 1,
              pageSize: pageSize1
            }, _this.getDataSource);
          },
          onChange: function onChange(page, pageSize1) {
            _this.setState({
              pageNumber: page,
              pageSize: pageSize1
            }, _this.getDataSource);
          }
        }
      });
    };

    _this.renderInfoView = function () {
      var promptInfo = _this.state.promptInfo;
      return React.createElement("div", {
        className: "info-view tipIcon"
      }, promptInfo);
    };

    var batchNum = window.location.hash.match(/batchNum=(\w+)&?/);
    var templateId = window.location.hash.match(/templateId=(\w+)&?/);
    var importBatchNum = window.location.hash.match(/importBatchNum=(\w+)&?/);
    _this.state = {
      dataList: [],
      columnsData: [],
      checkDisabled: false,
      submitDisabled: true,
      downloadDisable: false,
      batchNum: importBatchNum ? importBatchNum[1] : batchNum && batchNum[1],
      templateId: templateId && templateId[1],
      moduleName: '模板导入列表',
      promptInfo: '',
      pageNumber: 1,
      pageSize: 10,
      showStatus: '00',
      total: 0,
      visible: false,
      percent: 0,
      loading: false,
      isEdit: false,
      fileAllNum: 0,
      importStatus: '',
      dataInfo: {}
    };
    _this.defaultColumns = [{
      title: intlFormat('jlt.jltd.lineNo', '行号'),
      dataIndex: 'execlNum',
      fixed: 'left',
      width: 80,
      render: function render(text, record) {
        return React.createElement("div", {
          className: _this.errorClass(record)
        }, text);
      }
    }, {
      title: intlFormat('jlt.jltd.ReasonOfError', '错误原因'),
      dataIndex: 'errorMessage',
      fixed: 'left',
      width: 80,
      render: function render(text, record) {
        var msg = text && text !== 'null' ? text.replace(/;/g, ';<br >') : '';
        return React.createElement("div", {
          className: _this.errorClass(record),
          dangerouslySetInnerHTML: {
            __html: msg
          }
        });
      }
    }, {
      title: intlFormat('jlt.jltd.Operate', '操作'),
      dataIndex: 'emptyValue',
      width: 160,
      fixed: 'right',
      render: function render(_value, record, index) {
        var editable = record.editable;
        return editable ? React.createElement("span", {
          style: {
            fontSize: '14px',
            display: 'block'
          }
        }, React.createElement("a", {
          onClick: function onClick() {
            return _this.save(record, index);
          }
        }, intlFormat('jlt.jltd.Confirm', '确定')), React.createElement(Popconfirm, {
          title: intlFormat('jlt.jltd.confirmCancelEdit', '确定取消编辑?'),
          onConfirm: function onConfirm() {
            return _this.cancel(record, index);
          }
        }, React.createElement("a", {
          style: {
            marginLeft: '10px'
          }
        }, intlFormat('jlt.jltd.Cancelled', '取消')))) : React.createElement("a", {
          onClick: function onClick() {
            return _this.edit(record, index);
          }
        }, React.createElement(Icon, {
          type: "edit",
          className: "inline-operate-icon"
        }));
      }
    }];
    return _this;
  }

  _createClass(ImportTemplate, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this6 = this;

      this.initTemplate();
      document.addEventListener('visibilitychange', function () {
        if (document.visibilityState !== 'hidden') {
          if (window.location.hash.indexOf('test') >= 0) {
            _this6.initTemplate(false);
          } else {
            document.addEventListener('visibilitychange', function () {});
          }
        }
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.addEventListener('visibilitychange', function () {});
      clearTimeout(this.timer);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state9 = this.state,
          moduleName = _this$state9.moduleName,
          visible = _this$state9.visible,
          percent = _this$state9.percent,
          fileAllNum = _this$state9.fileAllNum;
      return React.createElement(PageHeaderLayout, {
        title: moduleName,
        wrapperClassName: "j-import-page",
        showBackBtn: true
      }, this.renderBtnView(), this.renderInfoView(), this.renderTable(), React.createElement(JProgress, {
        visible: visible,
        percent: percent,
        awitTime: fileAllNum,
        onHide: this.initTemplate
      }));
    }
  }]);

  return ImportTemplate;
}(React.Component);

export default ImportTemplate;