function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
    if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  }
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};

import classNames from 'classnames';
import { connect } from 'dva';
import { Redirect, Route, routerRedux, Switch } from 'dva/router'; // @ts-ignore

import { enquireScreen, unenquireScreen } from 'enquire-js'; // @ts-ignore

import { TinyButton as ScrollUpButton } from 'matt-react-scrollup';
import PropTypes from 'prop-types'; // @ts-ignore

import React from 'react';
import { ContainerQuery } from 'react-container-query'; // @ts-ignore

import { injectIntl } from 'react-intl'; // @ts-ignore

import NotFound from '../exception/404'; // @ts-ignore

import GlobalHeader from '../global-header';
import JIntl from '../j-util/jlt-intl';
import Layout from '../layout';
import message from '../message';
import numberUtils from '../number-utils';
import SiderMenu from '../sider-menu';
import validator from '../validator';
import { getRoutes } from '../_util/utils';
var setCurrency = validator.setCurrency,
    setCountry = validator.setCountry,
    localGet = validator.localGet;

var uuidCompact = function uuidCompact() {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    // tslint:disable-next-line:no-bitwise
    var r = Math.random() * 16 | 0; // tslint:disable-next-line:no-bitwise

    var v = c === 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
};

var Content = Layout.Content,
    Header = Layout.Header;
/**
 * 根据菜单取得重定向地址.
 */

var redirectData = [];

var getRedirect = function getRedirect(item) {
  if (item && item.children) {
    if (item.children[0] && item.children[0].path) {
      redirectData.push({
        from: "".concat(item.path),
        to: "".concat(item.children[0].path)
      });
      item.children.forEach(function (children) {
        getRedirect(children);
      });
    }
  }
};
/**
 * 获取面包屑映射
 * @param {Object} menuData 菜单配置
 * @param {Object} routerData 路由配置
 */


var getBreadcrumbNameMap = function getBreadcrumbNameMap(menuData, routerData) {
  var result = {};
  var childResult = {};
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = menuData[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var i = _step.value;

      if (!routerData[i.path]) {
        result[i.path] = i;
      }

      if (i.children) {
        _extends(childResult, getBreadcrumbNameMap(i.children, routerData));
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return _extends({}, routerData, result, childResult);
};

var query = {
  'screen-xs': {
    maxWidth: 575
  },
  'screen-sm': {
    minWidth: 576,
    maxWidth: 767
  },
  'screen-md': {
    minWidth: 768,
    maxWidth: 991
  },
  'screen-lg': {
    minWidth: 992,
    maxWidth: 1199
  },
  'screen-xl': {
    minWidth: 1200,
    maxWidth: 1599
  },
  'screen-xxl': {
    minWidth: 1600
  }
};
var isMobile;
enquireScreen(function (b) {
  isMobile = b;
});

var BasicLayout =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(BasicLayout, _React$PureComponent);

  function BasicLayout(props) {
    var _this;

    _classCallCheck(this, BasicLayout);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BasicLayout).call(this, props));
    _this.state = {
      isMobile: isMobile
    };

    _this.getPageTitle = function () {
      /*     const { routerData, location } = this.props;
      const { pathname } = location; */
      var _document = document,
          title = _document.title;
      return title;
      /* let currRouterData = null;
      // match params path
      Object.keys(routerData).forEach(key => {
        if (pathToRegexp(key).test(pathname)) {
          currRouterData = routerData[key];
        }
      });
      if (currRouterData && currRouterData.name) {
        title = `${currRouterData.name} - 晶链通供应链云平台`;
      }
      return title; */
    };

    _this.getBaseRedirect = function () {
      // According to the url parameter to redirect
      // 这里是重定向的,重定向到 url 的 redirect 参数所示地址
      var urlParams = new URL(window.location.href);
      var Authorized = _this.props.Authorized;
      var check = Authorized.check;
      var redirect = urlParams.searchParams.get('redirect'); // Remove the parameters in the url

      if (redirect) {
        urlParams.searchParams["delete"]('redirect');
        window.history.replaceState(null, 'redirect', urlParams.href);
      } else {
        var routerData = _this.props.routerData; // get the first authorized route path in routerData

        var authorizedPath = Object.keys(routerData).find(function (item) {
          return check(routerData[item].authority, item) && item !== '/';
        });
        return authorizedPath;
      }

      return redirect;
    };

    _this.handleMenuCollapse = function (collapsed) {
      var dispatch = _this.props.dispatch;
      dispatch({
        type: 'global/changeLayoutCollapsed',
        payload: collapsed
      });
    };

    _this.handleNoticeClear = function (type) {
      message.success("\u6E05\u7A7A\u4E86".concat(type));
      var dispatch = _this.props.dispatch;
      dispatch({
        type: 'global/clearNotices',
        payload: type
      });
    };

    _this.handleMenuClick = function (_ref) {
      var key = _ref.key;
      var dispatch = _this.props.dispatch;

      if (key === 'triggerError') {
        dispatch(routerRedux.push('/exception/trigger'));
        return;
      }

      if (key === 'logout') {
        dispatch({
          type: 'login/logout'
        });
      }
    };

    _this.handleNoticeVisibleChange = function (visible) {
      var dispatch = _this.props.dispatch;

      if (visible) {
        dispatch({
          type: 'global/fetchNotices'
        });
      }
    };

    props.getMenuData().forEach(getRedirect);
    return _this;
  }

  _createClass(BasicLayout, [{
    key: "getChildContext",
    value: function getChildContext() {
      var _this$props = this.props,
          location = _this$props.location,
          routerData = _this$props.routerData,
          menudata = _this$props.menudata,
          config = _this$props.config,
          getMenuData = _this$props.getMenuData;
      var mneudatas = menudata;

      if (config.readLocalMenu) {
        mneudatas = getMenuData();
      }

      return {
        location: location,
        breadcrumbNameMap: getBreadcrumbNameMap(mneudatas, routerData)
      };
    } // eslint-disable-next-line react/sort-comp,camelcase

  }, {
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      var _this2 = this;

      window.intlFormat = function (id, defaultMessage) {
        var data = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        // tslint:disable-next-line:curly
        var newData = data || {};
        var tempDefaultMessage = defaultMessage;

        if (data && Object.keys(newData).length > 0) {
          Object.keys(newData).map(function (key) {
            tempDefaultMessage = tempDefaultMessage.replace("{".concat(key, "}"), newData[key]);
          });
        }

        if (!id) return tempDefaultMessage || defaultMessage;

        if (window.locals && window.locals.language === 'zh' && window.locals.data && window.locals.data[id] && window.locals.data[id] !== defaultMessage) {
          JIntl.addLanguage({
            i18nKey: id,
            name: defaultMessage
          });
        }

        return _this2.props.intl.formatMessage({
          id: id || 'jlt.tenant',
          defaultMessage: defaultMessage
        }, data);
      };
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this3 = this;

      this.enquireHandler = enquireScreen(function (mobile) {
        // @ts-ignore
        _this3.setState({
          isMobile: mobile
        });
      });
      var dispatch = this.props.dispatch;
      dispatch({
        type: 'user/fetchCurrent'
      });
      dispatch({
        type: 'rest/msgInfo'
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      unenquireScreen(this.enquireHandler);
    }
  }, {
    key: "enquireHandler",
    value: function enquireHandler(_enquireHandler) {
      throw new Error('Method not implemented.');
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          currentUser = _this$props2.currentUser,
          collapsed = _this$props2.collapsed,
          notices = _this$props2.notices,
          routerData = _this$props2.routerData,
          match = _this$props2.match,
          location = _this$props2.location,
          menudata = _this$props2.menudata,
          locals = _this$props2.locals,
          msgInfo = _this$props2.msgInfo,
          config = _this$props2.config,
          getMenuData = _this$props2.getMenuData,
          logo = _this$props2.logo,
          Authorized = _this$props2.Authorized,
          urlConfig = _this$props2.urlConfig;

      if (currentUser && currentUser.roundingScale) {
        var scale = currentUser.roundingScale;
        numberUtils.QUANTITY_SCALE = scale.quantityScale;
        numberUtils.WEIGHT_SCALE = scale.weightScale;
        numberUtils.SIZE_SCALE = scale.sizeScale;
        numberUtils.VOLUME_SCALE = scale.volumeScale;
        numberUtils.SKU_PRICE_SCALE = scale.skuPriceScale;
        numberUtils.AMOUNT_SCALE = scale.amountScale;
        numberUtils.ROUNDING_MODE = scale.roundingMode; // @ts-ignore

        window.ROUNDING_MODE = scale.roundingMode;
      }

      var AuthorizedRoute = Authorized.AuthorizedRoute;
      var mb = this.state.isMobile;
      var baseRedirect = this.getBaseRedirect();
      var mneudatas = menudata;

      if (config.readLocalMenu) {
        mneudatas = getMenuData();
      }

      if (this.props.location.pathname === '/') {
        if (urlConfig) {
          if (['8000', '8001'].indexOf("".concat(document.location.port)) === -1) {
            baseRedirect = "".concat(urlConfig.workplat, "workplat/index.html?uuid=").concat(uuidCompact(), "#/workplat/home");
            window.location.href = baseRedirect;
            return;
          }
        } else if (['8000', '8001'].indexOf("".concat(document.location.port)) === -1) {
          baseRedirect = '/';
        }
      }

      var layout = React.createElement(Layout, {
        className: locals === 'zh' ? 'jltd-table-header-capitalize-zh' : 'jltd-table-header-capitalize-en',
        style: {
          flexDirection: 'column'
        }
      }, React.createElement(Header, {
        style: {
          padding: 0
        }
      }, React.createElement(GlobalHeader, {
        logo: logo,
        logopic: currentUser && currentUser.logoPic ? "../file/downLoadFile?pmCode=".concat(currentUser.logoPic) : null,
        currentUser: currentUser,
        notices: notices,
        collapsed: collapsed,
        isMobile: mb,
        msgCount: msgInfo && msgInfo.msgCount ? msgInfo.msgCount : null // onCollapse={this.handleMenuCollapse}
        ,
        onMenuClick: this.handleMenuClick,
        locals: locals,
        dispatch: this.props.dispatch
      })), React.createElement(Layout, {
        className: "jbasiclayout",
        style: {
          flexDirection: 'row'
        }
      }, React.createElement(SiderMenu, {
        collapsible: true,
        logo: logo // 不带Authorized参数的情况下如果没有权限,会强制跳到403界面
        // If you do not have the Authorized parameter
        // you will be forced to jump to the 403 interface without permission
        ,
        Authorized: Authorized,
        menuData: mneudatas,
        collapsed: collapsed,
        location: location,
        isMobile: mb,
        onCollapse: this.handleMenuCollapse
      }), React.createElement("div", {
        className: "global-body-layout main-ant-layout  main-body-layout"
      }, React.createElement(Content, {
        className: "scrollUpButton-Wapper",
        id: "maincontent"
      }, React.createElement(Switch, null, redirectData.map(function (item) {
        return React.createElement(Redirect, {
          key: item.from,
          exact: true,
          from: item.from,
          to: item.to
        });
      }), getRoutes(match.path, routerData).map(function (item) {
        return React.createElement(AuthorizedRoute, {
          key: item.key,
          path: item.path,
          component: item.component,
          exact: true,
          authority: item.authority,
          redirectPath: "/exception/403"
        });
      }), React.createElement(Redirect, {
        exact: true,
        from: "/",
        to: baseRedirect
      }), React.createElement(Route, {
        render: NotFound
      }))), React.createElement(ScrollUpButton, {
        ContainerClassName: ".scrollUpButton-Wapper"
      }))));
      return React.createElement(ContainerQuery, {
        query: query
      }, function (params) {
        return React.createElement("div", {
          className: classNames(params)
        }, layout);
      });
    }
  }]);

  return BasicLayout;
}(React.PureComponent);

BasicLayout.childContextTypes = {
  location: PropTypes.object,
  breadcrumbNameMap: PropTypes.object
};
BasicLayout = __decorate([connect(function (_ref2) {
  var user = _ref2.user,
      rest = _ref2.rest,
      _ref2$global = _ref2.global,
      global = _ref2$global === void 0 ? {} : _ref2$global;
  var currentUser = user.currentUser;
  setCurrency(currentUser.currencySort || '');
  setCountry(currentUser.country || 'zh');
  window.country = currentUser.country || 'zh';
  window.localGet = localGet;
  return {
    currentUser: user.currentUser,
    collapsed: global.collapsed,
    notices: global.notices,
    menudata: global.menudata,
    urlConfig: global.urlConfig,
    locals: global.locals,
    msgInfo: rest.msgInfo
  };
}) // @ts-ignore
, injectIntl], BasicLayout);
export default BasicLayout;