import _regeneratorRuntime from "@babel/runtime/regenerator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : new P(function (resolve) {
        resolve(result.value);
      }).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}; // importExcel --引用太深了


import classnames from 'classnames';
import { connect } from 'dva';
import { routerRedux } from 'dva/router';
import * as React from 'react';
import Button from '../button';
import Dropdown from '../dropdown';
import Ellipsis from '../ellipsis';
import Icon from '../icon';
import JModal from '../j-modal'; // import fetch from 'dva/fetch';

import LocaleReceiver from '../locale-provider/LocaleReceiver';
import defaultLocale from '../locale-provider/zh_CN';
import Menu from '../menu';
import Popconfirm from '../popconfirm';
import { default as fetch, default as request } from '../_util/request';
import { intlFormat } from '../_util/utils'; // import * as fetch from 'dva/fetch';
// @ts-ignore

import ImportExcel from './importExcel'; // 外引用组件

import operationButtonGroup from './operationButtonGroup';
import TipIcon from './tip-icon';

var queryString = require('qs');

var SubMenu = Menu.SubMenu;
var outPermissionList = null;
var dispatch;

function getImportBatchNum(params) {
  return request('../import/add', {
    method: "POST",
    body: params
  }).then(function (res) {
    return res || {};
  });
}

function startImport(buttonInfo) {
  return __awaiter(this, void 0, void 0,
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee() {
    var templateId, path, routerPath, res, data, message, success, code, batchNum, exist;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            templateId = buttonInfo.templateId;
            path = '../importTemplate';
            routerPath = buttonInfo.routerPath;

            if (routerPath) {
              path = routerPath;
            }

            _context.next = 6;
            return getImportBatchNum({
              override: false,
              templateId: templateId
            });

          case 6:
            res = _context.sent;
            data = res.data, message = res.message, success = res.success, code = res.code;

            if (!success) {
              _context.next = 15;
              break;
            }

            batchNum = data.batchNum, exist = data.exist;

            if (!exist) {
              _context.next = 13;
              break;
            }

            JModal.confirm({
              title: intlFormat('jlt.jltd.templateImport', '模板导入'),
              content: intlFormat('jlt.jltd.title', '存在正在导入的信息，是否继续上次导入操作'),
              okText: intlFormat('jlt.jltd.continueImport', '继续导入'),
              cancelText: intlFormat('jlt.jltd.reImport', '重新导入'),
              onOk: function onOk() {
                dispatch(routerRedux.push({
                  pathname: path,
                  search: queryString.stringify({
                    templateId: templateId,
                    batchNum: batchNum
                  })
                }));
              },
              onCancel: function onCancel(e) {
                JModal.destroyAll();

                if (e.triggerCancel) {
                  return;
                } // tslint:disable-next-line:no-shadowed-variable


                getImportBatchNum({
                  override: true,
                  templateId: templateId
                }).then(function (res) {
                  dispatch(routerRedux.push({
                    pathname: path,
                    search: queryString.stringify({
                      templateId: templateId,
                      batchNum: res.data.batchNum
                    })
                  }));
                });
              }
            });
            return _context.abrupt("return");

          case 13:
            dispatch(routerRedux.push({
              pathname: path,
              search: queryString.stringify({
                templateId: templateId,
                batchNum: batchNum
              })
            }));
            return _context.abrupt("return");

          case 15:
            if (code === '3002' || message === '导入模板不存在') {
              JModal.error({
                title: message,
                content: intlFormat('jlt.jltd.templateNoFountContent', '导入模板不存在，请联系管理员修改'),
                okCancel: false,
                okText: intlFormat('jlt.jltd.Confirm', '确定')
              });
            }

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
}

var renderButton = function renderButton(buttonInfo) {
  var disabled = buttonInfo.disabled,
      id = buttonInfo.id;

  if (buttonInfo.isNew) {
    return buttonInfo.child ? buttonInfo.child : React.createElement(Button, {
      ref: function ref(e) {
        if (id) {
          JButtonGroup.btnIds[id] = e;
        }
      },
      className: classnames('j-button-group', buttonInfo.className),
      type: buttonInfo.type || 'default',
      size: buttonInfo.size || 'default',
      onClick: function onClick(e) {
        if (buttonInfo.templateId) {
          startImport(buttonInfo);
        } else {
          // tslint:disable-next-line:no-unused-expression
          buttonInfo.onClick && buttonInfo.onClick(e);
        }
      },
      disabled: disabled || buttonInfo.loading
    }, buttonInfo.text);
  }

  return buttonInfo.templateId ? React.createElement(ImportExcel, {
    buttonInfo: buttonInfo
  }) : buttonInfo.child ? buttonInfo.child : React.createElement(Button, {
    ref: function ref(e) {
      if (id) {
        JButtonGroup.btnIds[id] = e;
      }
    },
    className: classnames('j-button-group', buttonInfo.className),
    type: buttonInfo.type || 'default',
    size: buttonInfo.size || 'default',
    onClick: buttonInfo.onClick,
    disabled: disabled
  }, buttonInfo.text);
};

var renderMenuItem = function renderMenuItem(buttonInfo) {
  var props = {};

  if (buttonInfo.text.length > 10) {
    props.title = buttonInfo.text;
  }

  return buttonInfo.templateId && !buttonInfo.isNew ? React.createElement(ImportExcel, {
    buttonInfo: buttonInfo,
    buttonType: "a"
  }) : React.createElement("div", _extends({
    onClick: function onClick() {
      if (buttonInfo.templateId && buttonInfo.isNew) {
        startImport(buttonInfo);
      } // tslint:disable-next-line:no-unused-expression


      !buttonInfo.diasbled && buttonInfo.onClick && buttonInfo.onClick();
    }
  }, props), React.createElement(Ellipsis, {
    length: 10,
    text: buttonInfo.text
  }));
};

var renderDropdown = function renderDropdown(buttonInfo) {
  var menu = React.createElement(Menu, {
    style: {
      maxHeight: 390,
      overflowY: 'auto'
    }
  }, buttonInfo.children.map(function (opt, index) {
    opt.isNew = buttonInfo.isNew;
    return React.createElement(Menu.Item, {
      key: index,
      disabled: opt.disabled
    }, renderDefaultMenu(opt));
  }));
  return React.createElement(Dropdown, {
    overlay: menu
  }, React.createElement(Button, {
    className: "button-group"
  }, buttonInfo.text, " ", React.createElement(Icon, {
    type: "down"
  })));
};

var renderSubMenu = function renderSubMenu(buttonInfo, index) {
  return React.createElement(SubMenu, {
    title: buttonInfo.text,
    key: "sub-button".concat(index)
  }, buttonInfo.children.map(function (opt, index1) {
    return React.createElement(Menu.Item, {
      key: index1,
      disabled: opt.disabled
    }, renderDefaultMenu(opt));
  }));
};

var renderDefaultButton = function renderDefaultButton(buttonInfo) {
  if (buttonInfo.popconfirmTitle) {
    return React.createElement(Popconfirm, {
      placement: "top",
      title: buttonInfo.popconfirmTitle,
      onConfirm: buttonInfo.onClick,
      okText: intlFormat('jlt.jltd.Confirm', "确定"),
      cancelText: intlFormat('jlt.jltd.Cancelled', "取消")
    }, React.createElement(NewGlobalBotton, {
      buttonInfo: _extends({}, buttonInfo, {
        onClick: null
      })
    }));
  }

  return React.createElement(NewGlobalBotton, {
    buttonInfo: buttonInfo
  });
};

var renderDefaultMenu = function renderDefaultMenu(buttonInfo) {
  if (buttonInfo.popconfirmTitle) {
    return React.createElement(Popconfirm, {
      placement: "top",
      title: buttonInfo.popconfirmTitle,
      onConfirm: buttonInfo.onClick,
      okText: intlFormat('jlt.jltd.Confirm', "确定"),
      cancelText: intlFormat('jlt.jltd.Cancelled', "取消")
    }, renderMenuItem(_extends({}, buttonInfo, {
      onClick: null
    })));
  }

  return renderMenuItem(buttonInfo);
};

var ButtonGroup =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ButtonGroup, _React$Component);

  function ButtonGroup(props) {
    var _this;

    _classCallCheck(this, ButtonGroup);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ButtonGroup).call(this, props));

    _this.getPermission = function () {
      // tslint:disable-next-line:no-unused-expression
      outPermissionList && outPermissionList["catch"](function () {
        outPermissionList = null;
      });
      setTimeout(function () {
        if (!outPermissionList) {
          outPermissionList = fetch('../system/getButtonPermission', {
            method: 'post',
            credentials: 'include'
          }).then(function (res) {
            if (!_this.unmount) {
              var list = _this.filterPermission(_this.props.data, res.data); // @ts-ignore


              _this.state.permissionList = res.data;

              _this.setState({
                buttonList: list
              });
            }

            return res.data;
          });
        } else {
          if (!_this.unmount) {
            // tslint:disable-next-line:no-unused-expression
            outPermissionList && outPermissionList.then(function (res) {
              var list = _this.filterPermission(_this.props.data, res || []); // @ts-ignore


              _this.state.permissionList = res;

              _this.setState({
                buttonList: list
              });
            });
          }
        }
      });
    };

    _this.filterPermission = function () {
      var buttonOptList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var permission = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return buttonOptList.filter(function (opt) {
        if (opt.children && opt.children.length > 0) {
          var filterChidrenList = _this.filterPermission(opt.children, permission);

          if (filterChidrenList.length === 0) {
            return false;
          }

          opt.children = filterChidrenList;
        }

        if (!opt.menuCode || !opt.operateCode) {
          return true;
        }

        return _this.check(opt, permission);
      });
    };

    _this.check = function () {
      var buttonOpt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var permissionMap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!buttonOpt.menuCode || !buttonOpt.operateCode) {
        return true;
      }

      if (permissionMap === null) {
        return false;
      }

      var operateCodeMap = permissionMap[buttonOpt.menuCode] || [];

      if (!operateCodeMap.hasOwnProperty(buttonOpt.operateCode)) {
        return false;
      }

      var operateName = operateCodeMap[buttonOpt.operateCode];

      if (operateName && operateName !== '') {
        buttonOpt.text = operateCodeMap[buttonOpt.operateCode];
      }

      return true;
    };

    _this.state = {
      buttonList: [],
      permissionList: []
    };
    dispatch = _this.props.dispatch;
    return _this;
  }

  _createClass(ButtonGroup, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.isLocalData) {
        this.setState({
          buttonList: this.props.data
        });
      } else {
        this.getPermission();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.isLocalData) {
        this.setState({
          buttonList: nextProps.data
        });
        return;
      }

      var list = this.filterPermission(nextProps.data, this.state.permissionList);

      if (!this.unmount) {
        this.setState({
          buttonList: list
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unmount = true;
    }
  }, {
    key: "render",
    value: function render() {
      var buttonList = this.state.buttonList;
      var _this$props$isNew = this.props.isNew,
          isNew = _this$props$isNew === void 0 ? JButtonGroup.isNew : _this$props$isNew;
      var defaultBtnOptList = [];
      var dropdownBtnOptList = [];

      if (buttonList.length <= 6) {
        defaultBtnOptList = buttonList;
      } else {
        defaultBtnOptList = buttonList.slice(0, 5);
        dropdownBtnOptList = buttonList.slice(5);
      }

      var menu = React.createElement(Menu, null, dropdownBtnOptList.map(function (opt, index) {
        if (isNew) opt.isNew = true;

        if (opt.children && opt.children.length > 0) {
          return renderSubMenu(opt, index);
        }

        return React.createElement(Menu.Item, {
          key: index,
          disabled: opt.disabled
        }, renderDefaultMenu(opt));
      }));
      var result = defaultBtnOptList.map(function (buttonInfo) {
        if (isNew) {
          buttonInfo.isNew = true;
        }

        return React.createElement("span", {
          key: buttonInfo.text,
          style: {
            display: 'inline-block'
          }
        }, buttonInfo.children && buttonInfo.children.length > 0 ? renderDropdown(buttonInfo) : renderDefaultButton(buttonInfo));
      });

      if (dropdownBtnOptList.length > 0) {
        result.push(React.createElement(Dropdown, {
          overlay: menu,
          key: "more"
        }, React.createElement(Button, {
          className: "j-button-group"
        }, this.props.locale.more, " ", React.createElement(Icon, {
          type: "down"
        }))));
      }

      return result;
    }
  }]);

  return ButtonGroup;
}(React.Component);

var ConnectButtonGroup = connect()(ButtonGroup);

var GlobalButton =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(GlobalButton, _React$PureComponent);

  function GlobalButton() {
    _classCallCheck(this, GlobalButton);

    return _possibleConstructorReturn(this, _getPrototypeOf(GlobalButton).apply(this, arguments));
  }

  _createClass(GlobalButton, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "render",
    value: function render() {
      return renderButton(_extends({}, this.props.buttonInfo, {
        load: this.props.load,
        dispatch: this.props.dispatch
      }));
    }
  }]);

  return GlobalButton;
}(React.PureComponent);

var NewGlobalBotton = connect(function (_ref) {
  var global = _ref.global;
  return {
    load: global.load
  };
})(GlobalButton);

var JButtonGroup =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(JButtonGroup, _React$Component2);

  function JButtonGroup() {
    var _this2;

    _classCallCheck(this, JButtonGroup);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(JButtonGroup).apply(this, arguments));

    _this2.renderBtn = function (locale) {
      return React.createElement("div", {
        className: "jlt-button-group"
      }, React.createElement("div", {
        style: _this2.props.extra ? {
          marginRight: 80
        } : {}
      }, React.createElement(ConnectButtonGroup, _extends({}, _this2.props, {
        locale: locale
      }))), _this2.props.extra && React.createElement("div", {
        className: "jlt-button-group-extra"
      }, React.createElement(TipIcon, {
        icon: _this2.props.icon
      }), _this2.props.extra));
    };

    return _this2;
  }

  _createClass(JButtonGroup, [{
    key: "render",
    value: function render() {
      return React.createElement(LocaleReceiver, {
        componentName: "JButtonGroup",
        defaultLocale: defaultLocale.JButtonGroup
      }, this.renderBtn);
    }
  }]);

  return JButtonGroup;
}(React.Component);

JButtonGroup.isNew = false;
JButtonGroup.btnIds = {};

JButtonGroup.loading = function (id) {
  if (JButtonGroup.btnIds[id] && JButtonGroup.btnIds[id].setState) {
    JButtonGroup.btnIds[id].setState({
      loading: true
    });
  }
};

JButtonGroup.disabled = function (id) {
  if (JButtonGroup.btnIds[id] && JButtonGroup.btnIds[id].setState) {
    JButtonGroup.btnIds[id].setState({
      disabled: true,
      loading: false
    });
  }
};

JButtonGroup.clear = function (id) {
  if (JButtonGroup.btnIds[id] && JButtonGroup.btnIds[id].setState) {
    JButtonGroup.btnIds[id].setState({
      disabled: false,
      loading: false
    });
  }
};

JButtonGroup.getPermissions = function (menuCode, opreateCode) {
  if (!outPermissionList) {
    outPermissionList = fetch('../system/getButtonPermission', {
      method: 'post',
      credentials: 'include'
    }).then(function (res) {
      if (menuCode && opreateCode) {
        return res.data[menuCode][opreateCode];
      } else if (menuCode && !opreateCode) {
        return res.data[menuCode];
      } else {
        return res.data;
      }
    });
    return outPermissionList;
  }

  if (menuCode && opreateCode) {
    return outPermissionList.then(function (res) {
      return res[menuCode][opreateCode];
    });
  } else if (menuCode && !opreateCode) {
    return outPermissionList.then(function (res) {
      return res[menuCode];
    });
  } else {
    return outPermissionList;
  }
};

JButtonGroup.operationButtonGroup = operationButtonGroup;
JButtonGroup.renderButton = renderButton;
export default JButtonGroup;