import Button from "../button";
import Popconfirm from "../popconfirm";

var getOptionDataText = function getOptionDataText(list, value) {
  var text = null; // tslint:disable-next-line:no-unused-expression

  list && list.some(function (data) {
    if (!data || data.value !== value) {
      return false;
    }

    text = data.text;
    return true;
  });
  return text || value; // 找不到对应值，显示value
};

var searchButtonGroup = function searchButtonGroup() {
  var buttonList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return buttonList.map(function (buttonInfo) {
    var renderButton = React.createElement(Button, {
      className: 'button-group',
      type: getOptionDataText([], buttonInfo.type),
      size: buttonInfo.size || 'default',
      onClick: buttonInfo.onClick
    }, buttonInfo.text);
    var renderPopconfirm = React.createElement(Popconfirm, {
      placement: "topRight",
      title: buttonInfo.popconfirmText,
      onConfirm: buttonInfo.onClick,
      okText: "\u786E\u5B9A",
      cancelText: "\u53D6\u6D88"
    }, React.createElement(Button, {
      className: 'button-group',
      type: "primary",
      size: buttonInfo.size || 'default'
    }, buttonInfo.text));
    return React.createElement("span", {
      key: buttonInfo.text
    }, buttonInfo.isPopconfirm ? renderPopconfirm : renderButton);
  });
};

export default searchButtonGroup;