function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import classnames from 'classnames';
import * as React from 'react';
import Button from '../button';
import Col from '../col';
import Form from '../form';
import Icon from '../icon';
import LocaleReceiver from '../locale-provider/LocaleReceiver';
import defaultLocale from '../locale-provider/zh_CN';
import Row from '../row';
import { messages } from './message';
import { getValueType, setValuesFunction } from './utils';
var FormItem = Form.Item;
var baseRoot = 'body';

function getContainer() {
  var modals = document.querySelectorAll('.ant-modal-wrap');
  var modal = undefined;
  modals.forEach(function (dom) {
    //@ts-ignore
    if (dom.style.display !== 'none') {
      modal = dom;
    }
  });
  return modal || document.querySelector('.ant-layout-content') || document.querySelector(baseRoot);
}

var JNewForm =
/*#__PURE__*/
function (_React$Component) {
  _inherits(JNewForm, _React$Component);

  function JNewForm(props) {
    var _this;

    _classCallCheck(this, JNewForm);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(JNewForm).call(this, props));
    _this.datePicker = {};

    _this.handleSearch = function (e) {
      e.preventDefault();

      if (_this.props.onSearchClick) {
        _this.props.onSearchClick(e);
      } else {
        _this.props.form.validateFields(function (_err, values) {
          console.warn('Received values of form: ', values);
        });
      }
    };

    _this.handleReset = function () {
      _this.props.form.resetFields(); // tslint:disable-next-line:no-unused-expression


      _this.props.onResetClick && _this.props.onResetClick();
    };

    _this.toggle = function () {
      var expand = _this.state.expand;

      if (expand) {
        // @ts-ignore
        _this.state.topList = _this.props.datas.slice(0, 2); // @ts-ignore

        _this.state.bottomList = _this.props.datas.slice(2);
      }

      _this.setState({
        expand: !expand
      });
    };

    _this.renderSearchBtn = function () {
      if (!_this.props.isSearch) {
        return null;
      }

      var showMore = _this.props.datas.filter(function (item) {
        return !item.hide;
      }).length > 2;
      var _this$props$renderAll = _this.props.renderAll,
          renderAll = _this$props$renderAll === void 0 ? false : _this$props$renderAll;
      return React.createElement(Col, {
        span: _this.props.searchSpan || _this.props.span || 8
      }, React.createElement(Row, {
        type: "flex",
        align: "middle",
        style: {
          paddingLeft: 30,
          minWidth: 340,
          position: 'relative',
          top: -1,
          margin: '4px 0'
        }
      }, React.createElement(Button, {
        style: {
          marginRight: 20
        },
        type: "primary",
        htmlType: "submit"
      }, _this.props.locale.search), React.createElement(Button, {
        style: {
          marginRight: 20
        },
        onClick: _this.handleReset
      }, _this.props.locale.reset), showMore && !renderAll && React.createElement(Button, {
        onClick: _this.toggle
      }, _this.state.expand ? _this.props.locale.closeMore : _this.props.locale.openMore, React.createElement(Icon, {
        type: _this.state.expand ? 'up' : 'down',
        style: {
          fontSize: 12
        }
      }))));
    };

    _this.state = {
      expand: false,
      topList: [],
      bottomList: []
    };
    return _this;
  }

  _createClass(JNewForm, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      if (this.props.datas && this.props.datas.length > 0) {
        // @ts-ignore
        var topList = this.props.datas.filter(function (item) {
          return !item.hide;
        }).slice(0, 2); // @ts-ignore

        var bottomList = this.props.datas.filter(function (item) {
          return !item.hide;
        }).slice(2);
        this.setState({
          topList: topList,
          bottomList: bottomList
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.getRefForm != null) {
        this.props.getRefForm(this.props.form);
      }

      if (!this.unmount) {
        this.getFormat();
        setValuesFunction(this);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unmount = true;
      clearTimeout(this.time);
    }
  }, {
    key: "getFormat",
    value: function getFormat(update) {
      var _this2 = this;

      this.datePicker = {}; // tslint:disable-next-line:no-unused-expression

      this.props.datas && this.props.datas.map(function (item) {
        var type = item && item.node && item.node.type && item.node.type._name;

        if (!type) {
          return;
        }

        if (type === 'DatePicker' || type === 'JDatePicker' || type === 'RangePicker' || type === 'MonthPicker' || type === 'WeekPicker') {
          _this2.datePicker[item.fileId || item.id] = item.node.props.format;
          item.defaultProps = {
            allowClear: true,
            getCalendarContainer: item.node.props.getCalendarContainer || getContainer
          };
          item.staticProps = {
            onCalendarChange: function onCalendarChange() {
              var datas = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

              _this2.props.form.setFieldsValue(_defineProperty({}, item.fileId || item.id, datas));

              var onCalendarChange = item.node.props.onCalendarChange;
              onCalendarChange && onCalendarChange(datas);
            },
            onOpenChange: function onOpenChange(status) {
              var onOpenChange = item.node.props.onOpenChange;

              if (type === 'RangePicker') {
                var val = _this2.props.form.getFieldValue(item.fileId || item.id);

                if (!status && (!val[0] || !val[1])) {
                  _this2.props.form.setFieldsValue(_defineProperty({}, item.fileId || item.id, undefined));
                }
              }

              onOpenChange && onOpenChange(status);
            }
          };
        } else if (type === 'Input' || type === 'Search' || type === 'JInput') {
          item.defaultProps = {
            placeholder: item.node.props.placeholder || "".concat(_this2.props.locale.placeholderInput),
            maxLength: item.node.props.maxLength || 50,
            onBlur: function onBlur(e) {
              var _item$node$props = item.node.props,
                  _item$node$props$maxL = _item$node$props.maxLength,
                  maxLength = _item$node$props$maxL === void 0 ? 50 : _item$node$props$maxL,
                  onBluer = _item$node$props.onBluer;
              e.target.value = e.target.value.slice(0, maxLength); // tslint:disable-next-line:no-shadowed-variable

              var errors = (_this2.props.form.getFieldError(item.fileId || item.id) || []).map( // tslint:disable-next-line:no-shadowed-variable
              function (item) {
                return new Error(item);
              });

              _this2.props.form.setFields(_defineProperty({}, item.fileId || item.id, {
                value: e.target.value || undefined,
                errors: errors.length === 0 ? undefined : errors
              })); // tslint:disable-next-line:no-unused-expression


              onBluer && onBluer(e);
            },
            allowClear: true
          };
        } else if (type === 'Select' || type === 'JSelect') {
          item.defaultProps = {
            placeholder: item.node.props.placeholder || "".concat(_this2.props.locale.placeholderSelect),
            allowClear: true,
            getPopupContainer: item.node.props.getPopupContainer || getContainer
          };
        } else if (type === 'TextArea') {
          item.defaultProps = {
            placeholder: item.node.props.placeholder || "".concat(_this2.props.locale.placeholderInput),
            maxLength: item.node.props.maxLength || 250,
            allowClear: true,
            onBlur: function onBlur(e) {
              var _item$node$props2 = item.node.props,
                  _item$node$props2$max = _item$node$props2.maxLength,
                  maxLength = _item$node$props2$max === void 0 ? 250 : _item$node$props2$max,
                  onBluer = _item$node$props2.onBluer;
              e.target.value = e.target.value.slice(0, maxLength); // tslint:disable-next-line:no-shadowed-variable

              var errors = (_this2.props.form.getFieldError(item.fileId || item.id) || []).map( // tslint:disable-next-line:no-shadowed-variable
              function (item) {
                return new Error(item);
              });

              _this2.props.form.setFields(_defineProperty({}, item.fileId || item.id, {
                value: e.target.value || undefined,
                errors: errors.length === 0 ? undefined : errors
              })); // tslint:disable-next-line:no-unused-expression


              onBluer && onBluer(e);
            }
          };
        } else if (type === 'inputNumber') {
          item.defaultProps = {
            placeholder: item.node.props.placeholder || "".concat(_this2.props.locale.placeholderInput),
            allowClear: true
          };
        } else if (type === 'Cascader') {
          item.defaultProps = {
            placeholder: item.node.props.placeholder || "".concat(_this2.props.locale.placeholderSelect),
            allowClear: true,
            getPopupContainer: item.node.props.getPopupContainer || getContainer
          };
        }
      });

      if (!update) {
        this.time = setTimeout(function () {
          _this2.forceUpdate();
        }, 100);
      }
    } // To generate mock Form.Item

  }, {
    key: "getFields",
    value: function getFields(list, expand) {
      var _this3 = this;

      var _this$props = this.props,
          datas = _this$props.datas,
          showDetail = _this$props.showDetail,
          _this$props$colon = _this$props.colon,
          colon = _this$props$colon === void 0 ? false : _this$props$colon,
          span = _this$props.span;
      var getFieldDecorator = this.props.form.getFieldDecorator;
      var children = [];
      var renderList = list || datas;

      var _loop = function _loop(i) {
        var item = renderList[i]; // if(item.hide){
        //   continue;
        // }
        // 正常表单

        var spann = span || 8;
        var rules = (item.rules || []).map(function (rule) {
          rule.type = rule.type || getValueType(item, function (type) {
            if (type === 'number' && !rule.transform) {
              rule.transform = function (value) {
                if (typeof value === 'string') {
                  return Number(value);
                } else {
                  return value;
                }
              };
            }
          });
          return _extends({}, rule, {
            field: item.id || item.fileId || item.label,
            fullField: item.label
          });
        });

        var options = _extends({}, item.options, {
          rules: rules || []
        });

        if (_this3.props.isModal) {} // 弹出框
        // spann = 12;
        // 有设置具体值的  8,16,24


        if (item.span) {
          spann = item.span;
        }

        if (item.value || item.initialValue) {
          options.initialValue = item.value || item.initialValue;
        }

        children.push(React.createElement(Col, {
          span: spann,
          offset: item.wrap || 0,
          pull: item.wrap || 0,
          key: i,
          className: !expand || item.hide ? 'j-form-col-hide' : ''
        }, showDetail ? React.createElement("div", {
          className: "detail-label"
        }, React.createElement("span", {
          className: "info-label"
        }, item.label, (item.colon || colon || false) && ':'), React.createElement("span", {
          className: "info-value"
        }, item.node)) : React.createElement(FormItem, _extends({
          colon: item.colon || colon || false
        }, item.item, {
          labelCol: {
            xs: {
              span: 24
            },
            sm: {
              span: 3
            },
            xl: {
              span: 6
            }
          },
          help: item.help,
          extra: item.extra,
          label: item.label
        }), item.render ? item.render() : getFieldDecorator(item.id || item.fileId || item.label, options)(React.cloneElement(item.node, _extends({}, item.defaultProps, item.node.props, item.staticProps), item.node.props.children)))));
      };

      for (var i = 0; i < renderList.length; i++) {
        _loop(i);
      }

      return children;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          datas = _this$props2.datas,
          isModal = _this$props2.isModal,
          style = _this$props2.style,
          _this$props2$renderAl = _this$props2.renderAll,
          renderAll = _this$props2$renderAl === void 0 ? false : _this$props2$renderAl,
          _this$props2$autoHeig = _this$props2.autoHeight,
          autoHeight = _this$props2$autoHeig === void 0 ? true : _this$props2$autoHeig;
      var rowClass = 'jltd-advanced-search-form-flex';
      this.getFormat(true); // @ts-ignore

      var topList = datas.filter(function (item) {
        return !item.hide;
      }).slice(0, 2); // @ts-ignore

      var bottomList = datas.filter(function (item) {
        return !item.hide;
      }).slice(2);
      var expand = this.state.expand;
      var hideData = datas.filter(function (item) {
        return item.hide;
      });

      if (isModal) {
        rowClass = 'jltd-advanced-search-form-flex jltd-advanced-search-form-modal';
      }

      return React.createElement(Form, {
        className: classnames('jltd-advanced-search-form', _defineProperty({}, 'autoHeight', autoHeight)),
        style: style || {},
        onSubmit: this.handleSearch
      }, React.createElement(Row, {
        type: "flex",
        className: rowClass,
        gutter: {
          xs: 8,
          sm: 16,
          md: 24
        }
      }, this.getFields(topList, true), this.renderSearchBtn(), this.getFields(bottomList, expand || renderAll), this.getFields(hideData, false)));
    }
  }]);

  return JNewForm;
}(React.Component);

var JNewFormComponent = Form.create({
  validateMessages: messages
})(JNewForm);

var JForm =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(JForm, _React$Component2);

  function JForm() {
    var _this4;

    _classCallCheck(this, JForm);

    _this4 = _possibleConstructorReturn(this, _getPrototypeOf(JForm).apply(this, arguments));

    _this4.renderForm = function (locale) {
      return React.createElement(JNewFormComponent, _extends({
        locale: locale
      }, _this4.props));
    };

    return _this4;
  }

  _createClass(JForm, [{
    key: "render",
    value: function render() {
      return React.createElement(LocaleReceiver, {
        componentName: "JForm",
        defaultLocale: defaultLocale.JForm
      }, this.renderForm);
    }
  }]);

  return JForm;
}(React.Component);

JForm.setBaseRoot = function (root) {
  baseRoot = root;
};

JForm.getBaseRoot = function () {
  return baseRoot;
};

export default JForm;