function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

import * as React from 'react'; // import { PageHeaderLayout, JForm, JTable, request, JButtonGroup } from 'jltd';

import PageHeaderLayout from '../page-header-layout';
import JForm from '../j-form';
import JTable from '../j-table';
import JButtonGroup from '../j-button-group';
import JQuickSearch from '../j-quick-search';
import request from '../_util/request';
import * as qs from 'querystring';

function debouce(fn) {
  var delay = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 200;
  var timer = null;
  return function () {
    var _arguments = arguments;
    clearTimeout(timer);
    timer = setTimeout(function () {
      return fn.apply(void 0, _toConsumableArray(_arguments));
    }, delay);
  };
}

var JListPage =
/*#__PURE__*/
function (_React$Component) {
  _inherits(JListPage, _React$Component);

  function JListPage(props) {
    var _this;

    _classCallCheck(this, JListPage);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(JListPage).call(this, props));
    _this.table = null;

    _this.setTarget = function () {
      JListPage.that = _assertThisInitialized(_this);
      JListPage.form = _this.form;
    };

    _this.onQucikSearch = function (value) {
      // tslint:disable-next-line:no-shadowed-variable
      var _this$props = _this.props,
          _this$props$quickSear = _this$props.quickSearchName,
          quickSearchName = _this$props$quickSear === void 0 ? 'orderStatus' : _this$props$quickSear,
          JQuickSearch = _this$props.JQuickSearch;
      _this.tempState[quickSearchName] = value; // @ts-ignore

      _this.state.orderStatus = value; // @ts-ignore

      _this.state.pageNumber = 1;

      _this.getData();

      JQuickSearch && JQuickSearch.onChange && JQuickSearch.onChange(value);
    };

    _this.getData = function (init) {
      var data = _this.getFormData(init);

      _this.table && _this.table.setState({
        selectedRowKeys: [],
        selectedRows: []
      });
      var _this$props2 = _this.props,
          onFetched = _this$props2.onFetched,
          dataParams = _this$props2.dataParams,
          dataFilter = _this$props2.dataFilter;
      var _this$state = _this.state,
          pageSize = _this$state.pageSize,
          pageNumber = _this$state.pageNumber;

      if (dataParams && dataParams.url) {
        var options = {
          body: _extends({}, data, dataParams.params || {}, {
            pageSize: pageSize,
            pageNumber: pageNumber
          }),
          method: 'POST'
        };

        _this.setState({
          loading: true
        });

        if (dataParams.method && data.method.toLocaleLowerCase() === 'get') {
          options.method = 'get';

          if (dataParams.url.indexOf('?') >= 0) {
            dataParams.url += "&".concat(qs.stringify(options.body));
          } else {
            dataParams.url += "?".concat(qs.stringify(options.body));
          }

          delete options.body;
        }

        request(dataParams.url, options).then(function (res) {
          if (dataFilter) {
            res = dataFilter(res);
            if (!res) throw new Error('dataFilter 必要要有返回值');
          } // tslint:disable-next-line:no-shadowed-variable


          var _res = res,
              data = _res.data,
              pageIndex = _res.pageIndex,
              pageSize = _res.pageSize,
              rowsCount = _res.rowsCount;

          _this.setState({
            dataSource: data,
            pageNumber: pageIndex,
            total: rowsCount,
            pageSize: pageSize,
            loading: false
          });

          if (res && res.pageIndex) {
            _this.table && _this.table.setState({
              pageSize: res.pageSize,
              current: res.pageIndex || res.pageNumber
            });
          }

          onFetched && onFetched(res);
        });
      }
    };

    _this.onPageChange = function (pageNumber, pageSize) {
      // @ts-ignore
      _this.state.pageNumber = pageNumber; // @ts-ignore

      _this.state.pageSize = pageSize;

      _this.getData();
    };

    _this.getFormData = function (type) {
      if (type) {
        var orderStatus = _this.state.orderStatus;
        var _this$props3 = _this.props,
            _this$props3$quickSea = _this$props3.quickSearchName,
            quickSearchName = _this$props3$quickSea === void 0 ? 'orderStatus' : _this$props3$quickSea,
            paramsFilter = _this$props3.paramsFilter;

        var data = _extends({}, _defineProperty({}, quickSearchName, orderStatus), JListPage.form ? _extends({}, JListPage.form.values()) : {});

        Object.keys(data).map(function (item) {
          if (data["".concat(item, "From")] && data["".concat(item, "To")] || Array.isArray(data[item]) && data[item].length === 0) {
            delete data[item];
          }
        });

        if (paramsFilter) {
          data = paramsFilter(data);
          if (!data) throw new Error('paramsFilter方法需要有返回值');
        }

        _this.tempState = JSON.parse(JSON.stringify(data));
        return data;
      } else {
        return _this.tempState;
      }
    };

    _this.onSearchClick = function () {
      // tslint:disable-next-line:no-shadowed-variable
      var JForm = _this.props.JForm; // @ts-ignore

      _this.state.pageNumber = 1;

      var data = _this.getFormData(true);

      JForm && JForm.onSearchClick && JForm.onSearchClick(data);

      _this.refresh();
    };

    _this.btnClick = function (e, item) {
      var _ref = _this.table ? _this.table.state : {},
          _ref$selectedRowKeys = _ref.selectedRowKeys,
          selectedRowKeys = _ref$selectedRowKeys === void 0 ? [] : _ref$selectedRowKeys,
          _ref$selectedRows = _ref.selectedRows,
          selectedRows = _ref$selectedRows === void 0 ? [] : _ref$selectedRows;

      item.onClick && item.onClick(JSON.parse(JSON.stringify(_extends({}, _this.state, {
        selectedRowKeys: selectedRowKeys,
        selectedRows: selectedRows
      }))), e);
    };

    _this.refresh = function () {
      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (Object.keys(params).length > 0) {
        Object.keys(params).map(function (key) {
          //@ts-ignore
          _this.state[key] = params[key];
        });
      }

      _this.getData();
    };

    _this.init = function () {
      JListPage.form && JListPage.form.resetFields();

      _this.getFormData(true); // @ts-ignore


      _this.state.pageNumber = 1; // @ts-ignore

      _this.state.pageSize = 10;
      _this.table && _this.table.setState({
        selectedRowKeys: [],
        selectedRows: [],
        orderStatus: _this.props.JQuickSearch ? _this.props.JQuickSearch.defaultValue : 0
      }, _this.getData);
    };

    _this.renderJQuickSearch = function () {
      var JQuickSearchData = _this.props.JQuickSearch;
      var orderStatus = _this.state.orderStatus;
      return JQuickSearchData ? React.createElement(JQuickSearch, {
        data: JQuickSearchData.data || [],
        onChange: _this.onQucikSearch,
        value: orderStatus
      }) : null;
    };

    _this.renderJForm = function () {
      var JFormData = _this.props.JForm;
      return JFormData ? React.createElement(JForm, {
        onResetClick: function onResetClick() {
          JListPage.form && JListPage.form.resetFields();
          JFormData.onResetClick && JFormData.onResetClick(JListPage.form);
        },
        isSearch: true,
        datas: [].concat(JFormData.data) || [],
        getRefForm: function getRefForm(e) {
          _this.form = e;
          JListPage.form = e;
        },
        onSearchClick: _this.onSearchClick
      }) : null;
    };

    _this.renderJTable = function () {
      var _this$props4 = _this.props,
          JTableData = _this$props4.JTable,
          renderTable = _this$props4.renderTable;
      var _this$state2 = _this.state,
          dataSource = _this$state2.dataSource,
          total = _this$state2.total,
          pageNumber = _this$state2.pageNumber,
          pageSize = _this$state2.pageSize,
          loading = _this$state2.loading;

      if (renderTable) {
        return renderTable({
          dataSource: dataSource,
          total: total,
          pageNumber: pageNumber,
          pageSize: pageSize,
          loading: loading,
          onPageChange: _this.onPageChange
        });
      }

      return JTableData ? React.createElement(JTable, _extends({
        ref: function ref(e) {
          return _this.table = e;
        }
      }, JTableData, {
        dataSource: dataSource,
        loading: loading,
        pagination: _extends({
          total: total,
          pageSize: pageSize,
          current: pageNumber,
          onChange: _this.onPageChange
        }, JTableData.pagination)
      })) : null;
    };

    _this.renderJButtonGroup = function () {
      var JButtonGroupData = _this.props.JButtonGroup;
      if (!JButtonGroupData) return null;
      var btnTempList = (JButtonGroupData.data || []).map(function (item) {
        return _extends({}, item, {
          onClick: function onClick(e) {
            _this.btnClick(e, item);
          }
        });
      });
      return JButtonGroupData ? React.createElement(JButtonGroup, _extends({}, JButtonGroupData, {
        data: btnTempList,
        extra: JButtonGroupData.extra
      })) : null;
    };

    _this.state = {
      orderStatus: props.JQuickSearch && props.JQuickSearch.defaultValue || '',
      total: 0,
      pageSize: props.defaultPageSize || 10,
      pageNumber: props.defaultCurrent || 1,
      dataSource: []
    };
    _this.tempState = {};
    _this.getData = debouce(_this.getData);
    JListPage.that = _assertThisInitialized(_this);
    return _this;
  }

  _createClass(JListPage, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props$initGetDa = this.props.initGetData,
          initGetData = _this$props$initGetDa === void 0 ? false : _this$props$initGetDa;

      if (initGetData) {
        this.getData(true);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {}
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          title = _this$props5.title,
          titleExtra = _this$props5.titleExtra;
      return title ? React.createElement(PageHeaderLayout, {
        title: title,
        style: {
          marginBottom: 0
        },
        titleExtra: titleExtra
      }, this.renderJQuickSearch(), this.renderJForm(), this.renderJButtonGroup(), this.renderJTable()) : React.createElement(React.Fragment, null, this.renderJQuickSearch(), this.renderJForm(), this.renderJButtonGroup(), this.renderJTable());
    }
  }]);

  return JListPage;
}(React.Component);

JListPage.that = null;
JListPage.form = null;

JListPage.refresh = function (params) {
  JListPage.that && JListPage.that.refresh(params);
};

JListPage.init = function () {
  JListPage.that && JListPage.that.init();
};

JListPage.getState = function () {
  var _ref2 = JListPage.that && JListPage.that.table ? JListPage.that.table.state : {},
      _ref2$selectedRowKeys = _ref2.selectedRowKeys,
      selectedRowKeys = _ref2$selectedRowKeys === void 0 ? [] : _ref2$selectedRowKeys,
      _ref2$selectedRows = _ref2.selectedRows,
      selectedRows = _ref2$selectedRows === void 0 ? [] : _ref2$selectedRows;

  return JListPage.that ? JSON.parse(JSON.stringify(_extends({}, JListPage.that ? JListPage.that.state : {}, {
    selectedRowKeys: selectedRowKeys,
    selectedRows: selectedRows
  }))) : {};
};

JListPage.getFormData = function () {
  return JListPage.that ? _extends({}, JListPage.that.tempState) : {};
};

export default JListPage;