import * as React from 'react';
export interface JTableProps {
    /**
     *  获取dataSource数据 {url:'your url',method:"POST",params:{}}`
     */
    dataSourceParams?: {
        url: string;
        params?: object;
        method?: string;
    };
    /** 获取表头数据 {url:'your url',method:"POST",params:{}} */
    columnsParams?: {
        url: string;
        params?: object;
        columns?: Array<object>;
    };
    saveColumnsParams?: {
        url: string;
        params?: object;
    };
    /** 获取表头数据 {url:'your url',method:"POST",params:{}} */
    /** 表头render方法 {dataIndex:'your dataIndex',render:(text,record)=> */
    columnsRender?: Array<object>;
    /** 表头render方法 {dataIndex:'your dataIndex',render:(text,record)=> */
    onChange?: (selectKey: any, selectedRow: any) => void;
    /** 获取tree数据 {url:'your url',method:"POST",params:{}} */
    rowKey?: any;
    dataSource?: any;
    columns?: any;
    pagination?: any;
    components?: any;
    FilterColumns?: boolean;
    className?: string;
    scroll?: {
        x: any;
        y: any;
    };
    rowSelection: any;
    onExpand: any;
    disabledList?: Array<string>;
    innerScroll?: boolean;
    bordered?: boolean;
    resizeAble?: boolean;
    onRow?: any;
    onClick?: any;
    onDoubleClick?: any;
    footerData?: any;
    dataFilter?: any;
    expandedRowRender?: any;
    columnsFormat?: (params: {
        record: any;
        columnIndex: any;
        columnLength: any;
        child: any;
        columnItem: any;
    }) => any;
    minColumns?: number;
    defaultPageSize?: number;
    defaultCurrent?: number;
    offsetTop?: number;
    setAuto?: boolean;
}
export interface JTableState {
    dataSource: any;
    columns: any;
    selectedRows: any;
    expandedKeys: Array<string>;
    selectedRowKeys: any;
    dataSourceParams: any;
    columnsRender: any;
    columnsParams: any;
    saveColumnsParams: any;
    autoExpandParent: boolean;
    loading: boolean;
    params: any;
    current: number;
    pageSize: number;
    total: number;
    scrollY: any;
    scrollX: any;
    isScrollX: boolean;
}
declare class JTable extends React.Component<JTableProps, JTableState> {
    form: any;
    targetDom: any;
    popOver: any;
    tableRef: any;
    timer: any;
    saveWidth: any;
    childData: any;
    constructor(props: any);
    onExpand: (expandedKeys: any) => void;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: JTableProps): void;
    componentWillUpdate(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    setFooter: () => void;
    removeFooter: () => void;
    getDataSource: (params1: any, pageNumber: number, pageSize: number) => void;
    handleResize: (index: any) => (_e: any, { size }: any) => void;
    getColumns: () => void;
    mergerRenderToColumns: (columns: any) => any;
    renderFilter: (cloums: any) => any;
    updatePopView: () => void;
    renderPopView: () => JSX.Element;
    saveFilter: () => void;
    resetFilter: () => void;
    setScroll: () => void;
    updateFixedView: () => void;
    getWidth: () => any;
    render(): JSX.Element;
}
export default JTable;
