function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  }
  return t;
};

import classnames from 'classnames';
import * as React from 'react';
import Tree from '../tree';
import RadioIcon from './radio-icon';

function childrenMap(children, isRadio) {
  return React.Children.map(children, function (child) {
    return React.cloneElement(child, _extends({}, child.props, {
      showIcon: isRadio || child.props.showIcon,
      className: classnames(child.props.className, {
        "jlt-radio-tree": isRadio
      }),
      icon: isRadio ? function (params) {
        return React.createElement(RadioIcon, {
          checked: params.selected,
          disabled: child.props.disabled
        });
      } : child.props.icon
    }), childrenMap(child.props.children || [], isRadio));
  });
}

var JTree = React.forwardRef(function (props, ref) {
  // tslint:disable-next-line:prefer-const
  var _props$type = props.type,
      type = _props$type === void 0 ? 'checkbox' : _props$type,
      _props$showIcon = props.showIcon,
      showIcon = _props$showIcon === void 0 ? false : _props$showIcon,
      multiple = props.multiple,
      className = props.className,
      children = props.children,
      rest = __rest(props, ["type", "showIcon", "multiple", "className", "children"]);

  var isRadio = type === 'radio';
  return React.createElement(Tree, _extends({
    ref: ref,
    showIcon: isRadio || showIcon,
    className: classnames(className, {
      "jlt-radio-tree": isRadio
    })
  }, rest, {
    multiple: !isRadio && multiple
  }), childrenMap(children || [], isRadio));
}); // @ts-ignore

JTree.TreeNode = Tree.TreeNode; // @ts-ignore

JTree.DirectoryTree = Tree.DirectoryTree;
export default JTree;