function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  }
  return t;
};

import Cascader from "antd/es/cascader";
import Checkbox from "antd/es/checkbox";
import DatePicker from "antd/es/date-picker";
import Form from 'antd/es/form';
import Icon from "antd/es/icon";
import Input from "antd/es/input";
import Radio from "antd/es/radio";
import Select from "antd/es/select";
import Tooltip from "antd/es/tooltip";
import classnames from "classnames";
import * as React from 'react';
import DataDictionaryComponents from '../DataDictionaryComponents';
import JDatePicker from '../j-date-picker';
import JInputNumber from '../j-input-number/index';
import Enum from '../_util/enum';
import { intlFormat } from '../_util/utils'; // import * as moment from 'moment';

import RanderRange from './RanderRange';

var moment = require('moment');

var RangePicker = DatePicker.RangePicker;
var TextArea = Input.TextArea;
var RadioGroup = Radio.Group;
var Search = Input.Search;
var Option = Select.Option;
/* eslint-disable */
// 输入框: input { label: '设备编号', type: 'input', onChange: this.onEquipmentIdChange， placeholder: '请输入设备编号' },
// 多行输入框: textarea { label: '设备编号', type: 'textarea', rows: 2, viewStyle: styles['textarea-style'], onChange: this.onEquipmentIdChange， placeholder: '请输入设备编号' },
// 查询框: search { label: '设备编号', type: 'input', onChange: this.onEquipmentIdChange， placeholder: '请输入设备编号' },
// 输入框: select { label: '状态', type: 'select', onChange: this.onStatusChange, optionData: [{value: 'no1', text: '第一'}, {value: 'no2', text: '第二'}], filterOption: {(input, option) => option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0} },
// 日期选择器: dataPicker { label: '有效日期从', type: 'dataPicker', onChange: this.onDateBeginChange },
// 勾选框: checkbox { label: '是否启用', type: 'checkbox', onChange: this.onDateBeginChange, defalutValue: true},
// 换行 br { type: 'br' }

/* eslint-enable */

var LabelWithController = function LabelWithController(props) {
  // 必填的星号提示
  var form = props.form; //@ts-ignore

  var renderRequire = props.isRequire ? React.createElement("span", {
    className: 'label-require'
  }, "*") : null; // 感叹号提示语

  var renderIconRequire = props.isIconRequire ? React.createElement(Tooltip, {
    title: props.title
  }, React.createElement(Icon, {
    type: "exclamation-circle"
  })) : null;
  var renderController = null;

  var renderFormItem = function renderFormItem(child) {
    var getFieldDecorator = form.getFieldDecorator;
    return React.createElement(Form.Item, null, getFieldDecorator(props.fileId, {
      rules: props.rules
    })(child));
  }; // 单选框


  if (props.type === 'radioGroup') {
    var renderRadio = (props.radioData || []).map(function (radio) {
      return React.createElement(Radio, {
        value: radio.value,
        key: radio.value
      }, radio.text);
    }); //@ts-ignore

    renderController = React.createElement("div", {
      className: classnames('view-style', 'radio-group-style', props.viewStyle)
    }, React.createElement(RadioGroup, {
      onChange: props.onChange,
      value: props.value
    }, renderRadio));
  } // 数字输入框


  if (props.type === 'inputnumber') {
    var valueProps = {};

    if (props.value || props.value === '') {
      valueProps.value = props.value;
    }

    renderController = React.createElement(JInputNumber, _extends({}, props, {
      value: props.value
    }, valueProps, {
      className: classnames('view-style', props.viewStyle),
      min: props.min ? props.min : 0,
      max: props.max ? props.max : Enum.DB_LENGTH_LIMIT.TWENTY_THREE.VALUE,
      step: props.step ? props.step : 1,
      formatter: props.formatter,
      parser: props.parser,
      precision: props.precision,
      disabled: props.disabled === true,
      onChange: function onChange(e) {
        props.onChange && props.onChange(e);
      }
    }));
  } // 输入框


  if (props.type === 'input') {
    var _valueProps = {};

    if (props.value || props.value === '') {
      _valueProps.value = props.value;
    }

    renderController = React.createElement(Input, _extends({}, props, {
      maxLength: props.maxLength || '50'
    }, _valueProps, {
      defaultValue: props.defaultValue,
      placeholder: props.placeholder,
      className: classnames('view-style', props.viewStyle),
      disabled: props.disabled === true,
      onChange: function onChange(e) {
        props.onChange && props.onChange(e.target.value.trim());
      },
      onBlur: function onBlur(e) {
        props.onBlur && props.onBlur(e.target.value);
      },
      onClick: props.onClick,
      readOnly: props.readOnly
    }));
  } // 多行输入框


  if (props.type === 'textarea') {
    var _valueProps2 = {};

    if (props.value || props.value === '') {
      _valueProps2.value = props.value;
    }

    renderController = React.createElement(TextArea, _extends({
      maxLength: props.maxLength || 255
    }, props, _valueProps2, {
      rows: props.rows === undefined ? 4 : props.rows,
      value: props.value,
      placeholder: props.placeholder,
      className: classnames('view-style', props.viewStyle),
      disabled: props.disabled === true,
      onChange: function onChange(e) {
        props.onChange && props.onChange(e.target.value.trim());
      }
    }));
  } // 查询框


  if (props.type === 'search') {
    var _valueProps3 = {};

    if (props.value || props.value === '') {
      _valueProps3.value = props.value;
    }

    renderController = React.createElement(Search, _extends({}, props, {
      maxLength: props.maxLength || '50',
      value: props.value
    }, _valueProps3, {
      placeholder: props.placeholder,
      onSearch: props.onSearch,
      disabled: props.disabled || false,
      className: classnames('view-style', props.viewStyle),
      suffix: props.suffix || null,
      readOnly: props.readOnly,
      onChange: function onChange(e) {
        props.onChange && props.onChange(e.target.value.trim());
      },
      onBlur: function onBlur(e) {
        props.onBlur && props.onBlur(e.target.value);
      }
    }));
  } // 选择框
  // 如果props.filterOption有方法，表示是带输入过滤的选择框模式


  if (props.type === 'select') {
    var renderOption = (props.optionData || []).map(function (option) {
      return React.createElement(Option, {
        key: option.value,
        value: option.value
      }, option.text);
    }); // 输入搜索模式

    var showSearch = false;
    var optionFilterProp = 'children';

    if (props.filterOption) {
      showSearch = true;
    }

    renderController = React.createElement(Select, _extends({}, props, {
      disabled: props.disabled === true || false,
      showSearch: showSearch,
      optionFilterProp: optionFilterProp,
      value: props.value || undefined,
      defaultValue: props.defaultValue,
      className: classnames('view-style', props.viewStyle),
      onChange: props.onChange,
      filterOption: props.filterOption,
      getPopupContainer: function getPopupContainer() {
        return document.querySelector('.ant-layout-content');
      },
      dropdownMatchSelectWidth: props.dropdownMatchSelectWidth === undefined ? true : props.dropdownMatchSelectWidth,
      placeholder: props.placeholder,
      mode: props.mode
    }), renderOption);
  } // 日期选择器


  if (props.type === 'dataPicker') {
    renderController = React.createElement(DatePicker, _extends({}, props, {
      className: classnames('view-style', props.viewStyle),
      format: props.format ? props.format : 'YYYY-MM-DD HH:mm:ss',
      showTime: props.showTime ? props.showTime : 'HH:mm:ss',
      value: props.value ? moment(props.value) : moment(),
      onChange: function onChange(moments, dateStrings) {
        props.onChange && props.onChange(dateStrings, moments);
      },
      placeholder: props.placeholder !== undefined && props.placeholder != null ? props.placeholder : intlFormat('jlt.jltd.PleaseSelect', '请选择')
    }));
  } // 日期选择器


  if (props.type === 'JDatePicker') {
    renderController = React.createElement(JDatePicker, _extends({}, props, {
      className: classnames('view-style', props.viewStyle),
      format: props.format ? props.format : 'YYYY-MM-DD HH:mm:ss',
      value: props.value ? moment(props.value) : moment(),
      onChange: function onChange(moments, dateStrings) {
        props.onChange && props.onChange(dateStrings, moments);
      },
      placeholder: props.placeholder !== undefined && props.placeholder != null ? props.placeholder : intlFormat('jlt.jltd.PleaseSelect', '请选择')
    }));
  }

  if (props.type === 'rangePicker') {
    renderController = React.createElement(RangePicker // @ts-ignore
    , _extends({}, props, {
      value: props.DateBegin ? [moment(props.DateBegin), moment(props.DateEnd)] : [],
      className: classnames('view-style', props.viewStyle),
      onChange: function onChange(moments, dateStrings) {
        props.onChange && props.onChange(dateStrings[0], dateStrings[1], moments);
      },
      format: props.format ? props.format : 'YYYY-MM-DD HH:mm:ss',
      showTime: props.showTime !== true,
      placeholder: props.placeholder
    }));
  }
  /*
    lastModify：2018.6.20 by matt.huang
    content: 地区选择早期开发没有对第三级没有数据进行判断会报错所以进行添加假数据
     */


  if (props.type === 'cascader') {
    var ret = props.options.find(function (val) {
      return val.label === '北京';
    });
    renderController = React.createElement(Cascader, _extends({}, props, {
      allowClear: true,
      options: props.options,
      className: classnames('view-style', props.viewStyle),
      onChange: function onChange(value, options) {
        var newopations = options;

        if (newopations.length < 2) {
          return;
        }

        if (ret && newopations.length === 2) {
          newopations.push({
            id: '',
            pid: '',
            name: '',
            value: '',
            label: ''
          });
        }

        props.onChange(value, newopations);
      },
      changeOnSelect: true,
      disabled: props.disabled === true,
      placeholder: intlFormat('jlt.jltd.PleaseSelect', '请选择'),
      value: props.defaultValue ? props.defaultValue : props.value
    }));
  } // 勾选框


  if (props.type === 'checkbox') {
    renderController = React.createElement("div", {
      className: classnames('view-style', 'checkbox-style', props.viewStyle)
    }, React.createElement(Checkbox, {
      defaultChecked: props.defaultValue,
      className: 'view-style',
      onChange: props.onChange
    }));
  } // 范围输入框


  if (props.type === 'range') {
    var onChange = props.onChange,
        minValue = props.minValue,
        maxValue = props.maxValue,
        rest = __rest(props, ["onChange", "minValue", "maxValue"]);

    renderController = React.createElement(RanderRange, _extends({
      onChange: onChange,
      minValue: minValue,
      maxValue: maxValue
    }, rest));
  } // 自定义字典


  if (props.type === 'dataDictionary') {
    renderController = React.createElement(DataDictionaryComponents, {
      codeType: props.codeType,
      disabled: props.disabled || false,
      value: props.value,
      defaultValue: props.defaultValue,
      className: props.className || 'view-style',
      onChange: props.onChange,
      dropdownMatchSelectWidth: props.dropdownMatchSelectWidth === undefined ? true : props.dropdownMatchSelectWidth,
      mode: props.mode ? props.mode : '',
      style: props.style
    });
  } // br换行


  if (props.type === 'br') {
    return React.createElement("br", null);
  } //const span = props.span;


  if (props.type === 'div') {
    return React.createElement("div", {
      className: 'ant-label-controller-style'
    });
  }

  return React.createElement("div", {
    className: props.className || 'ant-label-controller-style'
  }, React.createElement("div", {
    className: props.labelClass || 'label-text'
  }, renderRequire, renderIconRequire, props.label), form ? renderFormItem(renderController) : renderController, props.monetary);
};

export default LabelWithController;
export { RanderRange };