function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from 'react';
import PropTypes from 'prop-types';
import omit from 'omit.js';
import map from './map';
import Form from '../form';
import Button from '../button';
import Row from '../row';
import Col from '../col';
var FormItem = Form.Item;

function generator(_ref) {
  var defaultProps = _ref.defaultProps,
      defaultRules = _ref.defaultRules,
      type = _ref.type;
  return function (WrappedComponent) {
    var _a;

    return _a =
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(BasicComponent, _React$Component);

      function BasicComponent(props) {
        var _this;

        _classCallCheck(this, BasicComponent);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(BasicComponent).call(this, props));

        _this.onGetCaptcha = function () {
          var count = 59;

          _this.setState({
            count: count
          });

          var onGetCaptcha = _this.props.onGetCaptcha;

          if (onGetCaptcha) {
            onGetCaptcha();
          }

          _this.interval = setInterval(function () {
            count -= 1;

            _this.setState({
              count: count
            });

            if (count === 0) {
              clearInterval(_this.interval);
            }
          }, 1000);
        };

        _this.state = {
          count: 0
        };
        return _this;
      }

      _createClass(BasicComponent, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var updateActive = this.context.updateActive;
          var name = this.props.name;

          if (updateActive) {
            updateActive(name);
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          clearInterval(this.interval);
        }
      }, {
        key: "render",
        value: function render() {
          var form = this.context.form;
          var getFieldDecorator = form.getFieldDecorator;
          var options = {};
          var otherProps = {};

          var _a = this.props,
              onChange = _a.onChange,
              defaultValue = _a.defaultValue,
              rules = _a.rules,
              name = _a.name,
              restProps = __rest(_a, ["onChange", "defaultValue", "rules", "name"]);

          var count = this.state.count;
          options.rules = rules || defaultRules;

          if (onChange) {
            options.onChange = onChange;
          }

          if (defaultValue) {
            options.initialValue = defaultValue;
          }

          otherProps = restProps || otherProps;

          if (type === 'Captcha') {
            var inputProps = omit(otherProps, ['onGetCaptcha']);
            return React.createElement(FormItem, null, React.createElement(Row, {
              gutter: 8
            }, React.createElement(Col, {
              span: 16
            }, getFieldDecorator(name, options)(React.createElement(WrappedComponent, _extends({}, defaultProps, inputProps)))), React.createElement(Col, {
              span: 8
            }, React.createElement(Button, {
              disabled: count,
              className: 'getCaptcha',
              size: "large",
              onClick: this.onGetCaptcha
            }, count ? "".concat(count, " s") : '获取验证码'))));
          }

          return React.createElement(FormItem, null, getFieldDecorator(name, options)(React.createElement(WrappedComponent, _extends({}, defaultProps, otherProps))));
        }
      }]);

      return BasicComponent;
    }(React.Component), _a.contextTypes = {
      form: PropTypes.object,
      updateActive: PropTypes.func
    }, _a;
  };
}

var LoginItem = {};
var imap = map;
Object.keys(imap).forEach(function (item) {
  LoginItem[item] = generator({
    defaultProps: imap[item].props,
    defaultRules: imap[item].rules,
    type: item
  })(imap[item].component);
});
export default LoginItem;