import Icon from 'antd/es/icon';
import Input from 'antd/es/input';
import * as React from 'react';
var map = {
  UserName: {
    component: Input,
    props: {
      size: 'large',
      prefix: React.createElement(Icon, {
        type: "user",
        className: 'prefixIcon'
      }),
      placeholder: 'admin'
    },
    rules: [{
      required: true,
      message: 'Please enter username!'
    }]
  },
  Password: {
    component: Input,
    props: {
      size: 'large',
      prefix: React.createElement(Icon, {
        type: "lock",
        className: 'prefixIcon'
      }),
      type: 'password',
      placeholder: '888888'
    },
    rules: [{
      required: true,
      message: 'Please enter password!'
    }]
  },
  Mobile: {
    component: Input,
    props: {
      size: 'large',
      prefix: React.createElement(Icon, {
        type: "mobile",
        className: 'prefixIcon'
      }),
      placeholder: 'mobile number'
    },
    rules: [{
      required: true,
      message: 'Please enter mobile number!'
    }, {
      pattern: /^1\d{10}$/,
      message: 'Wrong mobile number format!'
    }]
  },
  Captcha: {
    component: Input,
    props: {
      size: 'large',
      prefix: React.createElement(Icon, {
        type: "mail",
        className: 'prefixIcon'
      }),
      placeholder: 'captcha'
    },
    rules: [{
      required: true,
      message: 'Please enter Captcha!'
    }]
  }
};
export default map;