import * as React from 'react';
import Modal from 'antd/es/modal';
import { intlFormat } from '../_util/utils';

var ModalComponent = function ModalComponent(props) {
  var visible = props.visible,
      onConfirm = props.onConfirm,
      onCancel = props.onCancel,
      title = props.title,
      child = props.child,
      width = props.width,
      okText = props.okText,
      style = props.style;
  return React.createElement(Modal, {
    width: width || '50%',
    okText: okText || intlFormat('jlt.jltd.Confirm', '确认'),
    cancelText: intlFormat('jlt.jltd.Cancelled', '取消'),
    title: title,
    visible: visible,
    maskClosable: false,
    onOk: onConfirm,
    onCancel: onCancel,
    closable: true,
    style: style || ''
  }, child);
};

export default ModalComponent;