function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from 'react';
import Avatar from 'antd/es/avatar';
import List from 'antd/es/list';
import classNames from 'classnames';
var preCls = 'ant-pro-noticelist';
var Ilist = List;
export default function NoticeList(_ref) {
  var _ref$data = _ref.data,
      data = _ref$data === void 0 ? [] : _ref$data,
      _onClick = _ref.onClick,
      onClear = _ref.onClear,
      title = _ref.title,
      locale = _ref.locale,
      emptyText = _ref.emptyText,
      emptyImage = _ref.emptyImage;

  if (data.length === 0) {
    return React.createElement("div", {
      className: "".concat(preCls, "-notFound")
    }, emptyImage ? React.createElement("img", {
      src: emptyImage,
      alt: "not found"
    }) : null, React.createElement("div", null, emptyText || locale.emptyText));
  }

  return React.createElement("div", null, React.createElement(Ilist, {
    className: preCls
  }, data.map(function (item, i) {
    var itemCls = classNames('item', _defineProperty({}, 'read', item.read));
    return React.createElement(Ilist.Item, {
      className: itemCls,
      key: item.key || i,
      onClick: function onClick() {
        return _onClick(item);
      }
    }, React.createElement(List.Item.Meta, {
      className: 'meta',
      avatar: item.avatar ? React.createElement(Avatar, {
        className: 'avatar',
        src: item.avatar
      }) : null,
      title: React.createElement("div", {
        className: 'title'
      }, item.title, React.createElement("div", {
        className: 'extra'
      }, item.extra)),
      description: React.createElement("div", null, React.createElement("div", {
        className: 'description',
        title: item.description
      }, item.description), React.createElement("div", {
        className: 'datetime'
      }, item.datetime))
    }));
  })), React.createElement("div", {
    className: "".concat(preCls, "-clear"),
    onClick: onClear
  }, locale.clear, title));
}