function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
    if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  }
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};

import classNames from 'classnames';
import { connect } from 'dva';
import { routerRedux } from 'dva/router'; // @ts-ignore

import jp from 'jsonpath/jsonpath.min';
import pathToRegexp from 'path-to-regexp';
import PropTypes from 'prop-types';
import * as React from 'react';
import { createElement, PureComponent } from 'react';
import Breadcrumb from '../breadcrumb';
import Button from '../button';
import Icon from '../icon';
import Tabs from '../tabs';
import { intlFormat } from '../_util/utils';
var TabPane = Tabs.TabPane;
export function getBreadcrumb(breadcrumbNameMap, url) {
  var breadcrumb = breadcrumbNameMap[url];

  if (!breadcrumb) {
    Object.keys(breadcrumbNameMap).forEach(function (item) {
      if (pathToRegexp(item).test(url)) {
        breadcrumb = breadcrumbNameMap[item];
      }
    });
  }

  return breadcrumb || {};
}

var PageHeader =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(PageHeader, _PureComponent);

  function PageHeader(props) {
    var _this;

    _classCallCheck(this, PageHeader);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PageHeader).call(this, props));

    _this.mapkeys = function (menus, keys) {
      var breach = [];
      keys.forEach(function (key) {
        _this.mapMenus(menus, key, breach);
      });
      return breach;
    };

    _this.mapMenus = function (menus, key, breach) {
      menus.forEach(function (menu) {
        if (menu.path === key) {
          breach.push({
            name: menu.name,
            url: menu.path
          });
        }

        if (menu.children) {
          _this.mapMenus(menu.children, key, breach);
        }
      });
    };

    _this.getPath = function (path) {
      var val = path;

      if (val.indexOf('#') > 0) {
        val = val.split('#')[1];
      }

      return val;
    };

    _this.onChange = function (key) {
      var onTabChange = _this.props.onTabChange;

      if (onTabChange) {
        onTabChange(key);
      }
    };

    _this.getBreadcrumbProps = function () {
      var _this$props = _this.props,
          routes = _this$props.routes,
          params = _this$props.params,
          location = _this$props.location,
          breadcrumbNameMap = _this$props.breadcrumbNameMap;
      var _this$context = _this.context,
          croutes = _this$context.routes,
          cparams = _this$context.params,
          clocation = _this$context.location,
          cbreadcrumbNameMap = _this$context.breadcrumbNameMap;
      return {
        routes: routes || croutes,
        params: params || cparams,
        routerLocation: location || clocation,
        breadcrumbNameMap: breadcrumbNameMap || cbreadcrumbNameMap
      };
    };

    _this.getBreadcrumbDom = function () {
      var breadcrumb = _this.conversionBreadcrumbList();

      _this.setState({
        breadcrumb: breadcrumb
      });
    }; // Generated according to props


    _this.conversionFromProps = function () {
      var _this$props2 = _this.props,
          breadcrumbList = _this$props2.breadcrumbList,
          breadcrumbSeparator = _this$props2.breadcrumbSeparator,
          _this$props2$linkElem = _this$props2.linkElement,
          linkElement = _this$props2$linkElem === void 0 ? 'a' : _this$props2$linkElem;
      return React.createElement(Breadcrumb, {
        className: "breadcrumb",
        separator: breadcrumbSeparator
      }, breadcrumbList.map(function (item) {
        return React.createElement(Breadcrumb.Item, {
          key: item.title
        }, item.href ? createElement(linkElement, _defineProperty({}, linkElement === 'a' ? 'href' : 'to', item.href), item.title) : item.title);
      }));
    };

    _this.conversionFromLocation = function (_routerLocation, _breadcrumbNameMap, menudata) {
      var _this$props3 = _this.props,
          breadcrumbSeparator = _this$props3.breadcrumbSeparator,
          _this$props3$linkElem = _this$props3.linkElement,
          linkElement = _this$props3$linkElem === void 0 ? 'a' : _this$props3$linkElem;
      var title = _this.state.title; // Convert the url to an array

      var keys = _this.getDefaultCollapsedSubMenus(menudata); // Loop data mosaic routing


      var lastName = '';
      var extraBreadcrumbItems = keys.map(function (item, index) {
        var isLinkable = item.url.indexOf('/') > -1;
        var linkE = isLinkable ? linkElement : 'span';

        if (index === keys.length - 1) {
          lastName = item.name;
          linkE = linkElement;
        }

        return item.name && !item.hideInBreadcrumb ? React.createElement(Breadcrumb.Item, {
          key: item.url
        }, index === 0 && React.createElement(Icon, {
          type: "environment",
          style: {
            marginRight: 10
          },
          theme: "filled"
        }), createElement(linkE, _defineProperty({}, linkElement === 'a' ? 'href' : 'to', item.url), item.name)) : null;
      }); // Add home breadcrumbs to your head

      /* extraBreadcrumbItems.unshift(
        <Breadcrumb.Item separator="" key="index">
          <Icon type="environment" theme="filled" />
        </Breadcrumb.Item>,
      ); */

      if (lastName !== title) {
        extraBreadcrumbItems.push(React.createElement(Breadcrumb.Item, {
          key: "last"
        }, createElement('span', _defineProperty({}, linkElement === 'a' ? 'href' : 'to', '/'), title)));
      }

      return React.createElement(Breadcrumb, {
        className: "breadcrumb",
        separator: breadcrumbSeparator
      }, extraBreadcrumbItems);
    };
    /**
     * 将参数转化为面包屑
     * Convert parameters into breadcrumbs
     */


    _this.conversionBreadcrumbList = function () {
      var _this$props4 = _this.props,
          breadcrumbList = _this$props4.breadcrumbList,
          breadcrumbSeparator = _this$props4.breadcrumbSeparator;

      var _this$getBreadcrumbPr = _this.getBreadcrumbProps(),
          routes = _this$getBreadcrumbPr.routes,
          params = _this$getBreadcrumbPr.params,
          routerLocation = _this$getBreadcrumbPr.routerLocation,
          breadcrumbNameMap = _this$getBreadcrumbPr.breadcrumbNameMap;

      var menudata = _this.state.menudata;

      if (breadcrumbList && breadcrumbList.length) {
        return _this.conversionFromProps();
      } // 如果传入 routes 和 params 属性
      // If pass routes and params attributes


      if (routes && params) {
        return React.createElement(Breadcrumb, {
          className: "breadcrumb",
          routes: routes.filter(function (route) {
            return route.breadcrumbName;
          }),
          params: params,
          itemRender: _this.itemRender,
          separator: breadcrumbSeparator
        });
      } // 根据 location 生成 面包屑
      // Generate breadcrumbs based on location


      if (routerLocation && routerLocation.pathname) {
        return _this.conversionFromLocation(routerLocation, breadcrumbNameMap, menudata);
      }

      return null;
    }; // 渲染Breadcrumb 子节点
    // Render the Breadcrumb child node
    // @ts-ignore


    _this.itemRender = function (route, params, routes, paths) {
      var _this$props$linkEleme = _this.props.linkElement,
          linkElement = _this$props$linkEleme === void 0 ? 'a' : _this$props$linkEleme;
      var last = routes.indexOf(route) === routes.length - 1;
      return last || !route.component ? React.createElement("span", null, route.breadcrumbName) : createElement(linkElement, {
        href: paths.join('/') || '/',
        to: paths.join('/') || '/'
      }, route.breadcrumbName);
    };

    _this.backOnClick = function () {
      var onBack = _this.props.onBack;

      if (onBack) {
        onBack();
      } else {
        _this.props.dispatch(routerRedux.goBack());
      }
    };

    _this.state = {
      breadcrumb: null,
      title: props.title || '',
      menudata: _this.props.menudata || []
    };
    return _this;
  }

  _createClass(PageHeader, [{
    key: "getDefaultCollapsedSubMenus",
    value: function getDefaultCollapsedSubMenus(menudata) {
      var _this2 = this;

      var pathname = window.location.href.split('#')[1];

      if (pathname.indexOf('?') > -1) {
        pathname = pathname.split('?')[0];
      }

      var parentPathname = pathname.substring(0, pathname.lastIndexOf('/'));
      var nodes = jp.nodes(menudata, '$..path');
      var fd = nodes.find(function (value) {
        var val = value.value;

        if (val.indexOf('#') > 0) {
          val = val.split('#')[1];
        }

        return val.toLowerCase() === pathname.toLowerCase();
      });

      if (!fd) {
        fd = nodes.find(function (value) {
          var val = value.value;

          if (val.indexOf('#') > 0) {
            val = val.split('#')[1];
          }

          return val.toLowerCase() === parentPathname.toLowerCase();
        });
      }

      if (!fd) {
        return [];
      }

      var fdf = fd.path.filter(function (val) {
        if (typeof val === 'number') {
          return true;
        }

        return false;
      });
      var keys = fdf.map(function (val, i) {
        switch (i) {
          case 0:
            return _this2.getPath(menudata[val].path);

          case 1:
            return _this2.getPath(menudata[fdf[0]].children[val].path);

          case 2:
            return _this2.getPath(menudata[fdf[0]].children[fdf[1]].children[val].path);

          default:
            return null;
        }
      });
      return this.mapkeys(menudata, keys);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getBreadcrumbDom();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(preProps) {
      var tabActiveKey = this.props.tabActiveKey;

      if (preProps.tabActiveKey !== tabActiveKey) {
        this.getBreadcrumbDom();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this3 = this;

      if (nextProps.title !== this.state.title) {
        this.setState({
          title: nextProps.title
        }, function () {
          _this3.getBreadcrumbDom();
        });
      }

      if ("".concat(nextProps.menudata) !== "".concat(this.state.menudata)) {
        this.setState({
          menudata: nextProps.menudata
        }, function () {
          _this3.getBreadcrumbDom();
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          logo = _this$props5.logo,
          action = _this$props5.action,
          tabList = _this$props5.tabList,
          className = _this$props5.className,
          tabActiveKey = _this$props5.tabActiveKey,
          tabDefaultActiveKey = _this$props5.tabDefaultActiveKey,
          tabBarExtraContent = _this$props5.tabBarExtraContent,
          showBackBtn = _this$props5.showBackBtn,
          backBtn = _this$props5.backBtn,
          titleExtra = _this$props5.titleExtra,
          backTitle = _this$props5.backTitle,
          JButtonGroup = _this$props5.JButtonGroup;
      var breadcrumb = this.state.breadcrumb;
      var clsString = classNames('ant-page-header', className);
      var activeKeyProps = {};

      if (tabDefaultActiveKey !== undefined) {
        activeKeyProps.defaultActiveKey = tabDefaultActiveKey;
      }

      if (tabActiveKey !== undefined) {
        activeKeyProps.activeKey = tabActiveKey;
      }

      return React.createElement("div", {
        className: clsString
      }, breadcrumb, React.createElement("div", {
        className: "jlt-title-detail pageHeader"
      }, logo && React.createElement("div", {
        className: "logo"
      }, logo), React.createElement("div", {
        className: "jlt-title-main"
      }, React.createElement("div", {
        className: "page-header-row"
      }, JButtonGroup, action && React.createElement("div", {
        className: "action"
      }, action), titleExtra && titleExtra), React.createElement("div", {
        className: "jlt-page-header-backBtn"
      }, backBtn, showBackBtn && React.createElement(Button, {
        type: "ghost",
        onClick: this.backOnClick
      }, !backTitle && React.createElement(Icon, {
        type: "rollback"
      }), backTitle ? backTitle : intlFormat('jlt.jltd.Return', '返回'))))), tabList && tabList.length && React.createElement(Tabs, _extends({
        className: "tabs"
      }, activeKeyProps, {
        onChange: this.onChange,
        tabBarExtraContent: tabBarExtraContent
      }), tabList.map(function (item) {
        return React.createElement(TabPane, {
          tab: item.tab,
          key: item.key
        });
      })));
    }
  }]);

  return PageHeader;
}(PureComponent);

PageHeader.contextTypes = {
  routes: PropTypes.array,
  params: PropTypes.object,
  location: PropTypes.object,
  breadcrumbNameMap: PropTypes.object
};
PageHeader = __decorate([connect(function (_ref) {
  var _ref$global = _ref.global,
      global = _ref$global === void 0 ? {} : _ref$global;
  return {
    menudata: global.menudata
  };
})], PageHeader);
export default connect()(PageHeader);