function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import classnames from 'classnames';
import moment from 'moment';
import * as React from 'react';
import Cascader from '../calendar';
import Checkbox from '../checkbox';
import DataDictionaryComponents from '../DataDictionaryComponents';
import DatePicker from '../date-picker';
import Form from '../form';
import Icon from '../icon';
import Input from '../input';
import InputNumber from '../input-number';
import RanderRange from '../label-with-controller/RanderRange';
import Radio from '../radio';
import Select from '../select';
import city from '../_util/city';
import Enum from '../_util/enum';
var RangePicker = DatePicker.RangePicker;
var TextArea = Input.TextArea;
var Search = Input.Search;
var Option = Select.Option;
var RadioGroup = Radio.Group; // 获取FormItem

var FormItem = Form.Item;

var RowEditComponents =
/*#__PURE__*/
function (_React$Component) {
  _inherits(RowEditComponents, _React$Component);

  function RowEditComponents(props) {
    var _this;

    _classCallCheck(this, RowEditComponents);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RowEditComponents).call(this, props));
    /**
     * 创建FormItem
     * formItemProps: FormItem的属性
     * fileId: 控件的id，唯一标识
     * fieldOption: getFieldDecorator方法传入的option
     * field： 组件
     */

    _this.createFormItem = function (field) {
      var getFieldDecorator = _this.props.form.getFieldDecorator;
      var _this$props = _this.props,
          formItemProps = _this$props.formItemProps,
          fileId = _this$props.fileId,
          editable = _this$props.editable;
      var formItemProp = formItemProps == null ? _this.formItemLayout : formItemProps;
      return React.createElement("div", null, editable ? React.createElement(FormItem, formItemProp, getFieldDecorator(fileId == null ? '' : fileId, _this.fieldOption)(field)) : _this.noEditTableHandler());
    };

    _this.noEditTableHandler = function () {
      var value = _this.props.value;
      var renderController = null;

      if (_this.props.type === 'dataDictionary') {
        renderController = _this.editComponents(_this.props);
      } else if (_this.props.type === 'dataPicker') {
        var dateValue = value == null ? '' : value.format(_this.props.format || 'YYYY/MM/DD');
        renderController = React.createElement("span", null, dateValue);
      } else {
        renderController = React.createElement("span", null, value == null ? '' : value);
      }

      return renderController;
    };

    _this.createHiddenInput = function (field) {
      var _this$props2 = _this.props,
          fileId = _this$props2.fileId,
          editable = _this$props2.editable,
          value = _this$props2.value;
      var getFieldDecorator = _this.props.form.getFieldDecorator;
      return React.createElement("div", null, editable ? React.createElement(FormItem, null, getFieldDecorator(fileId == null ? '' : fileId, _this.fieldOption)(field)) : React.createElement("span", null, value == null ? '' : value));
    };

    _this.convertFormInfo = function () {
      if (_this.props.type === 'hidden') {
        var field1 = _this.props.field == null ? React.createElement(Input, {
          type: "hidden"
        }) : _this.props.field;
        return _this.createHiddenInput(field1);
      }

      var field = _this.props.field == null ? _this.editComponents(_this.props) : _this.props.field;
      return _this.createFormItem(field);
    };

    _this.regexValid = function (value, regex) {
      if (!regex.test(value)) {
        value = value.substring(0, value.lastIndexOf(value[value.length - 1]));
        value = _this.regexValid(value, regex);
      }

      return value;
    };

    _this.editComponents = function (props) {
      var renderController; // 输入框

      if (_this.props.type === 'input') {
        var valueProps = {};

        if (_this.props.value || _this.props.value === '') {
          valueProps.value = _this.props.value;
        }

        renderController = React.createElement(Input, _extends({
          maxLength: _this.props.maxLength || 50
        }, valueProps, {
          defaultValue: _this.props.defaultValue,
          placeholder: _this.props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          className: 'row-edit-view-style',
          disabled: _this.props.disabled === true,
          style: _this.props.style,
          onBlur: _this.onBlur.bind(_assertThisInitialized(_this), _this.props),
          onChange: function onChange(e) {
            if (_this.props.onChange) {
              _this.props.onChange(e.target.value);
            }
          }
        }));
      } // 输入框


      if (_this.props.type === 'inputNumber') {
        var _valueProps = {};

        if (_this.props.value || _this.props.value === '') {
          _valueProps.value = _this.props.value;
        }

        renderController = React.createElement(InputNumber, {
          max: _this.props.max,
          min: _this.props.min,
          precision: _this.props.precision,
          disabled: _this.props.disabled === true,
          onChange: _this.props.onChange,
          step: _this.props.step || 1,
          formatter: _this.props.formatter,
          parser: _this.props.parser
        });
      } // 多行输入框


      if (_this.props.type === 'textarea') {
        renderController = React.createElement(TextArea, {
          onBlur: function onBlur(e) {
            if (props.fileId) {
              var value = e.target.value;

              _this.props.form.setFieldsValue(_defineProperty({}, props.fileId, value.trim()));
            }
          },
          rows: _this.props.rows === undefined ? 4 : _this.props.rows,
          value: _this.props.value,
          placeholder: _this.props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          className: classnames('row-edit-view-style', _this.props.viewStyle),
          disabled: _this.props.disabled === true,
          style: _this.props.style,
          maxLength: props.maxLength || 255,
          onChange: function onChange(e) {
            if (_this.props.onChange) {
              _this.props.onChange(e.target.value);
            }
          }
        });
      } // 查询框


      if (_this.props.type === 'search') {
        renderController = React.createElement(Search, {
          defaultValue: _this.props.defaultValue,
          placeholder: _this.props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          onChange: _this.props.onChange,
          className: 'row-edit-view-style',
          enterButton: true,
          onSearch: _this.props.onSearch,
          readOnly: _this.props.readOnly
        });
      } // 选择框
      // 如果props.filterOption有方法，表示是带输入过滤的选择框模式


      if (_this.props.type === 'select') {
        var renderOption = (_this.props.optionData || []).map(function (option) {
          return React.createElement(Option, {
            key: option.value,
            value: option.value
          }, option.text);
        }); // 输入搜索模式

        var showSearch = false;
        var optionFilterProp = 'children';

        if (_this.props.filterOption) {
          showSearch = true;
        }

        renderController = React.createElement(Select, {
          disabled: _this.props.disabled === true || _this.props.disabled === 'true',
          showSearch: showSearch,
          optionFilterProp: optionFilterProp,
          value: _this.props.value,
          defaultValue: _this.props.defaultValue,
          onChange: _this.props.onChange,
          filterOption: _this.props.filterOption,
          style: _this.props.style || {
            width: 170
          },
          className: _this.props.className || 'row-edit-view-style',
          placeholder: _this.props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          dropdownMatchSelectWidth: _this.props.dropdownMatchSelectWidth === undefined ? true : _this.props.dropdownMatchSelectWidth
        }, renderOption);
      } // 日期选择器


      if (_this.props.type === 'dataPicker') {
        renderController = React.createElement(DatePicker, {
          className: 'row-edit-view-style',
          defaultValue: _this.props.defaultValue ? _this.props.defaultValue : null,
          format: _this.props.format || 'YYYY/MM/DD',
          showTime: true,
          onChange: function onChange(data, dateStrings) {
            if (_this.props.onChange) {
              _this.props.onChange(dateStrings, data);
            }
          },
          value: _this.props.value ? _this.props.value : null
        });
      }

      if (_this.props.type === 'rangePicker') {
        renderController = React.createElement(RangePicker, {
          value: _this.props.DateBegin ? [moment(_this.props.DateBegin), moment(_this.props.DateEnd)] : [],
          onChange: function onChange(moments, dateStrings) {
            if (_this.props.onChange) {
              _this.props.onChange(dateStrings[0], dateStrings[1], moments);
            }
          }
        });
      } // 勾选框


      if (_this.props.type === 'checkbox') {
        renderController = React.createElement(Checkbox, {
          defaultChecked: _this.props.defaultValue,
          onChange: _this.props.onChange
        });
      } // 范围输入框


      if (_this.props.type === 'range') {
        var _this$props3 = _this.props,
            onChange = _this$props3.onChange,
            minValue = _this$props3.minValue,
            maxValue = _this$props3.maxValue;
        renderController = React.createElement(RanderRange, {
          onChange: onChange,
          minValue: minValue,
          maxValue: maxValue
        });
      } // br换行


      if (_this.props.type === 'br') {
        return React.createElement("br", null);
      } // 单选按钮


      if (_this.props.type === 'radioGroup') {
        var renderRadio = (props.radioData || []).map(function (data) {
          return React.createElement(Radio, {
            key: data.value,
            value: data.value
          }, data.text);
        });
        renderController = React.createElement(RadioGroup, {
          onChange: function onChange(e) {
            //props.onChange == null ? '' : props.onChange(e.target.value);
            if (props.onChange) {
              props.onChange(e.target.value);
            }
          }
        }, renderRadio);
      }

      if (_this.props.type === 'dataDictionary') {
        renderController = React.createElement(DataDictionaryComponents, {
          allowClear: true,
          codeType: _this.props.codeType,
          editable: _this.props.editable != null,
          disabled: _this.props.disabled === true || _this.props.disabled === 'true',
          value: _this.props.value,
          defaultValue: _this.props.defaultValue,
          className: _this.props.className || 'row-edit-view-style',
          style: _this.props.style || {
            width: 170
          },
          onChange: _this.props.onChange,
          placeholder: _this.props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          dropdownMatchSelectWidth: _this.props.dropdownMatchSelectWidth === undefined ? true : _this.props.dropdownMatchSelectWidth,
          mode: _this.props.mode ? _this.props.mode : ''
        });
      }

      if (_this.props.type === 'cascader') {
        renderController = // @ts-ignore
        React.createElement(Cascader, {
          style: _this.props.style || {
            width: '100%'
          },
          options: city,
          placeholder: _this.props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          onChange: _this.props.onChange,
          disabled: _this.props.disabled === true || _this.props.disabled === 'true'
        });
      }

      if (_this.props.type === 'popWin') {
        var _valueProps2 = {};

        if (_this.props.value || _this.props.value === '') {
          _valueProps2.x2 = _this.props.value;
        }

        renderController = React.createElement(Input, _extends({}, _valueProps2, {
          defaultValue: _this.props.defaultValue,
          placeholder: _this.props.placeholder || Enum.DEFAULT_PLACEHOLDER,
          className: 'row-edit-view-style',
          readOnly: true,
          disabled: _this.props.disabled,
          style: _this.props.style,
          suffix: _this.props.value ? React.createElement("div", null, React.createElement(Icon, {
            type: "close",
            onClick: _this.props.clearData
          }), React.createElement(Icon, {
            type: "search",
            onClick: _this.props.modalShow
          })) : React.createElement(Icon, {
            type: "search",
            onClick: _this.props.modalShow
          })
        }));
      }

      return renderController;
    }; // formItem的布局样式


    _this.formItemLayout = {
      labelCol: {
        xs: {
          span: 24
        },
        sm: {
          span: 8
        }
      },
      wrapperCol: {
        xs: {
          span: 24
        },
        sm: {
          span: 16
        }
      }
    };
    _this.fieldOption = {};
    return _this;
  }

  _createClass(RowEditComponents, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.getRefForm != null) {
        this.props.getRefForm(this.props.form);
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextPorps) {
      if (nextPorps.fieldOption == null) {
        this.fieldOption = {
          initialValue: nextPorps.value
        };
      } else if (nextPorps.fieldOption.initialValue == null) {
        this.fieldOption = nextPorps.fieldOption;
        this.fieldOption.initialValue = nextPorps.value;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var renderController = this.convertFormInfo();
      return React.createElement("div", null, renderController);
    }
  }, {
    key: "onBlur",
    value: function onBlur(props) {
      var fileId = props.fileId.replace(/\d+$/gi, '');

      if (props.value === '') {
        this.props.form.setFields(_defineProperty({}, fileId, props.fieldOption));
      }
    }
  }]);

  return RowEditComponents;
}(React.Component);

export default RowEditComponents;