function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import update from 'immutability-helper';
import * as React from 'react';
import DatePicker from "../date-picker";
import Icon from "../icon";
import Input from "../input";
import Popconfirm from "../popconfirm";
import Table from "../table";

var moment = require('moment');

var EditableCell = function EditableCell(arr) {
  return React.createElement("div", null, arr.editable ? arr.datable ? React.createElement(DatePicker, {
    style: {
      margin: '-5px 0'
    },
    onChange: function onChange(moments, dateStrings) {
      arr.onChange(dateStrings, moments);
    },
    value: arr.value && moment(arr.value)
  }) : React.createElement(Input, {
    style: {
      margin: '-5px 0'
    },
    value: arr.value,
    onChange: function onChange(e) {
      return arr.onChange(e.target.value);
    }
  }) : arr.value);
};

var TableComponents =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TableComponents, _React$Component);

  function TableComponents(props) {
    var _this;

    _classCallCheck(this, TableComponents);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TableComponents).call(this, props));

    _this.onSelectChange = function (selectedRowKeys, selectedRows) {
      var onSelect = _this.props.onSelect;

      if (onSelect) {
        onSelect(selectedRowKeys, selectedRows);
      }
    };

    _this.getLastTableDataMap = function (key) {
      // 初始化table最后一行空数据
      var tableData = _this.props.tableData;
      var tableDataInfo = tableData[0] || {};
      var tableDataKey = Object.keys(tableDataInfo);
      var tableDataMap = {};
      tableDataKey.forEach(function (info) {
        tableDataMap[info] = '';
      });
      tableDataMap.editable = true;
      tableDataMap.key = key;
      tableDataMap.isLast = true;
      return tableDataMap;
    };

    _this.handleChange = function (value, record, column) {
      var newData = _toConsumableArray(_this.state.tableDataSource);

      var target = newData.filter(function (item) {
        return record.key === item.key;
      })[0];

      if (target) {
        target[column] = value;

        _this.setState({
          tableDataSource: newData
        });
      }
    };

    _this.renderColumns = function (text, record, column) {
      return React.createElement(EditableCell, {
        editable: record.editable,
        datable: column === 'wiqrProductTime',
        value: text,
        onChange: function onChange(value) {
          return _this.handleChange(value, record, column);
        }
      });
    };

    _this.columns = props.tableColumns.map(function (column) {
      return column.isRenderColumn ? column : update(column, {
        $merge: {
          render: function render(text, record) {
            var textTemp = column.valueChange ? column.valueChange(text) : text;
            return _this.renderColumns(textTemp, record, column.dataIndex);
          }
        }
      });
    });
    var isEditable = props.isEditable,
        isDeleteable = props.isDeleteable,
        isAddable = props.isAddable,
        isSave = props.isSave,
        isCancel = props.isCancel;

    if (isEditable || isDeleteable || isAddable) {
      var renderSave = function renderSave(index) {
        return React.createElement("a", {
          onClick: function onClick() {
            return _this.save(index);
          },
          style: {
            fontSize: '14px',
            color: '#595959'
          }
        }, isSave ? '保存' : React.createElement(Icon, {
          type: "save"
        }));
      };

      var renderClose = function renderClose(record, index) {
        if (record.isLast) {
          return;
        }

        return React.createElement(Popconfirm, {
          title: "\u771F\u7684\u8981\u53D6\u6D88\u5417?",
          onConfirm: function onConfirm() {
            return _this.cancel(index);
          }
        }, React.createElement("a", {
          style: {
            fontSize: '14px',
            color: '#595959'
          }
        }, isCancel ? '取消' : React.createElement(Icon, {
          type: "close"
        })));
      };

      _this.columns.push({
        title: '操作',
        dataIndex: 'operation',
        width: 100,
        fixed: 'right',
        align: 'center',
        render: function render(_text, record, index) {
          var editable = record.editable;
          return React.createElement("div", {
            className: "editable-row-operations"
          }, editable ? React.createElement("span", null, renderSave(index), React.createElement("span", {
            style: {
              marginLeft: '5%'
            }
          }), renderClose(record, index)) : React.createElement("span", null, isEditable && React.createElement("a", {
            className: 'table-componentsicon-style',
            onClick: function onClick() {
              return _this.edit(index);
            }
          }, React.createElement(Icon, {
            type: "edit"
          })), isDeleteable && React.createElement("a", {
            onClick: function onClick() {
              return _this["delete"](index);
            }
          }, React.createElement(Icon, {
            type: "delete"
          }))));
        }
      });
    }

    _this.state = {
      tableDataSource: _this.getTableDataSource(props.tableData, props.isAddable)
    };
    _this.cacheData = props.tableData.map(function (item) {
      return _extends({}, item);
    });
    return _this;
  }

  _createClass(TableComponents, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.tableData && nextProps.tableData !== this.props.tableData) {
        var tableDataSource = this.getTableDataSource(nextProps.tableData, nextProps.isAddable);
        this.cacheData = nextProps.tableData.map(function (item) {
          return _extends({}, item);
        }); // tableDataSource = tableDataSource.map((info, index) => {
        //   return update(info, {
        //     $merge: { key: index },
        //   });
        // });

        this.setState({
          tableDataSource: tableDataSource
        }, function () {});
      }
    }
  }, {
    key: "getTableDataSource",
    value: function getTableDataSource() {
      var tableData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var isAddable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var tableDataSource = tableData;

      if (isAddable) {
        //@ts-ignore
        tableDataSource = update(tableData, {
          $push: [this.getLastTableDataMap(tableData.length)]
        });
      }

      return tableDataSource;
    }
  }, {
    key: "delete",
    value: function _delete(index) {
      var _this2 = this;

      /* const tableDataSource = update(this.state.tableDataSource, {
            $splice: [[index, 1]],
          }); */
      var tableDataSource = this.state.tableDataSource;
      this.setState({
        tableDataSource: tableDataSource
      }, function () {
        var onDelete = _this2.props.onDelete;

        if (onDelete) {
          onDelete(tableDataSource[index], index, tableDataSource);
        }
      });
    }
  }, {
    key: "edit",
    value: function edit(index) {
      var target = update(this.state.tableDataSource[index], {
        $merge: {
          editable: true
        }
      });
      var tableDataSource = update(this.state.tableDataSource, {
        $splice: [[index, 1, target]]
      });
      this.setState({
        tableDataSource: tableDataSource
      });
    }
  }, {
    key: "save",
    value: function save(index) {
      var _this3 = this;

      var newData = _toConsumableArray(this.state.tableDataSource);

      var target = update(this.state.tableDataSource[index], {
        $merge: {
          editable: false,
          isLast: false
        }
      });
      var tableDataSource = update(this.state.tableDataSource, {
        $splice: [[index, 1, target]]
      });

      if (target) {
        delete target.editable;
        this.setState({
          tableDataSource: tableDataSource
        }, function () {
          var onEdit = _this3.props.onEdit;

          if (onEdit) {
            onEdit(tableDataSource[index], index, tableDataSource);
          }
        });
        this.cacheData = newData.map(function (item) {
          return _extends({}, item);
        });
      }
    }
  }, {
    key: "add",
    value: function add(key) {
      var _this4 = this;

      var tableDataSource = this.state.tableDataSource;

      var newData = _toConsumableArray(this.state.tableDataSource);

      var target = newData.filter(function (item) {
        return key === item.key;
      })[0];

      if (target) {
        delete target.editable;
        newData.push(this.getLastTableDataMap(tableDataSource.length));
        this.setState({
          tableDataSource: newData
        }, function () {
          var onAdd = _this4.props.onAdd;

          if (onAdd) {
            onAdd(tableDataSource, key);
          }
        });
        this.cacheData = newData.map(function (item) {
          return _extends({}, item);
        });
      }
    }
  }, {
    key: "cancel",
    value: function cancel(index) {
      var tableDataSource = update(this.state.tableDataSource, {
        $splice: [[index, 1, this.cacheData[index]]]
      });
      this.setState({
        tableDataSource: tableDataSource
      });
    }
  }, {
    key: "render",
    value: function render() {
      var tableDataSource = this.state.tableDataSource;
      var _this$props = this.props,
          selectedRowKeys = _this$props.selectedRowKeys,
          rowKey = _this$props.rowKey,
          _this$props$loading = _this$props.loading,
          loading = _this$props$loading === void 0 ? false : _this$props$loading;
      var rowSelection = {
        fixed: 'left',
        selectedRowKeys: selectedRowKeys,
        onChange: this.onSelectChange
      };
      return React.createElement(Table, {
        loading: loading,
        rowKey: rowKey,
        scroll: {
          x: 1400
        },
        rowSelection: rowSelection,
        dataSource: tableDataSource,
        columns: this.columns,
        onChange: this.props.onChange // 分页、排序、筛选变化时触发
        ,
        pagination: this.props.pagination || false
      });
    }
  }]);

  return TableComponents;
}(React.Component);

export default TableComponents;