var currencySort = '';
var country = 'zh'; // 获取币种

var getCurrency = function getCurrency(def) {
  var currency = def;

  if (currencySort) {
    currency = currencySort;
  }

  return currency;
}; // 设置币种


var setCurrency = function setCurrency(cur) {
  validator.currencySort = cur;
  currencySort = cur;
}; // 设置币种


var setCountry = function setCountry(ctry) {
  validator.country = ctry;
  country = ctry;
}; // 获取本地化


var localGet = function localGet(key, def, value) {
  var reg = def || '';

  if (key) {
    var keys = key.split('.');
    var tmp = '';

    if (keys.length > 2) {
      tmp = validator[keys[2]][country];
    }

    if (tmp) {
      reg = tmp;
    }

    if (keys[1] === 'currency') {
      reg = getCurrency(def);

      if (value !== undefined && (value === '' || value === null)) {
        reg = '';
      }
    }

    if (country !== 'zh' && keys[1] !== 'currency') {
      reg = /[\d\D]*/;
    }
  }

  return reg;
}; // 正则


var validator = {
  carNo: {
    zh: /^[\u4e00-\u9fa5]{1}[A-Z]{1}[A-Z_0-9]{5}$/
  },
  ID: {
    zh: /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/
  },
  mobilePhoneNo: {
    zh: /^1\d{10}$/
  },
  fixedPhoneNo: {
    zh: /^(0\d{2,4}-?\d{7,8}|\d{7,8})$/
  },
  driveLisence: {
    zh: /^[1-9][0-9]{5}(19[0-9]{2}|200[0-9]|2010)(0[1-9]|1[0-2])(0[1-9]|[12][0-9]|3[01])[0-9]{3}[0-9xX]$/i
  },
  fixedOrMobileNo: {
    zh: /^1\d{10}$|^(0\d{2,4}-?\d{7,8}|\d{7,8})$|^(1\d{10}\/(0\d{2,4}-?\d{7,8}|\d{7,8}))$/
  },
  setCurrency: setCurrency,
  setCountry: setCountry,
  localGet: localGet,

  get country() {
    return country;
  },

  set country(value) {
    country = value;
  },

  currencySort: currencySort,
  provinceId: 99,
  provinceName: '新加坡省',
  cityId: 99,
  cityName: '新加坡市',
  areaId: 99,
  areaName: '新加坡区'
};
export default validator;