"use strict";

var fs = require('fs');

{
  // 表单提示label修改
  var paths = ['./node_modules/async-validator/es/util.js', './node_modules/jltd/node_modules/async-validator/es/util.js', './node_modules/antd/node_modules/async-validator/es/util.js', './node_modules/rc-form/node_modules/async-validator/es/util.js'];
  paths.map(function (pathItem) {
    var result = fs.existsSync(pathItem);

    if (result) {
      var body = fs.readFileSync(pathItem, 'utf-8');
      body = body.replace('field: oe.field || rule.fullField', 'field: oe.field || rule.field');
      fs.writeFileSync(pathItem, body);
    }
  });
}
{
  // 表单类型校验过滤
  var _paths = ["./node_modules/async-validator/es/rule/type.js", "./node_modules/jltd/node_modules/async-validator/es/rule/type.js", "./node_modules/antd/node_modules/async-validator/es/rule/type.js", "./node_modules/rc-form/node_modules/async-validator/es/rule/type.js"];

  _paths.map(function (pathItem) {
    var result = fs.existsSync(pathItem);

    if (result) {
      var body = fs.readFileSync(pathItem, 'utf-8');
      if (body.indexOf('return\n\tvar custom') >= 0) return;
      body = body.replace('var custom', 'return\n\tvar custom');
      fs.writeFileSync(pathItem, body);
    }
  });
}
{
  // 表单校验null处理
  var _paths2 = ['./node_modules/async-validator/es/validator/', './node_modules/antd/node_modules/async-validator/es/validator/', './node_modules/jltd/node_modules/async-validator/es/validator/', './node_modules/rc-form/node_modules/async-validator/es/validator/'];

  _paths2.map(function (pathItem) {
    var result = fs.existsSync(pathItem);

    if (result) {
      var filedirs = fs.readdirSync(pathItem);
      filedirs.map(function (filename) {
        var filedir = pathItem + filename;
        var data = fs.readFileSync(filedir, 'utf-8');
        if (data.indexOf('value !== undefined && value !== null') >= 0) return;
        data = data.replace('value !== undefined', 'value !== undefined && value !== null');
        fs.writeFileSync(filedir, data);
      });
    }
  });
}
{
  // 国际化处理
  var _paths3 = ['./node_modules/react-intl/lib/index.es.js', './node_modules/jltd/node_modules/react-intl/lib/index.es.js'];

  _paths3.map(function (pathItem) {
    var result = fs.existsSync(pathItem);

    if (result) {
      var data = fs.readFileSync(pathItem, 'utf-8');

      if (data.indexOf('!message') < 0) {
        var _replaceStr = "if(!message){config.onError('Missing message:',{id:id,defaultMessage:defaultMessage});}\n\t\tif (hasValues){\n\t\t\tvar formatter = state.getMessageFormat(message||defaultMessage, locale, formats);\n\t\t\tformattedMessage = formatter.format(values);\n\t\t\treturn formattedMessage;\n\t\t}\n\t\treturn message || defaultMessage || id;";
        data = data.replace("return message || defaultMessage || id;", _replaceStr);
        data = data.replace('!hasValues &&', '');
      }

      var replaceStr = "onError(createError('Missing message: \"' + id + '\" for locale: \"' + locale + '\"' + (defaultMessage ? ', using default message as fallback.' : '')),{id:id, defaultMessage:defaultMessage,err:true})";
      data = data.replace("onError(createError('Missing message: \"' + id + '\" for locale: \"' + locale + '\"' + (defaultMessage ? ', using default message as fallback.' : '')))", replaceStr);
      fs.writeFileSync(pathItem, data);
    }
  });
}