"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _request = _interopRequireDefault(require("../_util/request"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : new P(function (resolve) {
        resolve(result.value);
      }).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

if (!window.global) {
  window.global = {};
}

var uuidCompact = function uuidCompact() {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    // tslint:disable-next-line:no-bitwise
    var r = Math.random() * 16 | 0; // tslint:disable-next-line:no-bitwise

    var v = c === 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
};

var setUrl = function setUrl(menuUrl, urlConfig) {
  var uuid = uuidCompact().replace(/-/g, '');
  var absolutePath = menuUrl;
  var path = menuUrl;

  if (menuUrl.indexOf('http') >= 0) {
    return path;
  }

  var paths = absolutePath.split('/');
  var moduleName = paths[1];
  var basePath = urlConfig.basePath;
  var currentUrl = window.location.href;
  var urlPath = [];

  if (currentUrl.indexOf(basePath) !== -1) {
    urlPath = currentUrl.substring(currentUrl.indexOf(basePath) + basePath.length).split('/');
  }

  if (moduleName && urlConfig[moduleName.toLowerCase()] && currentUrl.indexOf(urlConfig[moduleName.toLowerCase()]) === -1) {
    path = "".concat(urlConfig[moduleName]).concat(moduleName, "/index.html?").concat(uuid, "#").concat(absolutePath);

    if (document.location.port === '8000') {
      path = absolutePath;
    }
  } else if (moduleName && urlPath.length > 0 && urlPath[0] !== moduleName) {
    path = "".concat(basePath + moduleName, "/index.html?").concat(uuid, "#").concat(absolutePath);

    if (document.location.port === '8000') {
      path = absolutePath;
    }
  } else {
    path = absolutePath;
  }

  return path;
};

if (!window.locals) {
  window.locals = {
    language: 'zh',
    messages: {}
  };
}

var formatter = function formatter(data, urlConfig) {
  return data.map(function (item) {
    var menuUrl = item.menuUrl;

    if (item.children) {
      menuUrl = "".concat(item.menuId);
    }

    if (!item.children) {
      if (menuUrl.indexOf('/') !== 0) {
        menuUrl = "/".concat(menuUrl);
      }

      menuUrl = setUrl(menuUrl, urlConfig);
    }

    var result = {
      name: item.menuName,
      path: menuUrl,
      pathname: "".concat(item.menuUrl),
      authority: 'admin',
      code: item.menuCode
    };

    if ("".concat(item.menuUrl).indexOf('http') >= 0) {
      result.path = "".concat(item.menuUrl);
    }

    if (item.iconClass) {
      result.icon = item.iconClass.replace(/(anticon\santicon-)/g, '');
    }

    if (item.children) {
      result.children = formatter(item.children, urlConfig);
    }

    return result;
  });
};

function getCode(menuList, path) {
  // eslint-disable-next-line
  return menuList.find(function (item) {
    if (item.pathname === path) {
      window.global.menuCode = item.code;
      return true;
    }

    if (item.children && item.children.length > 0) {
      return getCode(item.children, path);
    }
  });
} // 设置默认语言


function setIntl(params) {
  return __awaiter(this, void 0, void 0,
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee() {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", (0, _request["default"])("../locale/setLocale?locale=".concat(params.payload), {
              method: 'GET'
            }));

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
} // 获取默认语言


function getIntl() {
  return __awaiter(this, void 0, void 0,
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2() {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt("return", (0, _request["default"])('../locale/getLocale', {
              method: 'GET'
            }));

          case 1:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
} // 获取菜单


function getMenu() {
  return __awaiter(this, void 0, void 0,
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee3() {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", (0, _request["default"])('../system/getMenu', {}));

          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
} // 获取Url


function getUrlConfig() {
  return __awaiter(this, void 0, void 0,
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee4() {
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt("return", (0, _request["default"])('../rest/getUrlConfig', {}));

          case 1:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
}

function setAuthority(authority) {
  return localStorage.setItem('antd-pro-authority', authority);
}

var globalmedal = function globalmedal(config, getMenuData) {
  var menudata = [];

  if (config.readLocalMenu) {
    menudata = getMenuData();
  }

  return {
    namespace: 'global',
    state: {
      collapsed: false,
      notices: [],
      load: true,
      menudata: menudata,
      urlConfig: '',
      locals: window.locals.language,
      localMessage: {}
    },
    effects: {
      setLocalStateCall:
      /*#__PURE__*/
      _regenerator["default"].mark(function setLocalStateCall(_ref, _ref2) {
        var payload, call, getLg;
        return _regenerator["default"].wrap(function setLocalStateCall$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                payload = _ref.payload;
                call = _ref2.call;
                _context5.next = 4;
                return call(setIntl, {
                  payload: payload
                });

              case 4:
                _context5.next = 6;
                return call(getIntl);

              case 6:
                getLg = _context5.sent;

                if (getLg && getLg.data === payload) {
                  location.reload(); // yield put({
                  //   type: 'setLocalState',
                  //   payload,
                  // });
                }

              case 8:
              case "end":
                return _context5.stop();
            }
          }
        }, setLocalStateCall);
      }),
      fetchMenu:
      /*#__PURE__*/
      _regenerator["default"].mark(function fetchMenu(_, _ref3) {
        var call, put, urlconfigRes, menuRes;
        return _regenerator["default"].wrap(function fetchMenu$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                call = _ref3.call, put = _ref3.put;
                setAuthority('admin');
                _context6.next = 4;
                return call(getUrlConfig);

              case 4:
                urlconfigRes = _context6.sent;
                _context6.next = 7;
                return call(getMenu);

              case 7:
                menuRes = _context6.sent;

                if (!(urlconfigRes && urlconfigRes.data)) {
                  _context6.next = 11;
                  break;
                }

                _context6.next = 11;
                return put({
                  type: 'saveUrlConfig',
                  payload: urlconfigRes.data
                });

              case 11:
                if (!(menuRes && menuRes.data && menuRes.data.length > 0)) {
                  _context6.next = 14;
                  break;
                }

                _context6.next = 14;
                return put({
                  type: 'saveMenu',
                  payload: formatter(menuRes.data, urlconfigRes.data)
                });

              case 14:
              case "end":
                return _context6.stop();
            }
          }
        }, fetchMenu);
      })
    },
    reducers: {
      saveLocalMessage: function saveLocalMessage(state, _ref4) {
        var payload = _ref4.payload;
        var localMessage = state.localMessage;
        localMessage[payload.locals] = payload.messages;
        return _extends({}, state, {
          localMessage: localMessage
        });
      },
      changeLayoutCollapsed: function changeLayoutCollapsed(state, _ref5) {
        var payload = _ref5.payload;
        return _extends({}, state, {
          collapsed: payload
        });
      },
      saveUrlConfig: function saveUrlConfig(state, _ref6) {
        var payload = _ref6.payload;
        return _extends({}, state, {
          urlConfig: payload
        });
      },
      setLocalState: function setLocalState(state, _ref7) {
        var payload = _ref7.payload;
        return _extends({}, state, {
          locals: payload
        });
      },
      saveMenu: function saveMenu(state, _ref8) {
        var payload = _ref8.payload;
        return _extends({}, state, {
          menudata: payload
        });
      },
      checkMenu: function checkMenu(state, _ref9) {
        var payload = _ref9.payload;

        if (state.menudata.length > 0) {
          getCode(state.menudata, payload.pathname);
        }

        return state;
      }
    },
    subscriptions: {
      setup: function setup(_ref10) {
        var history = _ref10.history,
            dispatch = _ref10.dispatch;
        return history.listen(function (_ref11) {
          var pathname = _ref11.pathname,
              search = _ref11.search;

          if (typeof window.ga !== 'undefined') {
            window.ga('send', 'pageview', pathname + search);
          }

          dispatch({
            type: 'checkMenu',
            payload: {
              pathname: pathname
            }
          });
        });
      }
    }
  };
};

var _default = globalmedal;
exports["default"] = _default;