"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _dva = require("dva");

var React = _interopRequireWildcard(require("react"));

var _button = _interopRequireDefault(require("../button"));

var _dropdown = _interopRequireDefault(require("../dropdown"));

var _icon = _interopRequireDefault(require("../icon"));

var _menu = _interopRequireDefault(require("../menu"));

var _popconfirm = _interopRequireDefault(require("../popconfirm"));

var _utils = require("../_util/utils");

var _buttonPermission = _interopRequireDefault(require("./buttonPermission"));

var _importExcel = _interopRequireDefault(require("./importExcel"));

var _operationButtonGroup = _interopRequireDefault(require("./operationButtonGroup"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var SubMenu = _menu["default"].SubMenu;

var renderButton = function renderButton(buttonInfo) {
  var disabled = buttonInfo.disabled;

  if ((buttonInfo.loading || buttonInfo.text === '保存') && buttonInfo.load) {
    disabled = true;
  }

  return buttonInfo.templateId ? React.createElement(_importExcel["default"], {
    buttonInfo: buttonInfo
  }) : React.createElement(_button["default"], _extends({
    disabled: disabled,
    className: (0, _classnames["default"])('button-group', buttonInfo.className),
    type: buttonInfo.type || 'default',
    size: buttonInfo.size || 'default',
    onClick: buttonInfo.onClick
  }, buttonInfo), buttonInfo.text);
};

var renderMenuItem = function renderMenuItem(buttonInfo) {
  return buttonInfo.templateId ? React.createElement(_importExcel["default"], {
    buttonInfo: buttonInfo,
    buttonType: "a"
  }) : React.createElement("a", {
    onClick: buttonInfo.onClick
  }, buttonInfo.text);
};

var renderDropdown = function renderDropdown(buttonInfo) {
  var menu = React.createElement(_menu["default"], null, buttonInfo.children.map(function (opt, index) {
    return React.createElement(_menu["default"].Item, {
      key: index,
      disabled: opt.disabled
    }, renderDefaultMenu(opt));
  }));
  return React.createElement(_dropdown["default"], {
    overlay: menu
  }, React.createElement(_button["default"], {
    className: "button-group"
  }, buttonInfo.text, " ", React.createElement(_icon["default"], {
    type: "down"
  })));
};

var renderSubMenu = function renderSubMenu(buttonInfo) {
  return React.createElement(SubMenu, {
    title: buttonInfo.text,
    key: "sub-button"
  }, buttonInfo.children.map(function (opt, index) {
    return React.createElement(_menu["default"].Item, {
      key: index,
      disabled: opt.disabled
    }, renderDefaultMenu(opt));
  }));
};

var renderDefaultButton = function renderDefaultButton(buttonInfo) {
  if (buttonInfo.popconfirmTitle) {
    return React.createElement(_popconfirm["default"], {
      placement: "top",
      title: buttonInfo.popconfirmTitle,
      onConfirm: buttonInfo.onClick,
      okText: (0, _utils.intlFormat)('jlt.jltd.Confirm', '确定'),
      cancelText: (0, _utils.intlFormat)('jlt.jltd.Cancelled', '取消')
    }, React.createElement(NewGlobalBotton, {
      buttonInfo: _extends({}, buttonInfo, {
        onClick: null
      })
    }), ";");
  }

  return React.createElement(NewGlobalBotton, {
    buttonInfo: buttonInfo
  });
};

var renderDefaultMenu = function renderDefaultMenu(buttonInfo) {
  if (buttonInfo.popconfirmTitle) {
    return React.createElement(_popconfirm["default"], {
      placement: "top",
      title: buttonInfo.popconfirmTitle,
      onConfirm: buttonInfo.onClick,
      okText: (0, _utils.intlFormat)('jlt.jltd.Confirm', '确定'),
      cancelText: (0, _utils.intlFormat)('jlt.jltd.Cancelled', '取消')
    }, renderMenuItem(_extends({}, buttonInfo, {
      onClick: null
    })));
  }

  return renderMenuItem(buttonInfo);
};

var buttonGroup = function buttonGroup() {
  var buttonOptList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var filterButtonOptList = _buttonPermission["default"].filterPermission(buttonOptList);

  var defaultBtnOptList = filterButtonOptList.slice(0, 5);
  var dropdownBtnOptList = filterButtonOptList.slice(5);
  var menu = React.createElement(_menu["default"], null, dropdownBtnOptList.map(function (opt, index) {
    if (opt.children && opt.children.length > 0) {
      renderSubMenu(opt);
    }

    return React.createElement(_menu["default"].Item, {
      key: index,
      disabled: opt.disabled
    }, renderDefaultMenu(opt));
  }));
  var buttonList = defaultBtnOptList.map(function (buttonInfo) {
    return React.createElement("span", {
      key: buttonInfo.text,
      style: {
        display: 'inline-block'
      }
    }, buttonInfo.children && buttonInfo.children.length > 0 ? renderDropdown(buttonInfo) : renderDefaultButton(buttonInfo));
  });

  if (dropdownBtnOptList.length > 0) {
    buttonList.push(React.createElement(_dropdown["default"], {
      overlay: menu,
      key: "more"
    }, React.createElement(_button["default"], {
      className: "button-group"
    }, (0, _utils.intlFormat)('jlt.jltd.More', '更多'), " ", React.createElement(_icon["default"], {
      type: "down"
    }))));
  }

  return buttonList;
};

var GlobalButton =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(GlobalButton, _React$PureComponent);

  function GlobalButton() {
    _classCallCheck(this, GlobalButton);

    return _possibleConstructorReturn(this, _getPrototypeOf(GlobalButton).apply(this, arguments));
  }

  _createClass(GlobalButton, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "render",
    value: function render() {
      return renderButton(_extends({}, this.props.buttonInfo, {
        load: this.props.load,
        dispatch: this.props.dispatch
      }));
    }
  }]);

  return GlobalButton;
}(React.PureComponent);

var NewGlobalBotton = (0, _dva.connect)(function (_ref) {
  var global = _ref.global;
  return {
    load: global.load
  };
})(GlobalButton);
buttonGroup.operationButtonGroup = _operationButtonGroup["default"];
buttonGroup.renderButton = renderButton;
var _default = buttonGroup;
exports["default"] = _default;