"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _button = _interopRequireDefault(require("antd/es/button"));

var _popconfirm = _interopRequireDefault(require("antd/es/popconfirm"));

var _icon = _interopRequireDefault(require("antd/es/icon"));

var _buttonPermission = _interopRequireDefault(require("./buttonPermission"));

var _utils = require("../_util/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

var operationButtonGroup = function operationButtonGroup() {
  var buttonList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var filterButtonList = _buttonPermission["default"].filterPermission(buttonList);

  var operationButtonList = filterButtonList.map(function (buttonInfo) {
    var renderIcon = React.createElement("a", {
      onClick: buttonInfo.onClick
    }, React.createElement(_icon["default"], {
      type: buttonInfo.iconType,
      style: {
        color: '#0078D6',
        width: '20px',
        height: '20px'
      }
    }));
    var renderButton = buttonInfo.iconType ? renderIcon : React.createElement(_button["default"], {
      className: "operation-btn",
      type: buttonInfo.type || 'default',
      size: buttonInfo.size || 'default',
      onClick: buttonInfo.onClick
    }, buttonInfo.text);
    var renderPopconfirm = React.createElement(_popconfirm["default"], {
      placement: "topRight",
      title: buttonInfo.popconfirmTitle,
      onConfirm: buttonInfo.onClick,
      okText: (0, _utils.intlFormat)('jlt.jltd.Confirm', '确定'),
      cancelText: (0, _utils.intlFormat)('jlt.jltd.Cancelled', '取消')
    }, buttonInfo.iconType ? React.createElement("a", null, React.createElement(_icon["default"], {
      type: buttonInfo.iconType,
      style: {
        color: '#0078D6',
        width: '20px',
        height: '20px',
        paddingLeft: '12px'
      }
    })) : React.createElement(_button["default"], {
      className: "operation-btn",
      type: buttonInfo.type || 'default',
      size: buttonInfo.size || 'default'
    }, buttonInfo.text));
    return React.createElement("span", {
      key: buttonInfo.text
    }, buttonInfo.popconfirmTitle ? renderPopconfirm : renderButton);
  });
  return operationButtonList;
};

var _default = operationButtonGroup;
exports["default"] = _default;