"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _button = _interopRequireDefault(require("antd/es/button"));

var _popconfirm = _interopRequireDefault(require("antd/es/popconfirm"));

var _utils = require("../_util/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var getOptionDataText = function getOptionDataText(list, value) {
  var text = null;
  list && list.some(function (data) {
    if (!data || data.value !== value) {
      return false;
    }

    text = data.text;
    return true;
  });
  return text || value; // 找不到对应值，显示value
};

var searchButtonGroup = function searchButtonGroup() {
  var buttonList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return buttonList.map(function (buttonInfo) {
    var renderButton = React.createElement(_button["default"], {
      className: "button-group",
      type: getOptionDataText([], buttonInfo.type),
      size: buttonInfo.size || 'default',
      onClick: buttonInfo.onClick
    }, buttonInfo.text);
    var renderPopconfirm = React.createElement(_popconfirm["default"], {
      placement: "topRight",
      title: buttonInfo.popconfirmText,
      onConfirm: buttonInfo.onClick,
      okText: (0, _utils.intlFormat)('jlt.jltd.Confirm', '确定'),
      cancelText: (0, _utils.intlFormat)('jlt.jltd.Cancelled', '取消')
    }, React.createElement(_button["default"], {
      className: "button-group",
      type: "primary",
      size: buttonInfo.size || 'default'
    }, buttonInfo.text));
    return React.createElement("span", {
      key: buttonInfo.text
    }, buttonInfo.isPopconfirm ? renderPopconfirm : renderButton);
  });
};

var _default = searchButtonGroup;
exports["default"] = _default;