"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _form = _interopRequireDefault(require("../form"));

var _input = _interopRequireDefault(require("../input"));

var _select = _interopRequireDefault(require("../select"));

var _datePicker = _interopRequireDefault(require("antd/es/date-picker"));

var _checkbox = _interopRequireDefault(require("../checkbox"));

var _radio = _interopRequireDefault(require("../radio"));

var _classnames = _interopRequireDefault(require("classnames"));

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// import DataDictionaryComponents from '../../DataDictionaryComponents';
var RangePicker = _datePicker["default"].RangePicker;
var TextArea = _input["default"].TextArea;
var Search = _input["default"].Search;
var Option = _select["default"].Option;
var RadioGroup = _radio["default"].Group; // 获取FormItem

var FormItem = _form["default"].Item;

var EditableCell =
/*#__PURE__*/
function (_React$Component) {
  _inherits(EditableCell, _React$Component);

  function EditableCell(props) {
    var _this;

    _classCallCheck(this, EditableCell);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(EditableCell).call(this, props));
    /**
     * 创建FormItem
     * formItemProps: FormItem的属性
     * fieldId: 控件的id，唯一标识
     * fieldOption: getFieldDecorator方法传入的option
     * field： 组件
     */

    _this.createFormItem = function (field) {
      var _this$props = _this.props,
          fieldId = _this$props.fieldId,
          editable = _this$props.editable,
          value = _this$props.value,
          form = _this$props.form;
      var getFieldDecorator = form.getFieldDecorator;
      var options = _this.fieldOption;

      if (!options.initialValue) {
        options.initialValue = value;
      }

      return _react["default"].createElement("div", null, editable ? _react["default"].createElement(FormItem, null, getFieldDecorator(fieldId == null ? '' : fieldId, options)(field)) : _react["default"].createElement("span", null, value == null ? '' : value));
    };

    _this.createHiddenInput = function (field) {
      var _this$props2 = _this.props,
          fieldId = _this$props2.fieldId,
          editable = _this$props2.editable,
          value = _this$props2.value,
          form = _this$props2.form;
      var getFieldDecorator = form.getFieldDecorator;
      return _react["default"].createElement("div", null, editable ? _react["default"].createElement(FormItem, null, getFieldDecorator(fieldId == null ? '' : fieldId, _this.fieldOption)(field)) : _react["default"].createElement("span", null, value == null ? '' : value));
    };

    _this.convertFormInfo = function () {
      var field;

      if (_this.props.type === 'hidden') {
        field = _this.props.field == null ? _react["default"].createElement(_input["default"], {
          type: "hidden"
        }) : _this.props.field;
        return _this.createHiddenInput(field);
      }

      field = _this.props.field == null ? _this.editComponents() : _this.props.field;
      return _this.createFormItem(field);
    };

    _this.editComponents = function () {
      switch (_this.props.type) {
        case 'input':
          return _react["default"].createElement(_input["default"], {
            maxLength: _this.props.maxLength,
            placeholder: _this.props.placeholder,
            className: 'editable-cell-view-style',
            disabled: _this.props.disabled === true,
            style: _this.props.style,
            onBlur: function onBlur(e) {
              if (_this.props.onBlur) {
                _this.props.onBlur(e.target.value);
              }
            },
            onChange: function onChange(e) {
              if (_this.props.onChange) {
                _this.props.onChange(e.target.value);
              }
            }
          });

        case 'textarea':
          return _react["default"].createElement(TextArea, {
            rows: _this.props.rows === undefined ? 4 : _this.props.rows,
            value: _this.props.value,
            placeholder: _this.props.placeholder,
            className: (0, _classnames["default"])('editable-cell-view-style', _this.props.viewStyle),
            disabled: _this.props.disabled === true,
            style: _this.props.style,
            onChange: function onChange(e) {
              if (_this.props.onChange) {
                _this.props.onChange(e.target.value);
              }
            }
          });

        case 'search':
          return _react["default"].createElement(Search, {
            defaultValue: _this.props.defaultValue,
            placeholder: _this.props.placeholder,
            onSearch: _this.props.onChange,
            className: 'editable-cell-view-style',
            onClick: _this.props.onClick
          });

        case 'select':
          var _this$props3 = _this.props,
              className = _this$props3.className,
              disabled = _this$props3.disabled,
              dropdownMatchSelectWidth = _this$props3.dropdownMatchSelectWidth,
              filterOption = _this$props3.filterOption,
              onChange = _this$props3.onChange,
              optionData = _this$props3.optionData,
              placeholder = _this$props3.placeholder,
              style = _this$props3.style;
          var renderOption = (optionData || []).map(function (option) {
            return _react["default"].createElement(Option, {
              key: option.value,
              value: option.value
            }, option.text);
          }); // 输入搜索模式

          var showSearch = false; // 如果props.filterOption有方法，表示是带输入过滤的选择框模式

          if (filterOption) {
            showSearch = true;
          }

          return _react["default"].createElement(_select["default"], {
            disabled: disabled === true || disabled === 'true',
            showSearch: showSearch,
            optionFilterProp: "children",
            onChange: onChange,
            filterOption: filterOption,
            style: style || {
              width: 170
            },
            className: className || 'editable-cell-view-style',
            dropdownMatchSelectWidth: dropdownMatchSelectWidth === undefined ? true : dropdownMatchSelectWidth,
            placeholder: placeholder
          }, renderOption);

        case 'dataPicker':
          return _react["default"].createElement(_datePicker["default"], {
            className: 'editable-cell-view-style',
            defaultValue: _this.props.defaultValue,
            format: "YYYY/MM/DD",
            onChange: function onChange(moments, dateStrings) {
              if (_this.props.onChange) {
                _this.props.onChange(dateStrings, moments);
              }
            },
            value: (0, _moment["default"])(_this.props.value)
          });

        case 'rangePicker':
          return _react["default"].createElement(RangePicker, {
            value: _this.props.DateBegin ? [(0, _moment["default"])(_this.props.DateBegin), (0, _moment["default"])(_this.props.DateEnd)] : [],
            onChange: function onChange(moments, dateStrings) {
              if (_this.props.onChange) {
                _this.props.onChange(dateStrings[0], dateStrings[1], moments);
              }
            }
          });

        case 'checkbox':
          return _react["default"].createElement("div", {
            className: (0, _classnames["default"])('editable-cell-view-style', 'editable-cell-checkbox-style')
          }, _react["default"].createElement(_checkbox["default"], {
            defaultChecked: _this.props.defaultValue,
            onChange: _this.props.onChange
          }));

        case 'radioGroup':
          var renderRadio = (_this.props.radioData || []).map(function (radio) {
            return _react["default"].createElement(_radio["default"], {
              value: radio.value,
              key: radio.value
            }, radio.text);
          });
          return _react["default"].createElement("div", {
            className: (0, _classnames["default"])('editable-cell-view-style', 'editable-cell-radio-group-style')
          }, _react["default"].createElement(RadioGroup, {
            onChange: function onChange(e) {
              _this.props.onChange(e.target.value);
            },
            value: _this.props.value
          }, renderRadio));

        default:
          break;
      }
    };

    _this.state = {
      dataDictionaryList: [],
      loading: false
    };
    _this.fieldOption = {};
    return _this;
  }

  _createClass(EditableCell, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.getEditRowFormRef != null) {
        this.props.getEditRowFormRef(this.props.form);
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextPorps) {
      if (nextPorps.fieldOption == null) {
        this.fieldOption = {
          initialValue: nextPorps.value
        };
      } else if (nextPorps.fieldOption.initialValue == null) {
        this.fieldOption = nextPorps.fieldOption;
        this.fieldOption.initialValue = nextPorps.value;
      }
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", null, this.convertFormInfo());
    }
  }]);

  return EditableCell;
}(_react["default"].Component);

var _default = EditableCell;
exports["default"] = _default;