"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.cutStrByFullLength = exports.getStrFullLength = void 0;

var React = _interopRequireWildcard(require("react"));

var _tooltip = _interopRequireDefault(require("../tooltip"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  }
  return t;
};

/* eslint react/no-did-mount-set-state: 0 */

/* eslint no-param-reassign: 0 */
// @ts-ignore
var isSupportLineClamp = document.body.style.webkitLineClamp !== undefined;
var TooltipOverlayStyle = {
  overflowWrap: 'break-word',
  wordWrap: 'break-word'
};

var getStrFullLength = function getStrFullLength() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return str.split('').reduce(function (pre, cur) {
    var charCode = cur.charCodeAt(0);

    if (charCode >= 0 && charCode <= 128) {
      return pre + 1;
    } else {
      return pre + 2;
    }
  }, 0);
};

exports.getStrFullLength = getStrFullLength;

var cutStrByFullLength = function cutStrByFullLength() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var maxLength = arguments.length > 1 ? arguments[1] : undefined;
  var showLength = 0;
  return str.split('').reduce(function (pre, cur) {
    var charCode = cur.charCodeAt(0);

    if (charCode >= 0 && charCode <= 128) {
      showLength += 1;
    } else {
      showLength += 2;
    }

    if (showLength <= maxLength) {
      return pre + cur;
    } else {
      return pre;
    }
  }, '');
};

exports.cutStrByFullLength = cutStrByFullLength;

var EllipsisText = function EllipsisText(_a) {
  var text = _a.text,
      length = _a.length,
      tooltip = _a.tooltip,
      fullWidthRecognition = _a.fullWidthRecognition,
      other = __rest(_a, ["text", "length", "tooltip", "fullWidthRecognition"]);

  if (typeof text !== 'string') {
    throw new Error('Ellipsis children must be string.');
  }

  var textLength = fullWidthRecognition ? getStrFullLength(text) : text.length;

  if (textLength <= length || length < 0) {
    return React.createElement("span", other, text);
  }

  var tail = '...';
  var displayText;

  if (length - tail.length <= 0) {
    displayText = '';
  } else {
    displayText = fullWidthRecognition ? cutStrByFullLength(text, length) : text.slice(0, length);
  }

  if (tooltip) {
    return React.createElement(_tooltip["default"], {
      overlayStyle: TooltipOverlayStyle,
      title: text
    }, React.createElement("span", null, displayText, tail));
  }

  return React.createElement("span", other, displayText, tail);
};

var Ellipsis =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Ellipsis, _React$Component);

  function Ellipsis() {
    var _this;

    _classCallCheck(this, Ellipsis);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Ellipsis).apply(this, arguments));
    _this.state = {
      text: '',
      targetCount: 0
    };

    _this.computeLine = function () {
      var lines = _this.props.lines;

      if (lines && !isSupportLineClamp) {
        var text = _this.shadowChildren.innerText; //@ts-ignore

        var lineHeight = parseInt(getComputedStyle(_this.root).lineHeight, 10);
        var targetHeight = lines * lineHeight;
        _this.content.style.height = "".concat(targetHeight, "px");
        var totalHeight = _this.shadowChildren.offsetHeight;
        var shadowNode = _this.shadow.firstChild;

        if (totalHeight <= targetHeight) {
          _this.setState({
            text: text,
            targetCount: text.length
          });

          return;
        } // bisection


        var len = text.length;
        var mid = Math.ceil(len / 2);

        var count = _this.bisection(targetHeight, mid, 0, len, text, shadowNode);

        _this.setState({
          text: text,
          targetCount: count
        });
      }
    };

    _this.bisection = function (th, m, b, e, text, shadowNode) {
      var suffix = '...';
      var mid = m;
      var end = e;
      var begin = b;
      shadowNode.innerHTML = text.substring(0, mid) + suffix;
      var sh = shadowNode.offsetHeight;

      if (sh <= th) {
        shadowNode.innerHTML = text.substring(0, mid + 1) + suffix;
        sh = shadowNode.offsetHeight;

        if (sh > th) {
          return mid;
        } else {
          begin = mid;
          mid = Math.floor((end - begin) / 2) + begin;
          return _this.bisection(th, mid, begin, end, text, shadowNode);
        }
      } else {
        if (mid - 1 < 0) {
          return mid;
        }

        shadowNode.innerHTML = text.substring(0, mid - 1) + suffix;
        sh = shadowNode.offsetHeight;

        if (sh <= th) {
          return mid - 1;
        } else {
          end = mid;
          mid = Math.floor((end - begin) / 2) + begin;
          return _this.bisection(th, mid, begin, end, text, shadowNode);
        }
      }
    };

    _this.handleRoot = function (n) {
      _this.root = n;
    };

    _this.handleContent = function (n) {
      _this.content = n;
    };

    _this.handleNode = function (n) {
      _this.node = n;
    };

    _this.handleShadow = function (n) {
      _this.shadow = n;
    };

    _this.handleShadowChildren = function (n) {
      _this.shadowChildren = n;
    };

    return _this;
  }

  _createClass(Ellipsis, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.node) {
        this.computeLine();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var lines = this.props.lines;

      if (lines !== nextProps.lines) {
        this.computeLine();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          text = _this$state.text,
          targetCount = _this$state.targetCount;

      var _a = this.props,
          children = _a.children,
          lines = _a.lines,
          length = _a.length,
          className = _a.className,
          tooltip = _a.tooltip,
          fullWidthRecognition = _a.fullWidthRecognition,
          restProps = __rest(_a, ["children", "lines", "length", "className", "tooltip", "fullWidthRecognition"]);

      var cls = (0, _classnames["default"])('ant-pro-ellipsis', className, {
        'ant-pro-ellipsis-lines': lines && !isSupportLineClamp,
        'ant-pro-ellipsis-lineClamp': lines && isSupportLineClamp
      });

      if (!lines && !length) {
        return React.createElement("span", _extends({
          className: cls
        }, restProps), children);
      } // length


      if (!lines) {
        return React.createElement(EllipsisText, _extends({
          className: cls,
          length: length,
          text: children || '',
          tooltip: tooltip,
          fullWidthRecognition: fullWidthRecognition
        }, restProps));
      }

      var id = "antd-pro-ellipsis-".concat("".concat(new Date().getTime()).concat(Math.floor(Math.random() * 100))); // support document.body.style.webkitLineClamp

      if (isSupportLineClamp) {
        var style = "#".concat(id, "{-webkit-line-clamp:").concat(lines, ";-webkit-box-orient: vertical;}");
        return React.createElement("div", _extends({
          id: id,
          className: cls
        }, restProps), React.createElement("style", null, style), tooltip ? React.createElement(_tooltip["default"], {
          overlayStyle: TooltipOverlayStyle,
          title: children
        }, children) : children);
      }

      var childNode = React.createElement("span", {
        ref: this.handleNode
      }, targetCount > 0 && text.substring(0, targetCount), targetCount > 0 && targetCount < text.length && '...');
      return React.createElement("div", _extends({}, restProps, {
        ref: this.handleRoot,
        className: cls
      }), React.createElement("div", {
        ref: this.handleContent
      }, tooltip ? React.createElement(_tooltip["default"], {
        overlayStyle: TooltipOverlayStyle,
        title: text
      }, childNode) : childNode, React.createElement("div", {
        className: 'shadow',
        ref: this.handleShadowChildren
      }, children), React.createElement("div", {
        className: 'shadow',
        ref: this.handleShadow
      }, React.createElement("span", null, text))));
    }
  }]);

  return Ellipsis;
}(React.Component);

var EllipsisComponent = function EllipsisComponent(props) {
  return React.createElement(Ellipsis, _extends({}, props, {
    style: _extends({}, props.style, {
      display: '-webkit-inline-box',
      overflow: 'hidden'
    })
  }), props.text);
};

var _default = EllipsisComponent;
exports["default"] = _default;