"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getImportBatchNum = getImportBatchNum;
exports.getTemplateInfo = getTemplateInfo;
exports.getColumns = getColumns;
exports.checkDatas = checkDatas;
exports.checkRepeatImport = checkRepeatImport;
exports.getDataSource = getDataSource;
exports.submitData = submitData;
exports.editUpdate = editUpdate;
exports.getProgress = getProgress;

var _request = _interopRequireDefault(require("../_util/request"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// 获取批次号
function getImportBatchNum(params) {
  return (0, _request["default"])('../import/add', {
    method: "POST",
    allowRepeat: true,
    body: params
  }).then(function (res) {
    return res || {};
  });
} // 获取模板基本信息


function getTemplateInfo(params) {
  return (0, _request["default"])("../import/template", {
    method: 'POST',
    body: params,
    allowRepeat: true
  }).then(function (res) {
    return res || {};
  });
} // 获取模板表头数据


function getColumns(params) {
  return (0, _request["default"])("../import/".concat(params.templateId, "/columns?allowRepeat=true"), {
    method: 'GET'
  }).then(function (res) {
    return res || {};
  });
} // 开始数据校验


function checkDatas(params) {
  return (0, _request["default"])("../import/check", {
    method: 'POST',
    body: params,
    allowRepeat: true
  }).then(function (res) {
    return res || {};
  });
} // 检查是否有重复导入操作


function checkRepeatImport(params) {
  return (0, _request["default"])('../import/repeat', {
    method: "POST",
    body: params,
    allowRepeat: true
  }).then(function (res) {
    return res || {};
  });
} // 获取表格数据


function getDataSource(params) {
  return (0, _request["default"])('../import/dataList', {
    method: "POST",
    body: params,
    allowRepeat: true
  }).then(function (res) {
    return res || {};
  });
} // 提交数据


function submitData(params) {
  return (0, _request["default"])('../import/submit', {
    method: "POST",
    body: params,
    allowRepeat: true
  }).then(function (res) {
    return res || {};
  });
} // 编辑更新


function editUpdate(params) {
  return (0, _request["default"])('../import/updateMongoDB', {
    method: "POST",
    body: params,
    allowRepeat: true
  }).then(function (res) {
    return res || {};
  });
}

function getProgress(params) {
  return (0, _request["default"])('../import/progress', {
    method: "POST",
    body: params,
    allowRepeat: true
  }).then(function (res) {
    return res || {};
  });
}