"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _dva = require("dva");

var _router = require("dva/router");

var _immutabilityHelper = _interopRequireDefault(require("immutability-helper"));

var _qs = _interopRequireDefault(require("qs"));

var _react = _interopRequireWildcard(require("react"));

var _buttonGroup = _interopRequireDefault(require("../button-group"));

var _icon = _interopRequireDefault(require("../icon"));

var _labelWithController = _interopRequireDefault(require("../label-with-controller"));

var _message = _interopRequireDefault(require("../message"));

var _paginationComponent = _interopRequireDefault(require("../pagination-component"));

var _importExcel = _interopRequireDefault(require("./importExcel"));

var _TableComponents = _interopRequireDefault(require("./TableComponents"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// @ts-ignore
var Enum = {
  // 订单类型
  orderType: [{
    text: '运输出库',
    value: '1'
  }, {
    text: '运输入库',
    value: '2'
  }, {
    text: '运输订单',
    value: '3'
  }, {
    text: '出库订单',
    value: '4'
  }, {
    text: '入库订单',
    value: '5'
  }],
  // 状态
  importStatus: [{
    text: '等待导入',
    value: '10'
  }, {
    text: '等待校验',
    value: '20'
  }, {
    text: '等待提交',
    value: '30'
  }, {
    text: '提交成功',
    value: '40'
  }]
};
var utils = {
  downloadTemplate: function downloadTemplate(templateId) {
    var downloadUrl = "../importExportTemplate/downloadTemplate?templateId=".concat(templateId);
    downloadFile(downloadUrl);
  }
};

var downloadFile = function downloadFile(url) {
  if (document.getElementById('download-iframe') != null) {
    // @ts-ignore
    document.getElementById('download-iframe').remove();
  }

  var iframe = document.createElement('iframe');
  iframe = document.createElement('iframe');
  iframe.id = 'download-iframe';
  iframe.style.display = 'none';
  iframe.style.visibility = 'hidden';
  iframe.style.height = '0px';
  iframe.src = url;
  document.body.appendChild(iframe);
}; // 导入列表


var ImportBatchInfoList =
/*#__PURE__*/
function (_Component) {
  _inherits(ImportBatchInfoList, _Component);

  function ImportBatchInfoList(props) {
    var _this;

    _classCallCheck(this, ImportBatchInfoList);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ImportBatchInfoList).call(this, props)); // 导入批次号

    _this.onImportBatchNumChange = function (importBatchNum) {
      if (importBatchNum == null) {
        importBatchNum = '';
      }

      _this.setState({
        importBatchNum: importBatchNum
      });
    }; // 订单类型


    _this.onOrderTypeChange = function (orderType) {
      if (orderType == null) {
        orderType = '';
      }

      _this.setState({
        orderType: orderType
      });
    }; // 创建时间从


    _this.onCreateTimeStartTimeChange = function (createTimeStartTime) {
      if (createTimeStartTime == null) {
        createTimeStartTime = '';
      }

      _this.setState({
        createTimeStartTime: createTimeStartTime
      });
    }; // 创建时间到


    _this.onCreateTimeEndTimeChange = function (createTimeEndTime) {
      if (createTimeEndTime == null) {
        createTimeEndTime = '';
      }

      _this.setState({
        createTimeEndTime: createTimeEndTime
      });
    }; // 状态


    _this.onStatusChange = function (status) {
      if (status == null) {
        status = '';
      }

      _this.setState({
        status: status
      });
    }; // 操作人


    _this.onCreateNameChange = function (createName) {
      if (createName == null) {
        createName = '';
      }

      _this.setState({
        createName: createName
      });
    }; // 提交时间从


    _this.onSubmitTimeStartTimeChange = function (submitTimeStartTime) {
      if (submitTimeStartTime == null) {
        submitTimeStartTime = '';
      }

      _this.setState({
        submitTimeStartTime: submitTimeStartTime
      });
    }; // 提交时间到


    _this.onSubmitTimeEndTimeChange = function (submitTimeEndTime) {
      if (submitTimeEndTime == null) {
        submitTimeEndTime = '';
      }

      _this.setState({
        submitTimeEndTime: submitTimeEndTime
      });
    }; // 重置


    _this.onResetClick = function () {
      _this.setState({
        importBatchNum: '',
        orderType: '',
        createTimeStartTime: '',
        createTimeEndTime: '',
        status: '',
        createName: '',
        submitTimeStartTime: '',
        submitTimeEndTime: ''
      });
    }; // 编辑


    _this.onEditClick = function () {
      var rows = _this.state.rows;

      if (rows.length === 0) {
        _message["default"].error('请选择一条记录');

        return;
      }

      if (rows.length > 1) {
        _message["default"].error('请只选择一条记录');

        return;
      }

      var row = rows[0];

      _this.importEdit(row.templateId, row.importBatchNum);
    }; // 编辑


    _this.importEdit = function (templateId, importBatchNum) {
      _this.props.dispatch(_router.routerRedux.push({
        pathname: '/importTemplate',
        search: _qs["default"].stringify({
          templateId: templateId,
          importBatchNum: importBatchNum
        })
      }));
    }; // 选中行


    _this.onCellSelect = function (idList, rows) {
      _this.setState({
        idList: idList,
        rows: rows
      });
    }; // 分页变化


    _this.onPageChange = function (page, pageSize) {
      _this.searchTemplateForRedux(page, pageSize);
    }; // 每页条数变化


    _this.onPageSizeChange = function (pageSize) {
      _this.searchTemplateForRedux('1', pageSize);
    }; // 用state信息搜索模板


    _this.searchTemplateForState = function () {
      var _this$state = _this.state,
          importBatchNum = _this$state.importBatchNum,
          orderType = _this$state.orderType,
          createTimeStartTime = _this$state.createTimeStartTime,
          createTimeEndTime = _this$state.createTimeEndTime,
          status = _this$state.status,
          createName = _this$state.createName,
          submitTimeStartTime = _this$state.submitTimeStartTime,
          submitTimeEndTime = _this$state.submitTimeEndTime;

      _this.setState({
        loading: true
      });

      _this.props.dispatch({
        type: 'importBatchInfoList/getImportBatchList',
        payload: {
          importBatchNum: importBatchNum,
          orderType: orderType,
          createTimeStartTime: createTimeStartTime,
          createTimeEndTime: createTimeEndTime,
          status: status,
          createName: createName,
          submitTimeStartTime: submitTimeStartTime,
          submitTimeEndTime: submitTimeEndTime
        }
      }).then(function () {
        _this.setState(function () {
          return {
            loading: false
          };
        });
      });
    }; // 用Redux信息搜索模板


    _this.searchTemplateForRedux = function (pageNumber, pageSize) {
      _this.setState({
        idList: [],
        loading: true
      }, function () {
        var searchParam = _this.props.searchParam;
        var payload = (0, _immutabilityHelper["default"])(searchParam, {
          $merge: {
            pageNumber: pageNumber || searchParam.pageNumber,
            pageSize: pageSize || searchParam.pageSize
          }
        });

        _this.props.dispatch({
          type: 'importBatchInfoList/getImportBatchList',
          payload: payload
        }).then(function () {
          _this.setState(function () {
            return {
              loading: false
            };
          });
        });
      });
    };

    _this.operationCallback = function (result) {
      if (result.status > 0) {
        _message["default"].success(result.message);

        _this.searchTemplateForRedux('1', 10);
      } else {
        _message["default"].error(result.message);
      }
    };

    _this.downloadTemplate = function () {
      utils.downloadTemplate('carrierImportTransportIn');
    };

    _this.queryMoreCondition = function (queryCondition) {
      if (queryCondition === 'none') {
        _this.setState({
          queryCondition: queryCondition,
          queryMore: '',
          queryLess: 'none'
        });
      } else {
        _this.setState({
          queryCondition: queryCondition,
          queryMore: 'none',
          queryLess: ''
        });
      }
    };

    _this.renderControllerList = function () {
      var _this$state2 = _this.state,
          importBatchNum = _this$state2.importBatchNum,
          orderType = _this$state2.orderType,
          createTimeStartTime = _this$state2.createTimeStartTime,
          createTimeEndTime = _this$state2.createTimeEndTime,
          status = _this$state2.status,
          createName = _this$state2.createName;
      var controllerList = [{
        label: '导入批次号',
        type: 'input',
        onChange: _this.onImportBatchNumChange,
        value: importBatchNum
      }, {
        label: '订单类型',
        type: 'select',
        onChange: _this.onOrderTypeChange,
        optionData: Enum.orderType,
        value: orderType
      }, {
        label: '创建时间从',
        type: 'input',
        onChange: _this.onCreateTimeStartTimeChange,
        value: createTimeStartTime
      }, {
        label: '创建时间到',
        type: 'input',
        onChange: _this.onCreateTimeEndTimeChange,
        value: createTimeEndTime
      }, {
        label: '状态',
        type: 'select',
        onChange: _this.onStatusChange,
        optionData: Enum.importStatus,
        value: status
      }, {
        label: '操作人',
        type: 'input',
        onChange: _this.onCreateNameChange,
        value: createName
      }];
      var renderControllerList = controllerList.map(function (info) {
        return _react["default"].createElement(_labelWithController["default"], {
          type: info.type,
          label: info.label,
          key: info.label,
          onChange: info.onChange,
          optionData: info.optionData,
          value: info.value
        });
      });
      return renderControllerList;
    };

    _this.renderControllerMoreList = function () {
      var _this$state3 = _this.state,
          submitTimeStartTime = _this$state3.submitTimeStartTime,
          submitTimeEndTime = _this$state3.submitTimeEndTime;
      var controllerList = [{
        label: '提交时间从',
        type: 'input',
        onChange: _this.onSubmitTimeStartTimeChange,
        value: submitTimeStartTime
      }, {
        label: '提交时间到',
        type: 'input',
        onChange: _this.onSubmitTimeEndTimeChange,
        value: submitTimeEndTime
      }];
      var renderControllerList = controllerList.map(function (info) {
        return _react["default"].createElement(_labelWithController["default"], {
          type: info.type,
          label: info.label,
          key: info.label,
          onChange: info.onChange,
          optionData: info.optionData,
          value: info.value
        });
      });
      return renderControllerList;
    };

    _this.state = {
      idList: [],
      rows: [],
      templateId: '',
      importBatchNumTable: '',
      importBatchNum: '',
      orderType: '',
      createTimeStartTime: '',
      createTimeEndTime: '',
      status: '',
      createName: '',
      submitTimeStartTime: '',
      submitTimeEndTime: '',
      queryMore: '',
      queryCondition: 'none',
      queryLess: 'none',
      loading: false
    };
    _this.columns = [{
      dataIndex: 'importBatchNum',
      title: '导入批次号',
      width: 100
    }, {
      dataIndex: 'orderTypeTxt',
      title: '订单类型',
      width: 80
    }, {
      dataIndex: 'importRemark',
      title: '导入描述',
      width: 200
    }, {
      dataIndex: 'statusTxt',
      title: '状态',
      width: 80
    }, {
      dataIndex: 'originalRecordNum',
      title: '原始记录数',
      width: 80
    }, {
      dataIndex: 'successNum',
      title: '提交成功数',
      width: 80
    }, {
      dataIndex: 'orderNum',
      title: '提交订单数',
      width: 80
    }, {
      dataIndex: 'failNum',
      title: '提交失败数',
      width: 80
    }, {
      dataIndex: 'createTime',
      title: '创建时间',
      width: 100
    }, {
      dataIndex: 'submitTime',
      title: '提交时间',
      width: 100
    }, {
      dataIndex: 'createName',
      title: '操作人',
      width: 70
    }, {
      dataIndex: 'operation',
      title: '操作',
      width: 70,
      fixed: 'right',
      // @ts-ignore
      render: function render(val, item) {
        return _react["default"].createElement("div", null, _react["default"].createElement("a", {
          onClick: function onClick() {
            return _this.importEdit(item.templateId, item.importBatchNum);
          }
        }, "\u7F16\u8F91"));
      }
    }];
    return _this;
  }

  _createClass(ImportBatchInfoList, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.searchTemplateForState();
    }
  }, {
    key: "renderPagination",
    value: function renderPagination() {
      var rowsCount = this.props.rowsCount;

      if (!rowsCount) {
        return;
      }

      return _react["default"].createElement(_paginationComponent["default"], {
        className: "impexp-pagination-style",
        defaultCurrent: 1,
        total: rowsCount,
        onChange: this.onPageChange,
        onPageSizeChange: this.onPageSizeChange
      });
    }
  }, {
    key: "renderTable",
    value: function renderTable() {
      var idList = this.state.idList;
      var orderTypeMap = {};
      Enum.orderType.forEach(function (orderTypeInfo) {
        orderTypeMap[orderTypeInfo.value] = orderTypeInfo.text;
      });
      var statusMap = {};
      Enum.importStatus.forEach(function (statusInfo) {
        statusMap[statusInfo.value] = statusInfo.text;
      });
      var importBatchList = this.props.importBatchList.map(function (info) {
        return (0, _immutabilityHelper["default"])(info, {
          $merge: {
            orderTypeTxt: orderTypeMap[info.orderType],
            statusTxt: statusMap[info.status]
          }
        });
      });
      var tableWidth = this.columns.reduce(function (previousValue, currentValue) {
        return previousValue + currentValue.width; // 62是勾选框的宽度
      }, 0);
      return _react["default"].createElement(_TableComponents["default"] // @ts-ignore
      , {
        tableWidth: tableWidth,
        tableData: importBatchList || [],
        tableColumns: this.columns,
        loading: this.state.loading,
        isSelectable: true,
        onSelect: this.onCellSelect,
        selectedRowKeys: idList,
        rowKey: "id"
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var topButtonList = [{
        text: '搜索',
        onClick: this.searchTemplateForState,
        type: 'primary'
      }, {
        text: '重置',
        onClick: this.onResetClick
      }];
      var middleButtonList = [{
        text: '下载模板',
        onClick: this.downloadTemplate
      }];
      return _react["default"].createElement("div", {
        className: "impexp-controller-style"
      }, _react["default"].createElement("div", null, _react["default"].createElement("label", {
        style: {
          "float": 'left',
          fontSize: '20px',
          fontWeight: 400,
          borderLeft: '4px solid #0078d6',
          paddingLeft: '10px'
        }
      }, "\u5BFC\u5165\u5217\u8868")), _react["default"].createElement("div", {
        className: "impexp-search-view"
      }, _react["default"].createElement("div", {
        className: "impexp-search-controller"
      }, this.renderControllerList(), _react["default"].createElement("div", {
        style: {
          display: this.state.queryCondition
        }
      }, this.renderControllerMoreList())), _react["default"].createElement("div", {
        className: "impexp-search-btn-group",
        style: {
          flexDirection: 'column'
        }
      }, _react["default"].createElement("div", null, (0, _buttonGroup["default"])(topButtonList)), _react["default"].createElement("div", {
        style: {
          marginTop: '20px',
          marginLeft: '12px'
        }
      }, _react["default"].createElement("a", {
        style: {
          display: this.state.queryMore
        },
        onClick: function onClick() {
          return _this2.queryMoreCondition('');
        }
      }, "\u66F4\u591A", _react["default"].createElement(_icon["default"], {
        type: "down"
      })), _react["default"].createElement("a", {
        style: {
          display: this.state.queryLess
        },
        onClick: function onClick() {
          return _this2.queryMoreCondition('none');
        }
      }, "\u6536\u8D77", _react["default"].createElement(_icon["default"], {
        type: "up"
      }))))), _react["default"].createElement("div", {
        className: "impexp-btn-group"
      }, (0, _buttonGroup["default"])(middleButtonList), _react["default"].createElement(_importExcel["default"], {
        templateId: "carrierImportTransportIn"
      })), _react["default"].createElement("div", {
        className: "impexp-table-style"
      }, this.renderTable()), this.renderPagination());
    }
  }]);

  return ImportBatchInfoList;
}(_react.Component);

function mapStateToProps(state) {
  var _state$importBatchInf = state.importBatchInfoList,
      searchParam = _state$importBatchInf.searchParam,
      importBatchList = _state$importBatchInf.importBatchList,
      rowsCount = _state$importBatchInf.rowsCount;
  return {
    searchParam: searchParam,
    importBatchList: importBatchList,
    rowsCount: rowsCount
  };
}

var _default = (0, _dva.connect)(mapStateToProps)(ImportBatchInfoList);

exports["default"] = _default;