"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _dva = require("dva");

var _router = require("dva/router");

var _immutabilityHelper = _interopRequireDefault(require("immutability-helper"));

var _qs = _interopRequireDefault(require("qs"));

var _react = _interopRequireWildcard(require("react"));

var _button = _interopRequireDefault(require("../button"));

var _buttonGroup = _interopRequireDefault(require("../button-group"));

var _card = _interopRequireDefault(require("../card"));

var _dropdown = _interopRequireDefault(require("../dropdown"));

var _icon = _interopRequireDefault(require("../icon"));

var _input = _interopRequireDefault(require("../input"));

var _menu = _interopRequireDefault(require("../menu"));

var _message = _interopRequireDefault(require("../message"));

var _modal = _interopRequireDefault(require("../modal"));

var _paginationComponent = _interopRequireDefault(require("../pagination-component"));

var _popconfirm = _interopRequireDefault(require("../popconfirm"));

var _progress = _interopRequireDefault(require("../progress"));

var _table = _interopRequireDefault(require("../table"));

var _upload = _interopRequireDefault(require("../upload"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// @ts-ignore
var _window = window,
    $ = _window.$;
var host = '../';
var importExportTemplate = 'importExportTemplate';
var url = {
  importExportTemplate: {
    downloadTemplate: function downloadTemplate(templateId) {
      return "".concat(host).concat(importExportTemplate, "/downloadTemplate?templateId=").concat(templateId);
    },
    exportTemplate: function exportTemplate(templateId) {
      return "".concat(host).concat(importExportTemplate, "/exportTemplate?templateId=").concat(templateId);
    },
    exportTemplateThread: function exportTemplateThread(templateId) {
      return "".concat(host).concat(importExportTemplate, "/exportTemplateThread?templateId=").concat(templateId);
    },

    get findColumn() {
      return "".concat(host).concat(importExportTemplate, "/findColumn");
    },

    get findImportTemplate() {
      return "".concat(host).concat(importExportTemplate, "/findImportTemplate");
    },

    get importPage() {
      return "".concat(host).concat(importExportTemplate, "/importPage");
    },

    get importTemplateCheck() {
      return "".concat(host).concat(importExportTemplate, "/importTemplateCheck");
    },

    get importTemplateSumbit() {
      return "".concat(host).concat(importExportTemplate, "/importTemplateSumbit");
    },

    get updateMongoDB() {
      return "".concat(host).concat(importExportTemplate, "/updateMongoDB");
    },

    get getImportProgress() {
      return "".concat(host).concat(importExportTemplate, "/getImportProgress");
    },

    get importTemplate() {
      return "".concat(host).concat(importExportTemplate, "/importTemplate");
    }

  }
};
var utils = {
  downloadTemplate: function downloadTemplate(templateId) {
    var url1 = "".concat(host).concat(importExportTemplate, "/downloadTemplate?templateId=").concat(templateId);

    if (document.getElementById('download-iframe') != null) {
      // @ts-ignore
      document.getElementById('download-iframe').remove();
    }

    var iframe = document.createElement('iframe');
    iframe = document.createElement('iframe');
    iframe.id = 'download-iframe';
    iframe.style.display = 'none';
    iframe.style.visibility = 'hidden';
    iframe.style.height = '0px';
    iframe.src = url1;
    document.body.appendChild(iframe);
  }
};
var tmptemplateList = {};

var EditableCell = function EditableCell(_ref) {
  var editable = _ref.editable,
      value = _ref.value,
      status = _ref.status,
      _onChange = _ref.onChange;
  return _react["default"].createElement("div", null, editable ? _react["default"].createElement(_input["default"], {
    style: {
      margin: '-5px 0'
    },
    value: value,
    onChange: function onChange(e) {
      return _onChange(e.target.value);
    }
  }) : status === '10' ? _react["default"].createElement("span", null, value == null ? '' : value) : _react["default"].createElement("div", {
    className: "impexp-error-table-info"
  }, value == null ? '' : value));
}; // 学生规则模板


var ImportTemplate =
/*#__PURE__*/
function (_Component) {
  _inherits(ImportTemplate, _Component);

  function ImportTemplate(props) {
    var _this;

    _classCallCheck(this, ImportTemplate);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ImportTemplate).call(this, props));

    _this.initData = function () {
      var _this$props = _this.props,
          templateId = _this$props.templateId,
          importBatchNum = _this$props.importBatchNum;

      var self = _assertThisInitialized(_this);

      $.ajax({
        url: url.importExportTemplate.findImportTemplate,
        data: {
          templateId: templateId,
          importBatchNum: importBatchNum
        },
        cache: false,
        async: false,
        type: 'GET',
        dataType: 'json',
        success: function success(data) {
          self.setState({
            backUrl: data.backUrl,
            moduleTypeName: data.moduleTypeName
          });

          if (data.batchStatus === '10') {
            var promptInfo = "\u5F53\u524D\u5BFC\u5165\u6279\u6B21\u53F7\uFF1A".concat(data.importBatchNum, "\uFF0C\u8BF7\u9009\u62E9\u5BFC\u5165\u6A21\u677F\u6587\u4EF6");
            self.setState({
              promptInfo: promptInfo
            });
          } else {
            var _promptInfo = "\u5F53\u524D\u5BFC\u5165\u6279\u6B21\u53F7\uFF1A".concat(data.importBatchNum, "\uFF0C\u83B7\u53D6\u6587\u4EF6\u539F\u59CB\u8BB0\u5F55\u6570\u4E3A").concat(data.originalRecordNum == null ? 0 : data.originalRecordNum, "\u6761\uFF0C\u8BF7\u6267\u884C\u6570\u636E\u6821\u9A8C\u3002");

            self.setState({
              promptInfo: _promptInfo
            });
          }

          var importType = data.importType;
          var currentImportFlag = data.currentImportFlag;

          if (importType === 'submit') {
            self.setState({
              progressMask: ''
            });
            self.showSubmitProgress();
          } else if (currentImportFlag === 'true') {
            self.checkExistImport(data);
          }

          self.initButtonStatus(data.batchStatus);
        }
      });
    };

    _this.initButtonStatus = function (importBatchStatus) {
      if (importBatchStatus === '30') {
        _this.setState({
          isSubmitClick: true
        });
      } else if (importBatchStatus === '40') {
        _this.setState({
          isImportClick: true,
          isCheckClick: true,
          isSubmitClick: true
        });
      }
    };

    _this.queryTableInit = function () {
      var templateId = _this.props.templateId;

      var self = _assertThisInitialized(_this);

      $.ajax({
        url: url.importExportTemplate.findColumn,
        data: {
          templateId: templateId
        },
        cache: false,
        async: false,
        type: 'POST',
        dataType: 'json',
        success: function success(data) {
          self.queryColumnInit(data);
        }
      });
    };

    _this.queryColumnInit = function (data) {
      var self = _assertThisInitialized(_this);

      _this.columns = [{
        title: '操作',
        dataIndex: 'emptyValue',
        width: 100,
        // @ts-ignore
        render: function render(value, row, index) {
          var batchStatus = self.state.batchStatus;

          if (batchStatus == null || batchStatus !== '40') {
            var editable = row.editable;
            return _react["default"].createElement("div", {
              className: "editable-row-operations"
            }, editable ? _react["default"].createElement("span", {
              style: {
                fontSize: '14px',
                display: 'block',
                marginTop: '-10px'
              }
            }, _react["default"].createElement("a", {
              onClick: function onClick() {
                return _this.save(index);
              }
            }, "\u786E\u5B9A"), _react["default"].createElement(_popconfirm["default"], {
              title: "\u786E\u5B9A\u53D6\u6D88\u7F16\u8F91?",
              onConfirm: function onConfirm() {
                return _this.cancel(index);
              }
            }, _react["default"].createElement("a", {
              style: {
                marginLeft: '10px'
              }
            }, "\u53D6\u6D88"))) : _react["default"].createElement("a", {
              onClick: function onClick() {
                return _this.edit(index);
              }
            }, _react["default"].createElement(_icon["default"], {
              type: "edit",
              className: "impexp-inline-operate-icon"
            })));
          }

          return _react["default"].createElement("div", null);
        }
      }, {
        title: '行号',
        dataIndex: 'execlNum',
        width: 80,
        render: function render(val, item) {
          if (item.status === '10') {
            return _react["default"].createElement("div", null, _react["default"].createElement("span", null, val == null ? '' : val));
          }

          return _react["default"].createElement("div", {
            className: "impexp-error-table-info"
          }, _react["default"].createElement("span", null, val == null ? '' : val));
        }
      }, {
        title: '错误原因',
        dataIndex: 'errorMessage',
        width: 150,
        render: function render(val, item) {
          if (val == null) {
            return '';
          }

          var msgTitle = val;
          var msg = val.replace(/;/g, ';<br >');

          if (item.status === '10') {
            return _react["default"].createElement("span", {
              title: "{msgTitle}"
            }, _react["default"].createElement("div", {
              dangerouslySetInnerHTML: {
                __html: msg
              }
            }));
          }

          return _react["default"].createElement("span", {
            title: msgTitle
          }, _react["default"].createElement("div", {
            className: "impexp-error-table-info",
            dangerouslySetInnerHTML: {
              __html: msg
            }
          }));
        }
      }];
      var extendCount = 1;
      var length = data.length;

      var _loop = function _loop(i) {
        if (data[i].porpertyName !== '' && data[i].porpertyName != null) {
          var porpertyName = data[i].porpertyName;

          _this.columns.push({
            title: data[i].columnName,
            dataIndex: porpertyName,
            width: 150,
            render: function render(text, record) {
              return _this.renderColumns(text, record, porpertyName);
            }
          });
        } else {
          if (data[i].extendMap == null) {
            _this.columns.push({
              title: data[i].columnName,
              dataIndex: "emptyValue".concat(i),
              width: 150,
              render: function render(text, record) {
                return _this.renderColumns(text, record, "emptyValue".concat(i));
              }
            });
          } else {
            _this.columns.push({
              title: data[i].columnName,
              dataIndex: "extendMap.extend".concat(extendCount),
              width: 150,
              render: function render(text, record) {
                return _this.renderColumns(text, record, "extendMap.extend".concat(extendCount));
              }
            });
          }

          extendCount++;
        }
      };

      for (var i = 0; i < length; i++) {
        _loop(i);
      }
    };

    _this.checkExistImport = function (data) {
      _modal["default"].confirm({
        title: "".concat(data.currentModuleTypeName, "\u60A8\u8FD8\u6709\u672A\u63D0\u4EA4\u7684\u6570\u636E\uFF0C\u662F\u5426\u7EE7\u7EED\u8DF3\u8F6C\u63D0\u4EA4\uFF1F"),
        cancelText: '取消',
        okText: '确定',
        onOk: function onOk() {
          if (data.currentUrl != null && data.currentUrl !== '') {
            _this.props.dispatch(_router.routerRedux.push({
              pathname: data.currentUrl
            }));
          }
          /* else if (currentTemplateId != null && currentTemplateId !== '') {
          this.props.dispatch(
            routerRedux.push({
              pathname: '/importTemplate',
              search: queryString.stringify({
                templateId: data.currentTemplateId,
                importBatchNum: data.importBatchNum,
                importBatchStatus: data.status,
              }),
            })
          );
          } */
          else {
              _this.props.history.goBack();
            }
        },
        onCancel: function onCancel() {
          _this.props.history.goBack();
        }
      });
    }; // 数据校验


    _this.onCheckClick = function () {
      var _this$state = _this.state,
          importBatchNum = _this$state.importBatchNum,
          templateId = _this$state.templateId;

      var self = _assertThisInitialized(_this);

      _this.setState({
        clickCheck: true
      });

      _modal["default"].confirm({
        title: '确定校验数据？',
        cancelText: '取消',
        okText: '确定',
        onOk: function onOk() {
          self.setState({
            progressMask: 'block',
            percent: 0,
            isCheckClick: true
          });
          var params = [];
          params.push({
            name: 'importBatchNum',
            value: importBatchNum
          });
          params.push({
            name: 'templateId',
            value: templateId
          });
          $.post(url.importExportTemplate.importTemplateCheck, params, function (data) {
            if (!data.result) {
              self.setState({
                progressMask: 'none',
                isCheckClick: false,
                percent: 100
              });

              if (data.data != null) {
                self.checkExistImport(data.data);
              } else if (data.msg === '数据正在校验中，请稍等！') {
                _message["default"].error(data.msg);
              } else {
                _message["default"].error(data.msg);

                self.setState({
                  isImportClick: false,
                  isSubmitClick: true,
                  isCheckClick: true
                });
              }
            } else {
              self.showCheckProgress();
            }
          }, 'json');
        }
      });
    };

    _this.showCheckProgress = function () {
      var importBatchNum = _this.state.importBatchNum;

      var self = _assertThisInitialized(_this);

      setTimeout(function () {
        if (self.state.progressMask === 'none') {
          return;
        }

        $.post(url.importExportTemplate.getImportProgress, {
          importBatchNum: importBatchNum
        }, function (data) {
          if (data.result) {
            var totalNum = data.data.totalNum;
            var currentNum = data.data.currentNum;
            var importStatus = data.data.importStatus;
            var importMsg = data.data.importMsg;
            var percent = 0;

            if (parseInt(totalNum) !== 0) {
              percent = Math.floor(parseInt(currentNum) / parseInt(totalNum) * 100);
            } // @ts-ignore


            if (parseInt(percent) >= 90) {
              self.setState({
                percent: 90
              });
            } else {
              self.setState({
                percent: percent
              });
            }

            if (importStatus === '') {
              self.showCheckProgress();
            } else {
              self.setState({
                progressMask: 'none',
                isCheckClick: false,
                isSubmitClick: false
              });

              if (importStatus === 'true') {
                if (data.data.failCount > 0 || data.data.repeatCount > 0) {
                  var promptInfo = "\u5F53\u524D\u5BFC\u5165\u6279\u6B21\u53F7\uFF1A".concat(importBatchNum, "\uFF0C\u6570\u636E\u6821\u9A8C\u5B8C\u6210\uFF0C\u53EF\u5BFC\u5165\u8BB0\u5F55\u6570\u4E3A").concat(data.data.successCount, "\u6761\uFF0C\u91CD\u590D\u6570\u636E\u4E3A").concat(data.data.repeatCount, "\u6761\uFF0C\u9519\u8BEF\u4E14\u4E0D\u53EF\u5BFC\u5165\u8BB0\u5F55\u6570\u4E3A").concat(data.data.failCount, "\u6761\uFF0C\u8BF7\u91CD\u65B0\u5BFC\u5165\u6A21\u677F\u6216\u7F16\u8F91\u9519\u8BEF\u6570\u636E\u540E\u91CD\u65B0\u8FDB\u884C\u6570\u636E\u6821\u9A8C\u3002");
                  self.setState({
                    promptInfo: promptInfo
                  });
                } else {
                  var _promptInfo2 = "\u5F53\u524D\u5BFC\u5165\u6279\u6B21\u53F7\uFF1A".concat(importBatchNum, "\uFF0C\u6570\u636E\u6821\u9A8C\u6210\u529F\uFF0C\u8BF7\u5168\u90E8\u63D0\u4EA4\u6570\u636E\u3002");

                  self.setState({
                    promptInfo: _promptInfo2
                  });
                }
              }

              if (importMsg === '校验完成。') {
                _message["default"].success(importMsg);
              } else if (importMsg === '校验异常。') {
                _message["default"].error(importMsg);
              }

              self.displayShow('00');
            }
          }
        }, 'json');
      }, 3000);
    }; // 提交


    _this.onSubmitClick = function () {
      var _this$props2 = _this.props,
          importBatchNum = _this$props2.importBatchNum,
          templateId = _this$props2.templateId;

      var self = _assertThisInitialized(_this);

      _modal["default"].confirm({
        title: '确定提交数据？',
        cancelText: '取消',
        okText: '确定',
        onOk: function onOk() {
          self.setState({
            progressMask: '',
            percent: 0,
            isImportClick: true,
            isSubmitClick: true,
            isCheckClick: true
          });
          var params = [];
          params.push({
            name: 'importBatchNum',
            value: importBatchNum
          });
          params.push({
            name: 'templateId',
            value: templateId
          });
          $.post(url.importExportTemplate.importTemplateSumbit, params, function (data) {
            if (!data.result) {
              self.setState({
                progressMask: 'none'
              });

              if (data.data != null) {
                self.checkExistImport(data.data);
              } else if (data.msg === '数据正在提交中，请稍等！') {
                // @ts-ignore
                PUI.MessageBox.alert(data.msg);
                self.setState({
                  isImportClick: true,
                  isSubmitClick: true,
                  isCheckClick: true
                });
              } else {
                _message["default"].error(data.msg);

                self.setState({
                  isImportClick: false
                });
              }
            } else {
              self.showSubmitProgress();
            }
          }, 'json');
        }
      });
    };

    _this.showSubmitProgress = function () {
      var importBatchNum = _this.state.importBatchNum;

      var self = _assertThisInitialized(_this);

      setTimeout(function () {
        if (self.state.progressMask === 'none') {
          return;
        }

        $.post(url.importExportTemplate.getImportProgress, {
          importBatchNum: importBatchNum
        }, function (data) {
          if (data.result) {
            var totalNum = data.data.totalNum;
            var currentNum = data.data.currentNum;
            var importStatus = data.data.importStatus;
            var importMsg = data.data.importMsg;
            var percent = 0;

            if (parseInt(totalNum) !== 0) {
              percent = Math.floor(parseInt(currentNum) / parseInt(totalNum) * 100);
            } // @ts-ignore


            if (parseInt(percent) >= 90) {
              self.setState({
                percent: 90
              });
            } else {
              self.setState({
                percent: percent
              });
            }

            if (importStatus === '') {
              self.showSubmitProgress();
            } else {
              self.setState({
                progressMask: 'none',
                isImportClick: true,
                isCheckClick: true,
                isSubmitClick: true,
                isDisabledImportButton: true,
                batchStatus: '40'
              });

              if (importStatus === 'true') {
                var promptInfo = "\u5F53\u524D\u5BFC\u5165\u6279\u6B21\u53F7\uFF1A".concat(importBatchNum, "\uFF0C\u83B7\u53D6\u6587\u4EF6\u539F\u59CB\u8BB0\u5F55\u6570\u4E3A").concat(data.data.allCount, "\u6761\uFF0C\u5DF2\u5BFC\u5165\u6210\u529F").concat(data.data.successCount, "\u6761\u3002");
                self.setState({
                  promptInfo: promptInfo
                });
                self.displayShow('30');
              }

              if (importMsg.match('失败')) {
                _message["default"].error(importMsg);
              } else {
                _message["default"].success(importMsg);
              }
            }
          }
        }, 'json');
      }, 3000);
    }; // 列表过滤


    _this.onDisplayClick = function (val) {
      var showStatus = val == null ? '00' : val.key;

      _this.displayShow(showStatus);
    };

    _this.displayShow = function (val) {
      var importBatchNum = _this.props.importBatchNum;
      var showStatus = val == null ? '00' : val;

      _this.setState({
        showStatus: showStatus
      });

      _this.searchTemplate(showStatus, importBatchNum);
    };

    _this.downloadTemplate = function () {
      var templateId = _this.state.templateId;
      utils.downloadTemplate(templateId);
    };

    _this.beforeUpload = function (file) {
      var isExcel = file.type === 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' || file.type === 'application/vnd.ms-excel';

      if (!isExcel) {
        _message["default"].error('请上传xls、xlsx文件!');
      }

      return true;
    };

    _this.back = function () {
      _this.props.dispatch({
        type: 'importTemplate/clear',
        payload: {
          templateList: [],
          rowsCount: 0
        }
      });

      var backUrl = _this.state.backUrl;

      if (backUrl != null && backUrl !== '') {
        _this.props.dispatch(_router.routerRedux.push({
          pathname: '/import'
        }));
      } else {
        _this.props.history.goBack();
      }
    }; // 选中行


    _this.onCellSelect = function (pmCodeList, selectedList) {
      _this.setState({
        pmCodeList: pmCodeList,
        selectedList: selectedList
      });
    }; // 分页变化


    _this.onPageChange = function (page, pageSize) {
      _this.searchTemplateForRedux(page, pageSize);
    }; // 每页条数变化


    _this.onPageSizeChange = function (pageSize) {
      _this.searchTemplateForRedux('1', pageSize);
    }; // 用state信息搜索模板


    _this.searchTemplateForState = function () {
      var showStatus = _this.state.showStatus;
      var importBatchNum = _this.props.importBatchNum;

      _this.searchTemplate(showStatus, importBatchNum);
    };

    _this.searchTemplate = function (showStatus, importBatchNum) {
      _this.setState({
        loading: true
      });

      _this.props.dispatch({
        type: 'importTemplate/importPage',
        payload: {
          importBatchNum: importBatchNum,
          showStatus: showStatus
        }
      }).then(function () {
        _this.setState(function () {
          return {
            loading: false,
            defaultCurrent: 1
          };
        });
      });
    }; // 用Redux信息搜索模板


    _this.searchTemplateForRedux = function (pageNumber, pageSize) {
      _this.setState({
        loading: true
      }, function () {
        var searchParam = _this.props.searchParam;
        var payload = (0, _immutabilityHelper["default"])(searchParam, {
          $merge: {
            pageNumber: pageNumber || searchParam.pageNumber,
            pageSize: pageSize || searchParam.pageSize
          }
        });

        _this.props.dispatch({
          type: 'importTemplate/importPage',
          payload: payload
        }).then(function () {
          _this.setState(function () {
            return {
              loading: false,
              current: pageNumber
            };
          });
        });
      });
    };

    _this.operationCallback = function (result) {
      if (result.status > 0) {
        _message["default"].success(result.message);

        _this.searchTemplateForRedux('1', 10);
      } else {
        _message["default"].error(result.message);
      }
    };

    _this.handleChange = function (value, record, column) {
      var newData = _toConsumableArray(_this.state.templateList);

      var target = newData.filter(function (item) {
        return record.execlNum + record.hashCode === item.execlNum + item.hashCode;
      })[0];

      if (target) {
        target[column] = value;

        _this.setState({
          templateList: newData
        });
      }
    };

    _this.state = {
      clickCheck: false,
      defaultCurrent: 1,
      current: 1,
      percent: 0,
      tableRow: {},
      templateId: '',
      importBatchNum: '',
      batchStatus: '',
      showStatus: '00',
      pmCodeList: [],
      templateList: [],
      cacheTemplateData: [],
      promptInfo: '',
      progressMask: 'none',
      backUrl: '',
      moduleTypeName: '',
      loading: false,
      isImportClick: false,
      isCheckClick: false,
      isSubmitClick: false,
      isDisplayClick: false,
      isDownloadTemplate: false,
      // 导入模板按钮禁用标志
      isDisabledImportButton: false
    };
    _this.columns = [];
    return _this;
  }

  _createClass(ImportTemplate, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.initData();
      this.queryTableInit();
      this.searchTemplateForState();
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var templateId = nextProps.templateId,
          importBatchNum = nextProps.importBatchNum,
          templateList = nextProps.templateList; // 判断是否是校验的数据是否不变

      if (JSON.stringify(templateList) !== JSON.stringify(this.state.templateList) && this.state.clickCheck) {
        this.setState({
          clickCheck: false,
          templateList: templateList
        });
      }

      if (JSON.stringify(tmptemplateList) !== JSON.stringify(templateList)) {
        tmptemplateList = templateList;
        this.setState({
          templateList: templateList,
          cacheTemplateData: templateList
        });
      }

      if (templateId !== this.state.templateId || importBatchNum !== this.state.importBatchNum) {
        this.setState({
          templateId: templateId,
          importBatchNum: importBatchNum
        });
      }
    }
  }, {
    key: "edit",
    value: function edit(index) {
      var target = (0, _immutabilityHelper["default"])(this.state.templateList[index], {
        $merge: {
          editable: true
        }
      });
      var templateList = (0, _immutabilityHelper["default"])(this.state.templateList, {
        $splice: [[index, 1, target]]
      });
      this.setState({
        templateList: templateList
      });
    }
  }, {
    key: "save",
    value: function save(index) {
      var _this2 = this;

      var newData = _toConsumableArray(this.state.templateList);

      var target = (0, _immutabilityHelper["default"])(this.state.templateList[index], {
        $merge: {
          editable: false
        }
      });
      var templateList = (0, _immutabilityHelper["default"])(this.state.templateList, {
        $splice: [[index, 1, target]]
      });

      if (target) {
        this.updateTemplate(target);
        delete target.editable;
        this.setState({
          templateList: templateList
        }, function () {
          var onEdit = _this2.props.onEdit;

          if (onEdit) {
            onEdit(templateList[index], index, templateList);
          }
        });
        this.setState({
          cacheTemplateData: newData.map(function (item) {
            return _extends({}, item);
          })
        });
      }
    }
  }, {
    key: "updateTemplate",
    value: function updateTemplate(row) {
      var self = this;
      $.post(url.importExportTemplate.updateMongoDB, row, function (data) {
        if (data.result) {
          var promptInfo = "\u5F53\u524D\u5BFC\u5165\u6279\u6B21\u53F7\uFF1A".concat(data.data.importBatchNum, "\uFF0C\u5DF2\u7F16\u8F91").concat(data.data.editedNum, "\u6761\u6570\u636E\uFF0C\u9519\u8BEF\u4E14\u4E0D\u53EF\u5BFC\u5165\u8BB0\u5F55\u6570\u5269\u4F59").concat(data.data.surplusNum, "\u6761\uFF0C\u8BF7\u91CD\u65B0\u8FDB\u884C\u6570\u636E\u6821\u9A8C\u3002");

          _message["default"].success(data.msg);

          row.errorMessage = data.data.errorMessage;
          row.batchStatus = data.data.status;
          self.setState({
            isSubmitClick: true,
            isCheckClick: false,
            promptInfo: promptInfo
          });
        } else {
          _message["default"].error(data.msg);

          self.setState({
            isSubmitClick: true,
            isCheckClick: false
          });
        }
      }, 'json');
    }
  }, {
    key: "cancel",
    value: function cancel(index) {
      var cacheTemplateData = _extends({}, this.state.cacheTemplateData[index]);

      cacheTemplateData.editable = false;
      var templateList = (0, _immutabilityHelper["default"])(this.state.templateList, {
        $splice: [[index, 1, cacheTemplateData]]
      });
      this.setState({
        templateList: templateList
      });
    }
  }, {
    key: "renderPagination",
    value: function renderPagination() {
      var rowsCount = this.props.rowsCount;

      if (!rowsCount) {
        return;
      }

      return _react["default"].createElement(_paginationComponent["default"], {
        className: "impexp-pagination-style",
        defaultCurrent: this.state.defaultCurrent,
        current: this.state.current,
        total: rowsCount,
        onChange: this.onPageChange,
        onPageSizeChange: this.onPageSizeChange
      });
    }
  }, {
    key: "renderColumns",
    value: function renderColumns(text, record, column) {
      var _this3 = this;

      return _react["default"].createElement(EditableCell, {
        editable: record.editable,
        value: text,
        status: record.status,
        onChange: function onChange(value) {
          return _this3.handleChange(value, record, column);
        }
      });
    }
  }, {
    key: "renderTable",
    value: function renderTable() {
      var templateList = this.state.templateList.map(function (info) {
        return info;
      });
      var tableWidth = this.columns.reduce(function (previousValue, currentValue) {
        return previousValue + (currentValue.width == null ? 150 : currentValue.width); // 62是勾选框的宽度
      }, 0);
      return _react["default"].createElement(_table["default"], {
        pagination: false,
        scroll: {
          x: tableWidth
        },
        dataSource: templateList || [],
        columns: this.columns,
        loading: this.state.loading,
        bordered: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var self = this;
      var options = {
        name: 'file',
        action: url.importExportTemplate.importTemplate,
        headers: {
          authorization: 'authorization-text'
        },
        data: {
          templateId: this.props.templateId,
          importBatchNum: this.props.importBatchNum
        },
        showUploadList: false,
        beforeUpload: this.beforeUpload,
        disabled: this.state.isImportClick,
        onChange: function onChange(info) {
          if (info.file.status === 'done') {
            var result = info.file.response;

            if (result != null && result.result) {
              var promptInfo = "\u5F53\u524D\u5BFC\u5165\u6279\u6B21\u53F7\uFF1A".concat(result.data.importBatchNum, "\uFF0C\u83B7\u53D6\u6587\u4EF6\u539F\u59CB\u8BB0\u5F55\u6570\u4E3A").concat(result.data.originalImportNum, "\u6761\uFF0C\u8BF7\u6267\u884C\u6570\u636E\u6821\u9A8C\u3002");
              self.setState({
                promptInfo: promptInfo,
                isCheckClick: false,
                isSubmitClick: true
              });

              _message["default"].success(result.msg);

              self.displayShow('00');
            } else {
              _message["default"].error(result.msg);
            }
          } else if (info.file.status === 'error') {
            _message["default"].error(info.file.response.result.msg);
          }
        }
      };
      var middleButtonList = [{
        text: '数据校验',
        onClick: this.onCheckClick,
        disabled: this.state.isCheckClick,
        style: {
          marginLeft: '10px'
        }
      }, {
        text: '全部提交',
        onClick: this.onSubmitClick,
        disabled: this.state.isSubmitClick
      }, {
        text: '下载模板',
        onClick: this.downloadTemplate,
        disabled: this.state.isDownloadTemplate
      }];

      var menu = _react["default"].createElement(_menu["default"], {
        onClick: this.onDisplayClick
      }, _react["default"].createElement(_menu["default"].Item, {
        key: "00"
      }, "\u663E\u793A\u5168\u90E8\u8BB0\u5F55"), _react["default"].createElement(_menu["default"].Item, {
        key: "30"
      }, "\u663E\u793A\u5931\u8D25\u8BB0\u5F55"), _react["default"].createElement(_menu["default"].Item, {
        key: "10"
      }, "\u663E\u793A\u6B63\u786E\u8BB0\u5F55"), _react["default"].createElement(_menu["default"].Item, {
        key: "20"
      }, "\u663E\u793A\u91CD\u590D\u8BB0\u5F55"));

      var borderLine = _react["default"].createElement("div", null, _react["default"].createElement("span", {
        style: {
          width: '4px',
          height: '20px',
          background: '#0078d6',
          display: 'inline-block',
          top: '13px',
          marginTop: '2px',
          verticalAlign: 'sub',
          borderRadius: '2px',
          marginRight: '7px'
        }
      }), this.state.moduleTypeName, "\u5BFC\u5165\u7ED3\u679C\u5217\u8868");

      var gobackButton = _react["default"].createElement(_button["default"], {
        onClick: function onClick() {
          _this4.back();
        },
        style: {
          "float": 'right'
        }
      }, _react["default"].createElement(_icon["default"], {
        type: "rollback"
      }), "\u8FD4\u56DE");

      var renderProgressjlt = function renderProgressjlt() {
        // @ts-ignore
        return _react["default"].createElement(Progressjlt, {
          visible: _this4.state.progressMask === 'block',
          percent: _this4.state.percent
        });
      };

      return _react["default"].createElement(_card["default"], {
        title: borderLine,
        bordered: false,
        extra: gobackButton
      }, _react["default"].createElement("div", {
        className: "impexp-controller-style",
        style: {
          borderTop: '1px solid #e9e9e9'
        }
      }, _react["default"].createElement("div", {
        className: "impexp-btn-group"
      }, _react["default"].createElement(_upload["default"], _extends({}, options, {
        className: "impexp-btn-group"
      }), _react["default"].createElement(_button["default"], {
        disabled: this.state.isDisabledImportButton
      }, "\u5BFC\u5165\u6A21\u677F")), (0, _buttonGroup["default"])(middleButtonList), _react["default"].createElement(_dropdown["default"], {
        overlay: menu,
        placement: "bottomCenter"
      }, _react["default"].createElement(_button["default"], null, "\u5217\u8868\u8FC7\u6EE4"))), _react["default"].createElement("div", {
        className: "impexp-btn-group"
      }, _react["default"].createElement("h2", {
        className: "impexp-h2-font-size"
      }, this.state.promptInfo)), this.renderTable(), this.renderPagination(), renderProgressjlt()));
    }
  }]);

  return ImportTemplate;
}(_react.Component);

var Progressjlt =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Progressjlt, _React$Component);

  function Progressjlt() {
    _classCallCheck(this, Progressjlt);

    return _possibleConstructorReturn(this, _getPrototypeOf(Progressjlt).apply(this, arguments));
  }

  _createClass(Progressjlt, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement(_modal["default"], _extends({}, this.props, {
        title: "",
        mask: false,
        style: {
          top: '50%',
          marginTop: -40
        },
        closable: false,
        footer: null
      }), _react["default"].createElement(_progress["default"], {
        percent: this.props.percent
      }));
    }
  }]);

  return Progressjlt;
}(_react["default"].Component);

function mapStateToProps(state, props) {
  var locationSearch = _qs["default"].parse(props.location.search || '');

  var templateId = locationSearch.templateId,
      importBatchNum = locationSearch.importBatchNum;
  var _state$importTemplate = state.importTemplate,
      searchParam = _state$importTemplate.searchParam,
      templateList = _state$importTemplate.templateList,
      rowsCount = _state$importTemplate.rowsCount;
  return {
    templateId: templateId,
    importBatchNum: importBatchNum,
    searchParam: searchParam,
    templateList: templateList,
    rowsCount: rowsCount
  };
}

var _default = (0, _dva.connect)(mapStateToProps)(ImportTemplate);

exports["default"] = _default;