"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _datePicker = _interopRequireDefault(require("../date-picker"));

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// export default DatePicker;
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  }
  return t;
};

var TIME_LIST = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59];

var JDatePicker =
/*#__PURE__*/
function (_React$Component) {
  _inherits(JDatePicker, _React$Component);

  function JDatePicker(props) {
    var _this;

    _classCallCheck(this, JDatePicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(JDatePicker).call(this, props));

    _this.initCurrentData = function () {
      var _this$props = _this.props,
          limitTime = _this$props.limitTime,
          limitStartTime = _this$props.limitStartTime,
          limitEndTime = _this$props.limitEndTime;
      var limitDate = limitStartTime || limitTime;

      if (!limitDate && !limitEndTime) {
        return (0, _moment["default"])();
      } else if (limitDate) {
        if (typeof limitDate === 'string') {
          return (0, _moment["default"])(limitDate);
        }

        return limitDate;
      } else if (limitEndTime) {
        if (typeof limitEndTime === 'string') {
          return (0, _moment["default"])(limitEndTime);
        }

        return limitEndTime;
      }
    };

    _this.getLimitDate = function (currentDate, limitDate, limitEndTime) {
      if (typeof limitDate === 'string') {
        limitDate = (0, _moment["default"])(limitDate);
      }

      if (typeof limitEndTime === 'string') {
        limitEndTime = (0, _moment["default"])(limitEndTime);
      }

      if (!limitDate && !limitEndTime) {
        return {};
      }

      var limitHour = 0;
      var limitMinute = 0;
      var limitSecond = 0;
      var limitEndHour = 24;
      var limitEndMinute = 60;
      var limitEndSecond = 60;

      if (limitDate) {
        if (!currentDate.isAfter(limitDate.format('YYYY-MM-DD HH:mm:ss'), 'day') || currentDate.date() === limitDate.date()) {
          limitHour = limitDate.hour();
        }

        if (!currentDate.isAfter(limitDate.format('YYYY-MM-DD HH:mm:ss'), 'minute')) {
          limitMinute = limitDate.minute();
        }

        if (!currentDate.isAfter(limitDate.format('YYYY-MM-DD HH:mm:ss'), 'second')) {
          limitSecond = limitDate.second();
        } // if (!isDateAfter) {
        //   limitHour = limitDate.hour();
        //   limitMinute = limitDate.minute();
        //   limitSecond = limitDate.second();
        // }

      }

      if (limitEndTime) {
        if (!currentDate.isBefore(limitEndTime.format('YYYY-MM-DD HH:mm:ss', 'day')) || currentDate.date() === limitEndTime.date()) {
          limitEndHour = limitEndTime.hour();
        }

        if (!currentDate.isBefore(limitEndTime.format('YYYY-MM-DD HH:mm:ss', 'minute'))) {
          limitEndMinute = limitEndTime.minute();
        }

        if (!currentDate.isBefore(limitEndTime.format('YYYY-MM-DD HH:mm:ss', 'second'))) {
          limitEndSecond = limitEndTime.second();
        } // if (!isDateEndBefore) {
        //   limitEndHour = limitEndTime.hour();
        //   limitEndMinute = limitDate.minute();
        //   limitEndSecond = limitDate.second();
        // }

      }

      return {
        disabledDate: function disabledDate(current) {
          return current && (limitDate && current.format('YYYY-MM-DD') !== limitDate.format('YYYY-MM-DD') || limitEndTime && current.format('YYYY-MM-DD') !== limitEndTime.format('YYYY-MM-DD')) && (limitDate && current && current.isBefore(limitDate.format('YYYY-MM-DD'), 'day') || limitEndTime && current && current.isAfter(limitEndTime.format('YYYY-MM-DD', 'day')));
        },
        disabledTime: function disabledTime() {
          return {
            disabledHours: function disabledHours() {
              return TIME_LIST.slice(0, limitHour).concat(TIME_LIST.slice(limitEndHour + 1, 24));
            },
            disabledMinutes: function disabledMinutes() {
              return TIME_LIST.slice(0, limitMinute).concat(TIME_LIST.slice(limitEndMinute + 1, 60));
            },
            disabledSeconds: function disabledSeconds() {
              return TIME_LIST.slice(0, limitSecond).concat(TIME_LIST.slice(limitEndSecond + 1, 60));
            }
          };
        }
      };
    };

    _this.onOpenChange = function (status) {
      var _this$props2 = _this.props,
          onOpenChange = _this$props2.onOpenChange,
          onChange = _this$props2.onChange,
          limitTime = _this$props2.limitTime,
          limitStartTime = _this$props2.limitStartTime,
          limitEndTime = _this$props2.limitEndTime;
      var current = _this.state.current;

      if (!status) {
        limitStartTime = limitTime || limitStartTime;

        if (typeof limitStartTime === 'string') {
          limitStartTime = (0, _moment["default"])(limitStartTime);
        }

        if (typeof limitEndTime === 'string') {
          limitEndTime = (0, _moment["default"])(limitEndTime);
        }

        if (limitStartTime && current.isBefore(limitStartTime)) {
          _this.setState({
            current: limitStartTime
          }); // tslint:disable-next-line:no-unused-expression


          onChange && onChange(limitStartTime);
        } else if (limitEndTime && current.isAfter(limitEndTime)) {
          _this.setState({
            current: limitEndTime
          }); // tslint:disable-next-line:no-unused-expression


          onChange && onChange(limitEndTime);
        }
      } // tslint:disable-next-line:no-unused-expression


      onOpenChange && onOpenChange(status);
    };

    _this.state = {
      current: _this.initCurrentData()
    };
    return _this;
  }

  _createClass(JDatePicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _a = this.props,
          limitTime = _a.limitTime,
          getRef = _a.getRef,
          _onChange = _a.onChange,
          limitStartTime = _a.limitStartTime,
          limitEndTime = _a.limitEndTime,
          rest = __rest(_a, ["limitTime", "getRef", "onChange", "limitStartTime", "limitEndTime"]);

      var current = this.state.current;
      var limitProps = limitTime || limitStartTime || limitEndTime ? this.getLimitDate(current, limitTime || limitStartTime, limitEndTime) : {};
      return React.createElement(_datePicker["default"], _extends({
        ref: function ref(e) {
          return getRef && getRef(e);
        }
      }, limitProps, rest, {
        onChange: function onChange(date, dateString) {
          _this2.setState({
            current: date || (0, _moment["default"])()
          }); // tslint:disable-next-line:no-unused-expression


          _onChange && _onChange(date, dateString);
        },
        onOpenChange: this.onOpenChange
      }));
    }
  }]);

  return JDatePicker;
}(React.Component); // @ts-ignore


JDatePicker._name = 'JDatePicker'; // @ts-ignore

_datePicker["default"].RangePicker._name = 'RangePicker'; // @ts-ignore

_datePicker["default"].MonthPicker._name = 'MonthPicker'; // @ts-ignore

_datePicker["default"].WeekPicker._name = 'WeekPicker'; //@ts-ignore

JDatePicker.RangePicker = _datePicker["default"].RangePicker; //@ts-ignore

JDatePicker.MonthPicker = _datePicker["default"].MonthPicker; //@ts-ignore

JDatePicker.WeekPicker = _datePicker["default"].WeekPicker;
var _default = JDatePicker;
exports["default"] = _default;