"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.messages = exports.newMessages = void 0;
// tslint:disable-next-line:variable-name
var messages_zh = {
  "default": '%s验证失败',
  required: '%s是必填项',
  "enum": '%s必须是%s之一',
  whitespace: '%s不能为空',
  date: {
    format: '%s的数据%s必须是%s格式',
    parse: '%s无法解析，%s是无效字段',
    invalid: '%s的数据%s是无效字段'
  },
  types: {
    string: '%s不是一个%s',
    method: '%s不是一个%s类型方法',
    array: '%s不是一个%s',
    object: '%s不是一个%s',
    number: '%s不是一个%s',
    date: '%s不是一个%s',
    "boolean": '%s不是一个%s',
    integer: '%s不是一个%s',
    "float": '%s不是一个%s',
    regexp: '%s不是一个有效的%s',
    email: '%s不是一个有效的%s',
    url: '%s不是一个有效的%s',
    hex: '%s不是一个有效的%s'
  },
  string: {
    len: '%s的长度必须是%s',
    min: '%s的长度不能少于%s',
    max: '%s的长度不能大于%s',
    range: '%s的长度必须在%s到%s的范围内'
  },
  number: {
    len: '%s的长度必须是%s',
    min: '%s的长度不能少于%s',
    max: '%s的长度不能大于%s',
    range: '%s的长度必须在%s到%s的范围内'
  },
  array: {
    len: '%s的数量必须是%s',
    min: '%s的数量不能少于%s',
    max: '%s的数量不能大约%s',
    range: '%s的数量必须在%s到%s的范围内'
  },
  pattern: {
    mismatch: '%s的值%s不匹配%s'
  },
  clone: function clone() {
    var cloned = JSON.parse(JSON.stringify(this));
    cloned.clone = this.clone;
    return cloned;
  }
}; // tslint:disable-next-line:variable-name

var messages_en = {
  "default": 'Validation error on field %s',
  required: '%s is required',
  "enum": '%s must be one of %s',
  whitespace: '%s cannot be empty',
  date: {
    format: '%s date %s is invalid for format %s',
    parse: '%s date could not be parsed, %s is invalid ',
    invalid: '%s date %s is invalid'
  },
  types: {
    string: '%s is not a %s',
    method: '%s is not a %s (function)',
    array: '%s is not an %s',
    object: '%s is not an %s',
    number: '%s is not a %s',
    date: '%s is not a %s',
    "boolean": '%s is not a %s',
    integer: '%s is not an %s',
    "float": '%s is not a %s',
    regexp: '%s is not a valid %s',
    email: '%s is not a valid %s',
    url: '%s is not a valid %s',
    hex: '%s is not a valid %s'
  },
  string: {
    len: '%s must be exactly %s characters',
    min: '%s must be at least %s characters',
    max: '%s cannot be longer than %s characters',
    range: '%s must be between %s and %s characters'
  },
  number: {
    len: '%s must equal %s',
    min: '%s cannot be less than %s',
    max: '%s cannot be greater than %s',
    range: '%s must be between %s and %s'
  },
  array: {
    len: '%s must be exactly %s in length',
    min: '%s cannot be less than %s in length',
    max: '%s cannot be greater than %s in length',
    range: '%s must be between %s and %s in length'
  },
  pattern: {
    mismatch: '%s value %s does not match pattern %s'
  },
  clone: function clone() {
    var cloned = JSON.parse(JSON.stringify(this));
    cloned.clone = this.clone;
    return cloned;
  }
};

var newMessages = function newMessages() {
  if (window.locals && window.locals.language === 'en') {
    return messages_en;
  }

  return messages_zh;
};

exports.newMessages = newMessages;
var messages = newMessages();
exports.messages = messages;