"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _input = _interopRequireDefault(require("../input"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  }
  return t;
};

var MyInput = React.forwardRef(function (props, ref) {
  var _props$trim = props.trim,
      trim = _props$trim === void 0 ? true : _props$trim,
      _props$filterChar = props.filterChar,
      filterChar = _props$filterChar === void 0 ? false : _props$filterChar,
      _onChange = props.onChange,
      rest = __rest(props, ["trim", "filterChar", "onChange"]);

  if (trim) {
    trim = trim;
  }

  return React.createElement(_input["default"], _extends({
    ref: ref
  }, rest, {
    onChange: function onChange(e) {
      if (filterChar) {
        e.target.value = e.target.value.replace(/[\/\%\_]/g, '');
      }

      if (trim) {
        e.target.value = e.target.value.trim();
      } // tslint:disable-next-line:no-unused-expression


      _onChange && _onChange(e);
    }
  }));
});

var Search =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Search, _React$Component);

  function Search(props) {
    var _this;

    _classCallCheck(this, Search);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Search).call(this, props));
    _this.state = {};
    return _this;
  }

  _createClass(Search, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _a = this.props,
          _onChange2 = _a.onChange,
          onClear = _a.onClear,
          _a$allowClear = _a.allowClear,
          allowClear = _a$allowClear === void 0 ? true : _a$allowClear,
          readOnly = _a.readOnly,
          _onSearch = _a.onSearch,
          disabled = _a.disabled,
          allowInput = _a.allowInput,
          rest = __rest(_a, ["onChange", "onClear", "allowClear", "readOnly", "onSearch", "disabled", "allowInput"]);

      var rdo = _onSearch && true;

      if (allowInput) {
        rdo = false;
      }

      if (readOnly) {
        rdo = readOnly;
      }

      return React.createElement(_input["default"].Search, _extends({
        className: allowInput && 'jinput-search-allowinput',
        ref: function ref(e) {
          return _this2.searchRef = e;
        },
        disabled: disabled,
        readOnly: rdo,
        onClick: function onClick(e) {
          _onSearch && !disabled && !allowInput && _onSearch(e.target.value, e);
        },
        allowClear: !disabled && allowClear,
        onChange: function onChange(e) {
          if (e.target.value === '') {
            onClear && onClear(e);
          }

          _onChange2 && _onChange2(e);
        },
        onSearch: function onSearch(value, event) {
          if (!disabled) {
            // tslint:disable-next-line:no-unused-expression
            _onSearch && _onSearch(value, event);
          }
        }
      }, rest));
    }
  }]);

  return Search;
}(React.Component);

MyInput._name = 'Input'; // @ts-ignore

Search._name = 'Search'; // @ts-ignore

_input["default"].TextArea._name = 'TextArea'; // @ts-ignore

MyInput.Search = Search;
MyInput.Group = _input["default"].Group;
MyInput.TextArea = _input["default"].TextArea;
MyInput.TextArea = _input["default"].TextArea;
var _default = MyInput;
exports["default"] = _default;