import * as React from 'react';
export interface JModalSearchProps {
    /**
     *  获取dataSource数据 {url:'your url',method:"POST",params:{}}`
     */
    dataSourceParams?: {
        url: string;
        params?: object;
        method?: string;
    };
    /** 获取表头数据 {url:'your url',method:"POST",params:{}} */
    columnsParams?: {
        url?: string;
        params?: object;
        columns?: Array<object>;
    };
    /** 获取表头数据 {url:'your url',method:"POST",params:{}} */
    treeParams?: {
        url: string;
        params?: object;
        formKey: string;
    };
    /** 表头render方法 {dataIndex:'your dataIndex',render:(text,record)=> */
    columnsRender?: Array<object>;
    visible: boolean;
    /** 表头render方法 {dataIndex:'your dataIndex',render:(text,record)=> */
    onChange: (selectKey: any, selectedRow: any) => void;
    /** 获取tree数据 {url:'your url',method:"POST",params:{}} */
    rowKey?: any;
    scroll?: any;
    type?: string;
    /** 获取数据 选择单选框 双击行 点击确定 function({event, dataIndex, record}) */
    JFormData?: Array<object>;
    dataFormat?: any;
}
export interface JModalSearchState {
    visible: boolean;
    dataSource: Object;
    columns: Object;
    selectedRows: Object;
    tree: Array<Object>;
    expandedKeys: Array<string>;
    selectedRowKeys: string;
    treeSelectedKeys: Array<string>;
    dataSourceParams: any;
    columnsRender: any;
    JFormData: any;
    columnsParams: any;
    treeParams: any;
    autoExpandParent: boolean;
    loading: boolean;
    params: any;
    current: number;
    pageSize: number;
    total: number;
    reset: any;
    show: any;
}
declare class JModalSearch extends React.Component<JModalSearchProps, JModalSearchState> {
    form: any;
    state: JModalSearchState;
    onExpand: (expandedKeys: any) => void;
    onSelect: (selectedKeys: any) => void;
    renderTreeNodes: (data: any) => any;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: JModalSearchProps): void;
    componentWillUnmount(): void;
    getDataSource: (params1: any, pageNumber: any, pageSize: any, nextProps?: any, noreset?: any) => void;
    getColumns: (nextProps?: any) => void;
    mergerRenderToColumns: (columns?: any) => never[];
    getTree: (nextProps: any, cb: any) => void;
    renderForm: () => "" | JSX.Element;
    renderTree: () => "" | JSX.Element;
    render(): JSX.Element;
}
export default JModalSearch;
