"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var qs = _interopRequireWildcard(require("qs"));

var _modal = _interopRequireDefault(require("../modal"));

var _tree = _interopRequireDefault(require("../tree"));

var _jForm = _interopRequireDefault(require("../j-form"));

var _message = _interopRequireDefault(require("../message"));

var _standardTable = _interopRequireDefault(require("../standard-table"));

var _request = _interopRequireDefault(require("../_util/request"));

var _utils = require("../_util/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  }
  return t;
};

var TreeNode = _tree["default"].TreeNode;

var formatter = function formatter(data, setKeyTitle) {
  return data.map(function (item) {
    var result = {
      key: item[setKeyTitle.key],
      title: item[setKeyTitle.title]
    };

    if (item.children) {
      result.children = formatter(item.children, setKeyTitle);
    }

    return result;
  });
};

var JModalSearch =
/*#__PURE__*/
function (_React$Component) {
  _inherits(JModalSearch, _React$Component);

  function JModalSearch() {
    var _this;

    _classCallCheck(this, JModalSearch);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(JModalSearch).apply(this, arguments));
    _this.state = {
      expandedKeys: [],
      autoExpandParent: true,
      treeSelectedKeys: [],
      dataSource: [],
      columns: [],
      tree: [],
      current: 1,
      pageSize: 5,
      total: 0,
      visible: _this.props.visible,
      params: {},
      selectedRowKeys: '',
      selectedRows: {},
      loading: false,
      dataSourceParams: _this.props.dataSourceParams,
      columnsRender: _this.props.columnsRender,
      JFormData: _this.props.JFormData,
      treeParams: _this.props.treeParams,
      columnsParams: _this.props.columnsParams,
      reset: 1,
      show: true
    };

    _this.onExpand = function (expandedKeys) {
      _this.setState({
        expandedKeys: expandedKeys,
        autoExpandParent: false
      });
    };

    _this.onSelect = function (selectedKeys) {
      var params = _this.state.params;

      _this.setState({
        treeSelectedKeys: selectedKeys
      }, function () {
        _this.getDataSource(params, 1, 5);
      });
    };

    _this.renderTreeNodes = function (data) {
      return data.map(function (item) {
        if (item.children) {
          return (// @ts-ignore
            React.createElement(TreeNode, {
              title: item.title,
              key: item.key,
              dataRef: item
            }, _this.renderTreeNodes(item.children))
          );
        }

        return React.createElement(TreeNode, _extends({
          key: item.key
        }, item));
      });
    }; // 获取表格数据


    _this.getDataSource = function (params1, pageNumber, pageSize, nextProps, noreset) {
      // 搜索重置选中的keys
      if (!noreset) {
        _this.setState({
          selectedRowKeys: '',
          reset: _this.state.reset + 1
        });
      }

      var _ref = nextProps || _this.state,
          dataSourceParams = _ref.dataSourceParams,
          treeParams = _ref.treeParams;

      if (dataSourceParams) {
        var url = dataSourceParams.url,
            params = dataSourceParams.params,
            _dataSourceParams$met = dataSourceParams.method,
            method = _dataSourceParams$met === void 0 ? 'POST' : _dataSourceParams$met,
            _dataSourceParams$dat = dataSourceParams.dataType,
            dataType = _dataSourceParams$dat === void 0 ? 'json' : _dataSourceParams$dat;

        var body = _extends({
          pageNumber: pageNumber || 1,
          pageSize: pageSize || 5
        }, params, params1);

        if (treeParams && treeParams.formKey) {
          body[treeParams.formKey] = _this.state.treeSelectedKeys[0];
        }

        if (method.toLocaleLowerCase() === 'get') {
          url = "".concat(url, "?").concat(qs.stringify(body));
          body = undefined;
        } else if (dataType.toLocaleLowerCase() !== 'json') {
          var formData = new FormData();
          Object.keys(body).map(function (item) {
            formData.append(item, body[item] || '');
          });
          body = formData;
        }

        _this.setState({
          loading: true
        });

        (0, _request["default"])(url, {
          method: method,
          allowRepeat: true,
          body: body
        }).then(function (res) {
          if (_this.props.dataFormat) {
            res = _this.props.dataFormat(res);
          } // tslint:disable-next-line:no-shadowed-variable


          var _res = res,
              data = _res.data,
              pageNumber = _res.pageNumber,
              pageSize = _res.pageSize,
              rowsCount = _res.rowsCount;
          data = data ? data : []; // tslint:disable-next-line:no-shadowed-variable

          var params = _this.state.params;

          if (data.length === 0 && rowsCount > 0) {
            // 数据异常重置
            _this.getDataSource(params, 1, 5);

            return;
          }

          _this.setState({
            dataSource: data,
            current: pageNumber,
            total: rowsCount,
            pageSize: pageSize,
            loading: false
          });
        })["catch"](function (_error) {
          _this.setState({
            loading: false
          });
        });
      }
    };

    _this.getColumns = function (nextProps) {
      var _ref2 = nextProps || _this.state,
          columnsParams = _ref2.columnsParams;

      if (columnsParams) {
        var url = columnsParams.url,
            params = columnsParams.params,
            columns = columnsParams.columns;

        if (columns) {
          _this.setState({
            columns: _this.mergerRenderToColumns(columns)
          });

          return;
        }

        (0, _request["default"])(url, {
          method: 'POST',
          body: _extends({}, params)
        }).then(function (res) {
          var data = res.data;

          _this.setState({
            columns: _this.mergerRenderToColumns(data)
          });
        })["catch"](function (error) {
          console.warn(error);
        });
      }
    };

    _this.mergerRenderToColumns = function (columns) {
      var columnsRender = _this.state.columnsRender;

      if (columnsRender) {
        columnsRender.forEach(function (element) {
          columns.some(function (element1) {
            if (element1.dataIndex === element.dataIndex) {
              element1.render = element.render;
              return true;
            }

            return false;
          });
        });
      }

      return [].concat(columns);
    };

    _this.getTree = function (nextProps, cb) {
      var _ref3 = nextProps || _this.state,
          treeParams = _ref3.treeParams;

      if (treeParams) {
        var url = treeParams.url,
            params = treeParams.params,
            setKeyTitle = treeParams.setKeyTitle;
        (0, _request["default"])(url, {
          method: 'POST',
          body: _extends({}, params)
        }).then(function (res) {
          var data = res.data;

          if (setKeyTitle) {
            var key = setKeyTitle.key,
                title = setKeyTitle.title;

            if (!key || !title) {
              console.warn('setKeyTitle key and  title is undefined');
            }

            data = formatter(data, setKeyTitle);
          }

          var keys = data.map(function (item) {
            return item.key;
          });

          _this.setState({
            tree: data,
            expandedKeys: keys || [],
            treeSelectedKeys: keys
          }, function () {
            cb();
          });
        })["catch"](function (error) {
          console.warn(error);
        });
      } else {
        cb();
      }
    };

    _this.renderForm = function () {
      var JFormData = _this.state.JFormData;

      if (JFormData) {
        return React.createElement(_jForm["default"], {
          renderAll: true,
          datas: JFormData,
          getRefForm: function getRefForm(e) {
            return _this.form = e;
          },
          isSearch: true,
          onResetClick: function onResetClick() {
            _this.setState({
              treeSelectedKeys: []
            });
          },
          onSearchClick: function onSearchClick() {
            _this.form.validateFields(function (err, values) {
              if (!err) {
                values = _this.form.values();
                var tmp = Object.keys(values);
                var params = {};
                tmp.forEach(function (key) {
                  params[key] = values[key];

                  if (values[key] === undefined) {
                    params[key] = '';
                  }
                });

                _this.setState({
                  params: params
                });

                _this.getDataSource(params, 1, 5);
              }
            });
          }
        });
      } else {
        return '';
      }
    };

    _this.renderTree = function () {
      var tree = _this.state.tree;

      if (tree.length > 0) {
        return React.createElement(_tree["default"] // checkable
        , {
          onExpand: _this.onExpand,
          expandedKeys: _this.state.expandedKeys,
          autoExpandParent: _this.state.autoExpandParent,
          onSelect: _this.onSelect,
          selectedKeys: _this.state.treeSelectedKeys
        }, _this.renderTreeNodes(tree));
      }

      return '';
    };

    return _this;
  }

  _createClass(JModalSearch, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      // console.log(nextProps, 'nextProps');
      var visible = nextProps.visible,
          dataSourceParams = nextProps.dataSourceParams,
          treeParams = nextProps.treeParams,
          columnsParams = nextProps.columnsParams,
          columnsRender = nextProps.columnsRender,
          JFormData = nextProps.JFormData;

      if (visible !== this.state.visible) {
        this.setState({
          visible: visible,
          dataSourceParams: dataSourceParams,
          treeParams: treeParams,
          columnsParams: columnsParams,
          columnsRender: columnsRender,
          JFormData: JFormData
        }, function () {
          if (visible) {
            _this2.getColumns(nextProps);

            _this2.getTree(nextProps, function () {
              _this2.getDataSource({}, 1, 5, nextProps);
            });
          }
        });

        if (visible) {
          this.setState({
            show: true
          });
        }

        if (!visible) {
          this.form && this.form.resetFields();
          setTimeout(function () {
            _this2.setState({
              dataSource: [],
              show: false,
              expandedKeys: [],
              treeSelectedKeys: [],
              columns: [],
              tree: [],
              current: 1,
              pageSize: 5,
              total: 0,
              params: {},
              selectedRowKeys: '',
              selectedRows: {},
              loading: false,
              dataSourceParams: _this2.props.dataSourceParams,
              columnsRender: _this2.props.columnsRender,
              JFormData: _this2.props.JFormData,
              treeParams: _this2.props.treeParams,
              columnsParams: _this2.props.columnsParams
            });
          }, 500);
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.setState = function () {
        return;
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _a = this.props,
          rowKey = _a.rowKey,
          type = _a.type,
          scroll = _a.scroll,
          rest = __rest(_a, ["rowKey", "type", "scroll"]);

      var _this$state = this.state,
          current = _this$state.current,
          pageSize = _this$state.pageSize,
          total = _this$state.total,
          params = _this$state.params,
          reset = _this$state.reset,
          columns = _this$state.columns,
          visible = _this$state.visible,
          show = _this$state.show;
      return React.createElement(_modal["default"], _extends({
        onOk: function onOk() {
          var _this3$state = _this3.state,
              selectedRowKeys = _this3$state.selectedRowKeys,
              selectedRows = _this3$state.selectedRows,
              visible = _this3$state.visible;

          if (selectedRowKeys.length === 0) {
            if (type === 'radio') {
              _message["default"].error((0, _utils.intlFormat)('jlt.jltd.PleaseSelectOneData', "\u8BF7\u9009\u62E9\u4E00\u6761\u6570\u636E"), 3);
            } else {
              _message["default"].error((0, _utils.intlFormat)('jlt.jltd.PleaseSelectOneDataCheckbox', "\u8BF7\u9009\u62E9\u6570\u636E"), 3);
            }

            return;
          }

          if (visible) {
            _this3.props.onChange(selectedRowKeys, selectedRows);
          }
        },
        okText: (0, _utils.intlFormat)('jlt.jltd.Confirm', '确定'),
        maskClosable: false
      }, rest, {
        visible: visible
      }), React.createElement("div", {
        className: "j-modal-search"
      }, this.renderTree(), React.createElement("div", {
        className: "j-modal-search-right"
      }, show && this.renderForm(), show && React.createElement(_standardTable["default"], {
        scroll: scroll,
        reset: reset,
        loading: this.state.loading,
        onSelectRow: function onSelectRow(selectedRowKeys, selectedRows, eventype) {
          if (eventype === 'doubleClick' && type === 'radio') {
            _this3.props.onChange(selectedRowKeys, selectedRows);
          } else {
            _this3.setState({
              selectedRowKeys: selectedRowKeys,
              selectedRows: selectedRows
            });
          }
        },
        type: type || 'checkbox',
        rowKey: rowKey || 'id',
        onChange: function onChange(pagination) {
          // tslint:disable-next-line:no-shadowed-variable
          var current = pagination.current,
              pageSize = pagination.pageSize;

          _this3.getDataSource(params, current, pageSize, '', true);
        },
        selectedRows: [],
        data: {
          list: this.state.dataSource,
          pagination: {
            current: current,
            pageSize: pageSize,
            total: total,
            pageSizeOptions: ['5', '10', '15', '20'],
            showTotal: function showTotal() {
              return React.createElement("div", null, (0, _utils.intlFormat)('jlt.jltd.Gong', '共'), React.createElement("span", {
                style: {
                  margin: '0 10px'
                }
              }, total), ' ', (0, _utils.intlFormat)('jlt.jltd.Tiao', '条'));
            },
            showSizeChanger: true,
            showQuickJumper: false
          }
        },
        columns: columns
      }))));
    }
  }]);

  return JModalSearch;
}(React.Component);

var _default = JModalSearch;
exports["default"] = _default;