"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _modal = _interopRequireDefault(require("../modal"));

var _classnames = _interopRequireDefault(require("classnames"));

var _icon = _interopRequireDefault(require("../icon"));

var _confirm = _interopRequireDefault(require("./confirm"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  }
  return t;
};

var JModal = function JModal() {};

JModal.info = function (props) {
  var className = props.className,
      _props$width = props.width,
      width = _props$width === void 0 ? 360 : _props$width,
      _props$okCancel = props.okCancel,
      okCancel = _props$okCancel === void 0 ? true : _props$okCancel,
      rest = __rest(props, ["className", "width", "okCancel"]);

  var config = _extends({
    type: 'info',
    icon: React.createElement(_icon["default"], {
      type: "info-circle",
      theme: "filled"
    })
  }, rest, {
    okCancel: okCancel,
    width: width,
    className: (0, _classnames["default"])('jlt-modal-fn', className)
  });

  return (0, _confirm["default"])(config);
};

JModal.success = function (props) {
  var className = props.className,
      _props$width2 = props.width,
      width = _props$width2 === void 0 ? 360 : _props$width2,
      _props$okCancel2 = props.okCancel,
      okCancel = _props$okCancel2 === void 0 ? true : _props$okCancel2,
      rest = __rest(props, ["className", "width", "okCancel"]);

  var config = _extends({
    type: 'success',
    icon: React.createElement(_icon["default"], {
      type: "check-circle",
      theme: "filled"
    })
  }, rest, {
    okCancel: okCancel,
    width: width,
    className: (0, _classnames["default"])('jlt-modal-fn', className)
  });

  return (0, _confirm["default"])(config);
};

JModal.error = function (props) {
  var className = props.className,
      _props$width3 = props.width,
      width = _props$width3 === void 0 ? 360 : _props$width3,
      _props$okCancel3 = props.okCancel,
      okCancel = _props$okCancel3 === void 0 ? true : _props$okCancel3,
      rest = __rest(props, ["className", "width", "okCancel"]);

  var config = _extends({
    type: 'error',
    icon: React.createElement(_icon["default"], {
      type: "close-circle",
      theme: "filled"
    })
  }, rest, {
    okCancel: okCancel,
    width: width,
    className: (0, _classnames["default"])('jlt-modal-fn', className)
  });

  return (0, _confirm["default"])(config);
};

JModal.warning = JModal.warn = function (props) {
  var className = props.className,
      _props$width4 = props.width,
      width = _props$width4 === void 0 ? 360 : _props$width4,
      _props$okCancel4 = props.okCancel,
      okCancel = _props$okCancel4 === void 0 ? true : _props$okCancel4,
      rest = __rest(props, ["className", "width", "okCancel"]);

  var config = _extends({
    type: 'warning',
    icon: React.createElement(_icon["default"], {
      type: "exclamation-circle",
      theme: "filled"
    })
  }, rest, {
    okCancel: okCancel,
    width: width,
    className: (0, _classnames["default"])('jlt-modal-fn', className)
  });

  return (0, _confirm["default"])(config);
};

JModal.confirm = function (props) {
  var className = props.className,
      _props$width5 = props.width,
      width = _props$width5 === void 0 ? 360 : _props$width5,
      rest = __rest(props, ["className", "width"]);

  var config = _extends({
    type: 'confirm'
  }, rest, {
    confirm: _confirm["default"],
    width: width,
    className: (0, _classnames["default"])('jlt-modal-fn', className)
  });

  return (0, _confirm["default"])(config);
};

JModal.destroyAll = _modal["default"].destroyAll;
var _default = JModal;
exports["default"] = _default;