"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _dva = require("dva");

var _router = require("dva/router");

var React = _interopRequireWildcard(require("react"));

var _reactIntl = require("react-intl");

var _en = _interopRequireDefault(require("react-intl/locale-data/en"));

var _zh = _interopRequireDefault(require("react-intl/locale-data/zh"));

var _localeProvider = _interopRequireDefault(require("../locale-provider"));

var _request = _interopRequireDefault(require("../request"));

var _en_US = _interopRequireDefault(require("../locale-provider/en_US"));

var _zh_CN = _interopRequireDefault(require("../locale-provider/zh_CN"));

var _jUtil = _interopRequireDefault(require("../j-util"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __decorate = void 0 && (void 0).__decorate || function (decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
    if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  }
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};

if (!window.locals) {
  window.locals = {
    language: 'zh',
    messages: {}
  };
}

_jUtil["default"].jltIntl.initDefaultMessage();

var errList = {};
var lg = window.locals && window.locals.language || 'zh';
var appLocale = {
  jltd: lg === 'zh' ? _zh_CN["default"] : _en_US["default"],
  locale: lg || 'zh',
  messages: window.locals.data || {},
  formats: {
    date: {
      normal: {
        hour12: false,
        year: 'numeric',
        month: '2-digit',
        day: '2-digit',
        hour: '2-digit',
        minute: '2-digit'
      }
    }
  }
};
lg === 'zh' ? (0, _reactIntl.addLocaleData)(_zh["default"]) : (0, _reactIntl.addLocaleData)(_en["default"]);
var ConnectedRouter = _router.routerRedux.ConnectedRouter;
var errCount = 0;

var RouterConfiga =
/*#__PURE__*/
function (_React$Component) {
  _inherits(RouterConfiga, _React$Component);

  function RouterConfiga(props) {
    var _this;

    _classCallCheck(this, RouterConfiga);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RouterConfiga).call(this, props));

    _this.addLocalMessage = function (params) {
      var formdata = new FormData(); // eslint-disable-next-line guard-for-in
      // tslint:disable-next-line:forin

      for (var key in params) {
        formdata.append(key, params[key]);
      }

      (0, _request["default"])('/minima/language/save', {
        method: 'POST',
        body: params
      }).then(function (_res) {
        errCount -= 1;
        console.warn(errCount, 'errCount');
      });
    };

    _this.onError = function (err, data) {
      var _window = window,
          global = _window.global;

      if (!data || err.indexOf('Missing message') === -1 || global && !global.menuCode || data.id == 'jlt.tenant') {
        return;
      }

      if (!errList[data.id] && data.id && data.defaultMessage) {
        errList[data.id] = data;
        errCount += 1;

        _this.addLocalMessage({
          i18nKey: data.id,
          name: data.defaultMessage,
          i18nMenuCode: global.menuCode
        });
      }
    }; // tslint:disable-next-line:no-unused-expression


    !props.config.readLocalMenu && props.dispatch({
      type: 'global/fetchMenu'
    });
    return _this;
  }

  _createClass(RouterConfiga, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          history = _this$props.history,
          app = _this$props.app,
          _this$props$global = _this$props.global,
          global = _this$props$global === void 0 ? {
        menudata: []
      } : _this$props$global,
          config = _this$props.config,
          getMenuData = _this$props.getMenuData,
          getRouterData = _this$props.getRouterData,
          _this$props$localMess = _this$props.localMessage,
          localMessage = _this$props$localMess === void 0 ? {
        en: {},
        zh: {}
      } : _this$props$localMess;
      var menudata = global.menudata;

      if (config.readLocalMenu) {
        menudata = getMenuData();
      }

      var routerData = getRouterData(app, menudata);
      var BasicLayout = routerData['/'].component;
      return React.createElement(_localeProvider["default"], {
        locale: appLocale.jltd
      }, React.createElement(_reactIntl.IntlProvider, {
        locale: appLocale.locale,
        messages: _extends({}, appLocale.messages, localMessage[lg]),
        formats: appLocale.formats // @ts-ignore
        ,
        onError: this.onError
      }, React.createElement(ConnectedRouter, {
        history: history
      }, React.createElement(_router.Switch, null, React.createElement(_router.Route, {
        path: "/",
        render: function render(props) {
          return React.createElement(BasicLayout, props);
        }
      })))));
    }
  }]);

  return RouterConfiga;
}(React.Component);

RouterConfiga = __decorate([(0, _dva.connect)(function (_ref) {
  var global = _ref.global;
  return {
    global: global
  };
})], RouterConfiga);
var _default = RouterConfiga;
exports["default"] = _default;