import * as React from "react";
import { TableProps, TableRowSelection } from "antd/es/table/interface";
interface Iprops<T> extends TableProps<T> {
    isRowSelect?: boolean;
    scrollWidth?: number | string;
    scrollHeight?: number | string;
    showPagination?: boolean;
    singleExanded?: boolean;
    total?: number;
    rowKey?: string;
    rowSelection?: TableRowSelection<T>;
    onPageChange?: (currentPage: number, size: number) => void;
}
interface IState {
    expandedRowKeys?: string[] | number[];
    selectedRowKeys: string[];
    selectedRows: Object[];
    page: number | string;
    pageSize: number | string;
}
export default class MyTable<T> extends React.Component<Iprops<T>, IState> {
    static defaultProps: {
        isRowSelect: boolean;
        rowKey: string;
        scrollWidth: number;
        scrollHeight: number;
        showPagination: boolean;
        singleExanded: boolean;
    };
    constructor(props: Iprops<T>);
    buildPorps: () => {
        expandedRowKeys: string[] | number[];
        onExpandedRowsChange: (rows: any) => void;
        pagination: boolean;
        isRowSelect?: boolean | undefined;
        scrollWidth?: string | number | undefined;
        scrollHeight?: string | number | undefined;
        showPagination?: boolean | undefined;
        singleExanded?: boolean | undefined;
        total?: number | undefined;
        rowKey?: string | undefined;
        rowSelection?: TableRowSelection<T> | undefined;
        onPageChange?: ((currentPage: number, size: number) => void) | undefined;
        prefixCls?: string | undefined;
        dropdownPrefixCls?: string | undefined;
        size?: "small" | "default" | "middle" | undefined;
        dataSource?: T[] | undefined;
        components?: import("antd/es/table/interface").TableComponents | undefined;
        columns?: import("antd/es/table/interface").ColumnProps<T>[] | undefined;
        rowClassName?: ((record: T, index: number) => string) | undefined;
        expandedRowRender?: ((record: T, index: number, indent: number, expanded: boolean) => React.ReactNode) | undefined;
        defaultExpandAllRows?: boolean | undefined;
        defaultExpandedRowKeys?: string[] | number[] | undefined;
        expandIcon?: ((props: import("antd/es/table/interface").ExpandIconProps<T>) => React.ReactNode) | undefined;
        expandIconAsCell?: boolean | undefined;
        expandIconColumnIndex?: number | undefined;
        expandRowByClick?: boolean | undefined;
        onExpand?: ((expanded: boolean, record: T) => void) | undefined;
        onChange?: ((pagination: import("antd/es/pagination/Pagination").PaginationConfig, filters: Record<keyof T, string[]>, sorter: import("antd/es/table/interface").SorterResult<T>, extra: import("antd/es/table/interface").TableCurrentDataSource<T>) => void) | undefined;
        loading?: boolean | import("antd/es/spin").SpinProps | undefined;
        locale?: import("antd/es/table/interface").TableLocale | undefined;
        indentSize?: number | undefined;
        onRowClick?: ((record: T, index: number, event: Event) => void) | undefined;
        onRow?: ((record: T, index: number) => any) | undefined;
        onHeaderRow?: ((columns: import("antd/es/table/interface").ColumnProps<T>[], index: number) => any) | undefined;
        useFixedHeader?: boolean | undefined;
        bordered?: boolean | undefined;
        showHeader?: boolean | undefined;
        footer?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        title?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        scroll: {
            x?: string | number | boolean | undefined;
            y?: string | number | boolean | undefined;
        } | {
            x: string | number | undefined;
            y: string | number | undefined;
        };
        childrenColumnName?: string | undefined;
        bodyStyle?: React.CSSProperties | undefined;
        className?: string | undefined;
        style?: React.CSSProperties | undefined;
        children?: React.ReactNode;
        sortDirections?: import("antd/es/table/interface").SortOrder[] | undefined;
        selectedRowKeys: string[];
        selectedRows: Object[];
    } | {
        expandedRowKeys: string[] | number[];
        onExpandedRowsChange: (rows: any) => void;
        pagination: boolean;
        isRowSelect?: boolean | undefined;
        scrollWidth?: string | number | undefined;
        scrollHeight?: string | number | undefined;
        showPagination?: boolean | undefined;
        singleExanded?: boolean | undefined;
        total?: number | undefined;
        rowKey?: string | undefined;
        rowSelection?: TableRowSelection<T> | undefined;
        onPageChange?: ((currentPage: number, size: number) => void) | undefined;
        prefixCls?: string | undefined;
        dropdownPrefixCls?: string | undefined;
        size?: "small" | "default" | "middle" | undefined;
        dataSource?: T[] | undefined;
        components?: import("antd/es/table/interface").TableComponents | undefined;
        columns?: import("antd/es/table/interface").ColumnProps<T>[] | undefined;
        rowClassName?: ((record: T, index: number) => string) | undefined;
        expandedRowRender?: ((record: T, index: number, indent: number, expanded: boolean) => React.ReactNode) | undefined;
        defaultExpandAllRows?: boolean | undefined;
        defaultExpandedRowKeys?: string[] | number[] | undefined;
        expandIcon?: ((props: import("antd/es/table/interface").ExpandIconProps<T>) => React.ReactNode) | undefined;
        expandIconAsCell?: boolean | undefined;
        expandIconColumnIndex?: number | undefined;
        expandRowByClick?: boolean | undefined;
        onExpand?: ((expanded: boolean, record: T) => void) | undefined;
        onChange?: ((pagination: import("antd/es/pagination/Pagination").PaginationConfig, filters: Record<keyof T, string[]>, sorter: import("antd/es/table/interface").SorterResult<T>, extra: import("antd/es/table/interface").TableCurrentDataSource<T>) => void) | undefined;
        loading?: boolean | import("antd/es/spin").SpinProps | undefined;
        locale?: import("antd/es/table/interface").TableLocale | undefined;
        indentSize?: number | undefined;
        onRowClick?: ((record: T, index: number, event: Event) => void) | undefined;
        onRow?: ((record: T, index: number) => any) | undefined;
        onHeaderRow?: ((columns: import("antd/es/table/interface").ColumnProps<T>[], index: number) => any) | undefined;
        useFixedHeader?: boolean | undefined;
        bordered?: boolean | undefined;
        showHeader?: boolean | undefined;
        footer?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        title?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        scroll: {
            x?: string | number | boolean | undefined;
            y?: string | number | boolean | undefined;
        } | {
            x: string | number | undefined;
            y: string | number | undefined;
        };
        childrenColumnName?: string | undefined;
        bodyStyle?: React.CSSProperties | undefined;
        className?: string | undefined;
        style?: React.CSSProperties | undefined;
        children?: React.ReactNode;
        sortDirections?: import("antd/es/table/interface").SortOrder[] | undefined;
        selectedRowKeys: string[];
        selectedRows: Object[];
    } | {
        expandedRowKeys: string[] | number[];
        onExpandedRowsChange: (rows: any) => void;
        pagination: boolean;
        isRowSelect?: boolean | undefined;
        scrollWidth?: string | number | undefined;
        scrollHeight?: string | number | undefined;
        showPagination?: boolean | undefined;
        singleExanded?: boolean | undefined;
        total?: number | undefined;
        rowKey?: string | undefined;
        rowSelection: TableRowSelection<T> | {
            selectedRowKeys: string[];
            onChange: (selectedRowKeys: any, selectedRows: any) => void;
            onSelect: (record: any, selected: any, selectedRows: any, nativeEvent: any) => void;
            onSelectAll: (selected: any, selectedRows: any, changeRows: any) => void;
            onSelectInvert: (selectedRows: any) => void;
        } | {
            selectedRowKeys: string[];
            onChange: (selectedRowKeys: any, selectedRows: any) => void;
            onSelect: (record: any, selected: any, selectedRows: any, nativeEvent: any) => void;
            onSelectAll: (selected: any, selectedRows: any, changeRows: any) => void;
            onSelectInvert: (selectedRows: any) => void;
            type?: "checkbox" | "radio" | undefined;
            getCheckboxProps?: ((record: T) => Object) | undefined;
            onSelectMultiple?: ((selected: boolean, selectedRows: T[], changeRows: T[]) => void) | undefined;
            selections?: boolean | import("antd/es/table/interface").SelectionItem[] | undefined;
            hideDefaultSelections?: boolean | undefined;
            fixed?: boolean | undefined;
            columnWidth?: string | number | undefined;
            selectWay?: "onSelect" | "onSelectMultiple" | "onSelectAll" | "onSelectInvert" | undefined;
            columnTitle?: React.ReactNode;
        };
        onPageChange?: ((currentPage: number, size: number) => void) | undefined;
        prefixCls?: string | undefined;
        dropdownPrefixCls?: string | undefined;
        size?: "small" | "default" | "middle" | undefined;
        dataSource?: T[] | undefined;
        components?: import("antd/es/table/interface").TableComponents | undefined;
        columns?: import("antd/es/table/interface").ColumnProps<T>[] | undefined;
        rowClassName?: ((record: T, index: number) => string) | undefined;
        expandedRowRender?: ((record: T, index: number, indent: number, expanded: boolean) => React.ReactNode) | undefined;
        defaultExpandAllRows?: boolean | undefined;
        defaultExpandedRowKeys?: string[] | number[] | undefined;
        expandIcon?: ((props: import("antd/es/table/interface").ExpandIconProps<T>) => React.ReactNode) | undefined;
        expandIconAsCell?: boolean | undefined;
        expandIconColumnIndex?: number | undefined;
        expandRowByClick?: boolean | undefined;
        onExpand?: ((expanded: boolean, record: T) => void) | undefined;
        onChange?: ((pagination: import("antd/es/pagination/Pagination").PaginationConfig, filters: Record<keyof T, string[]>, sorter: import("antd/es/table/interface").SorterResult<T>, extra: import("antd/es/table/interface").TableCurrentDataSource<T>) => void) | undefined;
        loading?: boolean | import("antd/es/spin").SpinProps | undefined;
        locale?: import("antd/es/table/interface").TableLocale | undefined;
        indentSize?: number | undefined;
        onRowClick?: ((record: T, index: number, event: Event) => void) | undefined;
        onRow?: ((record: T, index: number) => any) | undefined;
        onHeaderRow?: ((columns: import("antd/es/table/interface").ColumnProps<T>[], index: number) => any) | undefined;
        useFixedHeader?: boolean | undefined;
        bordered?: boolean | undefined;
        showHeader?: boolean | undefined;
        footer?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        title?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        scroll: {
            x?: string | number | boolean | undefined;
            y?: string | number | boolean | undefined;
        } | {
            x: string | number | undefined;
            y: string | number | undefined;
        };
        childrenColumnName?: string | undefined;
        bodyStyle?: React.CSSProperties | undefined;
        className?: string | undefined;
        style?: React.CSSProperties | undefined;
        children?: React.ReactNode;
        sortDirections?: import("antd/es/table/interface").SortOrder[] | undefined;
        selectedRowKeys: string[];
        selectedRows: Object[];
    } | {
        expandedRowKeys: string[] | number[];
        onExpandedRowsChange: (rows: any) => void;
        pagination: boolean;
        isRowSelect?: boolean | undefined;
        scrollWidth?: string | number | undefined;
        scrollHeight?: string | number | undefined;
        showPagination?: boolean | undefined;
        singleExanded?: boolean | undefined;
        total?: number | undefined;
        rowKey?: string | undefined;
        rowSelection?: TableRowSelection<T> | undefined;
        onPageChange?: ((currentPage: number, size: number) => void) | undefined;
        prefixCls?: string | undefined;
        dropdownPrefixCls?: string | undefined;
        size?: "small" | "default" | "middle" | undefined;
        dataSource?: T[] | undefined;
        components?: import("antd/es/table/interface").TableComponents | undefined;
        columns?: import("antd/es/table/interface").ColumnProps<T>[] | undefined;
        rowClassName?: ((record: T, index: number) => string) | undefined;
        expandedRowRender?: ((record: T, index: number, indent: number, expanded: boolean) => React.ReactNode) | undefined;
        defaultExpandAllRows?: boolean | undefined;
        defaultExpandedRowKeys?: string[] | number[] | undefined;
        expandIcon?: ((props: import("antd/es/table/interface").ExpandIconProps<T>) => React.ReactNode) | undefined;
        expandIconAsCell?: boolean | undefined;
        expandIconColumnIndex?: number | undefined;
        expandRowByClick?: boolean | undefined;
        onExpand?: ((expanded: boolean, record: T) => void) | undefined;
        onChange?: ((pagination: import("antd/es/pagination/Pagination").PaginationConfig, filters: Record<keyof T, string[]>, sorter: import("antd/es/table/interface").SorterResult<T>, extra: import("antd/es/table/interface").TableCurrentDataSource<T>) => void) | undefined;
        loading?: boolean | import("antd/es/spin").SpinProps | undefined;
        locale?: import("antd/es/table/interface").TableLocale | undefined;
        indentSize?: number | undefined;
        onRowClick?: ((record: T, index: number, event: Event) => void) | undefined;
        onRow?: ((record: T, index: number) => any) | undefined;
        onHeaderRow?: ((columns: import("antd/es/table/interface").ColumnProps<T>[], index: number) => any) | undefined;
        useFixedHeader?: boolean | undefined;
        bordered?: boolean | undefined;
        showHeader?: boolean | undefined;
        footer?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        title?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        scroll: {
            x?: string | number | boolean | undefined;
            y?: string | number | boolean | undefined;
        } | {
            x: string | number | undefined;
            y: string | number | undefined;
        };
        childrenColumnName?: string | undefined;
        bodyStyle?: React.CSSProperties | undefined;
        className?: string | undefined;
        style?: React.CSSProperties | undefined;
        children?: React.ReactNode;
        sortDirections?: import("antd/es/table/interface").SortOrder[] | undefined;
        selectedRowKeys: string[];
        selectedRows: Object[];
    } | {
        expandedRowKeys: string[] | number[];
        onExpandedRowsChange: (rows: any) => void;
        pagination: {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            total: number;
            showTotal: (total: any) => string;
            showSizeChanger: boolean;
            showQuickJumper: boolean;
            current: number;
            pageSize: number;
        } | {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            total: number;
            showTotal: (total: any) => string;
            showSizeChanger: boolean;
            showQuickJumper: boolean;
            current: number;
            pageSize: number;
        } | {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            position?: "both" | "top" | "bottom" | undefined;
            total: number;
            defaultCurrent?: number | undefined;
            current: number;
            defaultPageSize?: number | undefined;
            pageSize: number;
            hideOnSinglePage?: boolean | undefined;
            showSizeChanger: boolean;
            pageSizeOptions?: string[] | undefined;
            showQuickJumper: boolean | {
                goButton?: React.ReactNode;
            };
            showTotal: ((total: number, range: [number, number]) => React.ReactNode) | ((total: any) => string);
            size?: string | undefined;
            simple?: boolean | undefined;
            style?: React.CSSProperties | undefined;
            locale?: Object | undefined;
            className?: string | undefined;
            prefixCls?: string | undefined;
            selectPrefixCls?: string | undefined;
            itemRender?: ((page: number, type: "next" | "prev" | "page" | "jump-prev" | "jump-next", originalElement: React.ReactElement<HTMLElement, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>) => React.ReactNode) | undefined;
            role?: string | undefined;
            showLessItems?: boolean | undefined;
        };
        isRowSelect?: boolean | undefined;
        scrollWidth?: string | number | undefined;
        scrollHeight?: string | number | undefined;
        showPagination?: boolean | undefined;
        singleExanded?: boolean | undefined;
        total?: number | undefined;
        rowKey?: string | undefined;
        rowSelection?: TableRowSelection<T> | undefined;
        onPageChange?: ((currentPage: number, size: number) => void) | undefined;
        prefixCls?: string | undefined;
        dropdownPrefixCls?: string | undefined;
        size?: "small" | "default" | "middle" | undefined;
        dataSource?: T[] | undefined;
        components?: import("antd/es/table/interface").TableComponents | undefined;
        columns?: import("antd/es/table/interface").ColumnProps<T>[] | undefined;
        rowClassName?: ((record: T, index: number) => string) | undefined;
        expandedRowRender?: ((record: T, index: number, indent: number, expanded: boolean) => React.ReactNode) | undefined;
        defaultExpandAllRows?: boolean | undefined;
        defaultExpandedRowKeys?: string[] | number[] | undefined;
        expandIcon?: ((props: import("antd/es/table/interface").ExpandIconProps<T>) => React.ReactNode) | undefined;
        expandIconAsCell?: boolean | undefined;
        expandIconColumnIndex?: number | undefined;
        expandRowByClick?: boolean | undefined;
        onExpand?: ((expanded: boolean, record: T) => void) | undefined;
        onChange?: ((pagination: import("antd/es/pagination/Pagination").PaginationConfig, filters: Record<keyof T, string[]>, sorter: import("antd/es/table/interface").SorterResult<T>, extra: import("antd/es/table/interface").TableCurrentDataSource<T>) => void) | undefined;
        loading?: boolean | import("antd/es/spin").SpinProps | undefined;
        locale?: import("antd/es/table/interface").TableLocale | undefined;
        indentSize?: number | undefined;
        onRowClick?: ((record: T, index: number, event: Event) => void) | undefined;
        onRow?: ((record: T, index: number) => any) | undefined;
        onHeaderRow?: ((columns: import("antd/es/table/interface").ColumnProps<T>[], index: number) => any) | undefined;
        useFixedHeader?: boolean | undefined;
        bordered?: boolean | undefined;
        showHeader?: boolean | undefined;
        footer?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        title?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        scroll: {
            x?: string | number | boolean | undefined;
            y?: string | number | boolean | undefined;
        } | {
            x: string | number | undefined;
            y: string | number | undefined;
        };
        childrenColumnName?: string | undefined;
        bodyStyle?: React.CSSProperties | undefined;
        className?: string | undefined;
        style?: React.CSSProperties | undefined;
        children?: React.ReactNode;
        sortDirections?: import("antd/es/table/interface").SortOrder[] | undefined;
        selectedRowKeys: string[];
        selectedRows: Object[];
    } | {
        expandedRowKeys: string[] | number[];
        onExpandedRowsChange: (rows: any) => void;
        pagination: boolean;
        isRowSelect?: boolean | undefined;
        scrollWidth?: string | number | undefined;
        scrollHeight?: string | number | undefined;
        showPagination?: boolean | undefined;
        singleExanded?: boolean | undefined;
        total?: number | undefined;
        rowKey?: string | undefined;
        rowSelection?: TableRowSelection<T> | undefined;
        onPageChange?: ((currentPage: number, size: number) => void) | undefined;
        prefixCls?: string | undefined;
        dropdownPrefixCls?: string | undefined;
        size?: "small" | "default" | "middle" | undefined;
        dataSource?: T[] | undefined;
        components?: import("antd/es/table/interface").TableComponents | undefined;
        columns?: import("antd/es/table/interface").ColumnProps<T>[] | undefined;
        rowClassName?: ((record: T, index: number) => string) | undefined;
        expandedRowRender?: ((record: T, index: number, indent: number, expanded: boolean) => React.ReactNode) | undefined;
        defaultExpandAllRows?: boolean | undefined;
        defaultExpandedRowKeys?: string[] | number[] | undefined;
        expandIcon?: ((props: import("antd/es/table/interface").ExpandIconProps<T>) => React.ReactNode) | undefined;
        expandIconAsCell?: boolean | undefined;
        expandIconColumnIndex?: number | undefined;
        expandRowByClick?: boolean | undefined;
        onExpand?: ((expanded: boolean, record: T) => void) | undefined;
        onChange?: ((pagination: import("antd/es/pagination/Pagination").PaginationConfig, filters: Record<keyof T, string[]>, sorter: import("antd/es/table/interface").SorterResult<T>, extra: import("antd/es/table/interface").TableCurrentDataSource<T>) => void) | undefined;
        loading?: boolean | import("antd/es/spin").SpinProps | undefined;
        locale?: import("antd/es/table/interface").TableLocale | undefined;
        indentSize?: number | undefined;
        onRowClick?: ((record: T, index: number, event: Event) => void) | undefined;
        onRow?: ((record: T, index: number) => any) | undefined;
        onHeaderRow?: ((columns: import("antd/es/table/interface").ColumnProps<T>[], index: number) => any) | undefined;
        useFixedHeader?: boolean | undefined;
        bordered?: boolean | undefined;
        showHeader?: boolean | undefined;
        footer?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        title?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        scroll: {
            x?: string | number | boolean | undefined;
            y?: string | number | boolean | undefined;
        } | {
            x: string | number | undefined;
            y: string | number | undefined;
        };
        childrenColumnName?: string | undefined;
        bodyStyle?: React.CSSProperties | undefined;
        className?: string | undefined;
        style?: React.CSSProperties | undefined;
        children?: React.ReactNode;
        sortDirections?: import("antd/es/table/interface").SortOrder[] | undefined;
        selectedRowKeys: string[];
        selectedRows: Object[];
    } | {
        expandedRowKeys: string[] | number[];
        onExpandedRowsChange: (rows: any) => void;
        pagination: {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            total: number;
            showTotal: (total: any) => string;
            showSizeChanger: boolean;
            showQuickJumper: boolean;
            current: number;
            pageSize: number;
        } | {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            total: number;
            showTotal: (total: any) => string;
            showSizeChanger: boolean;
            showQuickJumper: boolean;
            current: number;
            pageSize: number;
        } | {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            position?: "both" | "top" | "bottom" | undefined;
            total: number;
            defaultCurrent?: number | undefined;
            current: number;
            defaultPageSize?: number | undefined;
            pageSize: number;
            hideOnSinglePage?: boolean | undefined;
            showSizeChanger: boolean;
            pageSizeOptions?: string[] | undefined;
            showQuickJumper: boolean | {
                goButton?: React.ReactNode;
            };
            showTotal: ((total: number, range: [number, number]) => React.ReactNode) | ((total: any) => string);
            size?: string | undefined;
            simple?: boolean | undefined;
            style?: React.CSSProperties | undefined;
            locale?: Object | undefined;
            className?: string | undefined;
            prefixCls?: string | undefined;
            selectPrefixCls?: string | undefined;
            itemRender?: ((page: number, type: "next" | "prev" | "page" | "jump-prev" | "jump-next", originalElement: React.ReactElement<HTMLElement, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>) => React.ReactNode) | undefined;
            role?: string | undefined;
            showLessItems?: boolean | undefined;
        };
        isRowSelect?: boolean | undefined;
        scrollWidth?: string | number | undefined;
        scrollHeight?: string | number | undefined;
        showPagination?: boolean | undefined;
        singleExanded?: boolean | undefined;
        total?: number | undefined;
        rowKey?: string | undefined;
        rowSelection?: TableRowSelection<T> | undefined;
        onPageChange?: ((currentPage: number, size: number) => void) | undefined;
        prefixCls?: string | undefined;
        dropdownPrefixCls?: string | undefined;
        size?: "small" | "default" | "middle" | undefined;
        dataSource?: T[] | undefined;
        components?: import("antd/es/table/interface").TableComponents | undefined;
        columns?: import("antd/es/table/interface").ColumnProps<T>[] | undefined;
        rowClassName?: ((record: T, index: number) => string) | undefined;
        expandedRowRender?: ((record: T, index: number, indent: number, expanded: boolean) => React.ReactNode) | undefined;
        defaultExpandAllRows?: boolean | undefined;
        defaultExpandedRowKeys?: string[] | number[] | undefined;
        expandIcon?: ((props: import("antd/es/table/interface").ExpandIconProps<T>) => React.ReactNode) | undefined;
        expandIconAsCell?: boolean | undefined;
        expandIconColumnIndex?: number | undefined;
        expandRowByClick?: boolean | undefined;
        onExpand?: ((expanded: boolean, record: T) => void) | undefined;
        onChange?: ((pagination: import("antd/es/pagination/Pagination").PaginationConfig, filters: Record<keyof T, string[]>, sorter: import("antd/es/table/interface").SorterResult<T>, extra: import("antd/es/table/interface").TableCurrentDataSource<T>) => void) | undefined;
        loading?: boolean | import("antd/es/spin").SpinProps | undefined;
        locale?: import("antd/es/table/interface").TableLocale | undefined;
        indentSize?: number | undefined;
        onRowClick?: ((record: T, index: number, event: Event) => void) | undefined;
        onRow?: ((record: T, index: number) => any) | undefined;
        onHeaderRow?: ((columns: import("antd/es/table/interface").ColumnProps<T>[], index: number) => any) | undefined;
        useFixedHeader?: boolean | undefined;
        bordered?: boolean | undefined;
        showHeader?: boolean | undefined;
        footer?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        title?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        scroll: {
            x?: string | number | boolean | undefined;
            y?: string | number | boolean | undefined;
        } | {
            x: string | number | undefined;
            y: string | number | undefined;
        };
        childrenColumnName?: string | undefined;
        bodyStyle?: React.CSSProperties | undefined;
        className?: string | undefined;
        style?: React.CSSProperties | undefined;
        children?: React.ReactNode;
        sortDirections?: import("antd/es/table/interface").SortOrder[] | undefined;
        selectedRowKeys: string[];
        selectedRows: Object[];
    } | {
        expandedRowKeys: string[] | number[];
        onExpandedRowsChange: (rows: any) => void;
        pagination: boolean;
        isRowSelect?: boolean | undefined;
        scrollWidth?: string | number | undefined;
        scrollHeight?: string | number | undefined;
        showPagination?: boolean | undefined;
        singleExanded?: boolean | undefined;
        total?: number | undefined;
        rowKey?: string | undefined;
        rowSelection: TableRowSelection<T> | {
            selectedRowKeys: string[];
            onChange: (selectedRowKeys: any, selectedRows: any) => void;
            onSelect: (record: any, selected: any, selectedRows: any, nativeEvent: any) => void;
            onSelectAll: (selected: any, selectedRows: any, changeRows: any) => void;
            onSelectInvert: (selectedRows: any) => void;
        } | {
            selectedRowKeys: string[];
            onChange: (selectedRowKeys: any, selectedRows: any) => void;
            onSelect: (record: any, selected: any, selectedRows: any, nativeEvent: any) => void;
            onSelectAll: (selected: any, selectedRows: any, changeRows: any) => void;
            onSelectInvert: (selectedRows: any) => void;
            type?: "checkbox" | "radio" | undefined;
            getCheckboxProps?: ((record: T) => Object) | undefined;
            onSelectMultiple?: ((selected: boolean, selectedRows: T[], changeRows: T[]) => void) | undefined;
            selections?: boolean | import("antd/es/table/interface").SelectionItem[] | undefined;
            hideDefaultSelections?: boolean | undefined;
            fixed?: boolean | undefined;
            columnWidth?: string | number | undefined;
            selectWay?: "onSelect" | "onSelectMultiple" | "onSelectAll" | "onSelectInvert" | undefined;
            columnTitle?: React.ReactNode;
        };
        onPageChange?: ((currentPage: number, size: number) => void) | undefined;
        prefixCls?: string | undefined;
        dropdownPrefixCls?: string | undefined;
        size?: "small" | "default" | "middle" | undefined;
        dataSource?: T[] | undefined;
        components?: import("antd/es/table/interface").TableComponents | undefined;
        columns?: import("antd/es/table/interface").ColumnProps<T>[] | undefined;
        rowClassName?: ((record: T, index: number) => string) | undefined;
        expandedRowRender?: ((record: T, index: number, indent: number, expanded: boolean) => React.ReactNode) | undefined;
        defaultExpandAllRows?: boolean | undefined;
        defaultExpandedRowKeys?: string[] | number[] | undefined;
        expandIcon?: ((props: import("antd/es/table/interface").ExpandIconProps<T>) => React.ReactNode) | undefined;
        expandIconAsCell?: boolean | undefined;
        expandIconColumnIndex?: number | undefined;
        expandRowByClick?: boolean | undefined;
        onExpand?: ((expanded: boolean, record: T) => void) | undefined;
        onChange?: ((pagination: import("antd/es/pagination/Pagination").PaginationConfig, filters: Record<keyof T, string[]>, sorter: import("antd/es/table/interface").SorterResult<T>, extra: import("antd/es/table/interface").TableCurrentDataSource<T>) => void) | undefined;
        loading?: boolean | import("antd/es/spin").SpinProps | undefined;
        locale?: import("antd/es/table/interface").TableLocale | undefined;
        indentSize?: number | undefined;
        onRowClick?: ((record: T, index: number, event: Event) => void) | undefined;
        onRow?: ((record: T, index: number) => any) | undefined;
        onHeaderRow?: ((columns: import("antd/es/table/interface").ColumnProps<T>[], index: number) => any) | undefined;
        useFixedHeader?: boolean | undefined;
        bordered?: boolean | undefined;
        showHeader?: boolean | undefined;
        footer?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        title?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        scroll: {
            x?: string | number | boolean | undefined;
            y?: string | number | boolean | undefined;
        } | {
            x: string | number | undefined;
            y: string | number | undefined;
        };
        childrenColumnName?: string | undefined;
        bodyStyle?: React.CSSProperties | undefined;
        className?: string | undefined;
        style?: React.CSSProperties | undefined;
        children?: React.ReactNode;
        sortDirections?: import("antd/es/table/interface").SortOrder[] | undefined;
        selectedRowKeys: string[];
        selectedRows: Object[];
    } | {
        expandedRowKeys: string[] | number[];
        onExpandedRowsChange: (rows: any) => void;
        pagination: {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            total: number;
            showTotal: (total: any) => string;
            showSizeChanger: boolean;
            showQuickJumper: boolean;
            current: number;
            pageSize: number;
        } | {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            total: number;
            showTotal: (total: any) => string;
            showSizeChanger: boolean;
            showQuickJumper: boolean;
            current: number;
            pageSize: number;
        } | {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            position?: "both" | "top" | "bottom" | undefined;
            total: number;
            defaultCurrent?: number | undefined;
            current: number;
            defaultPageSize?: number | undefined;
            pageSize: number;
            hideOnSinglePage?: boolean | undefined;
            showSizeChanger: boolean;
            pageSizeOptions?: string[] | undefined;
            showQuickJumper: boolean | {
                goButton?: React.ReactNode;
            };
            showTotal: ((total: number, range: [number, number]) => React.ReactNode) | ((total: any) => string);
            size?: string | undefined;
            simple?: boolean | undefined;
            style?: React.CSSProperties | undefined;
            locale?: Object | undefined;
            className?: string | undefined;
            prefixCls?: string | undefined;
            selectPrefixCls?: string | undefined;
            itemRender?: ((page: number, type: "next" | "prev" | "page" | "jump-prev" | "jump-next", originalElement: React.ReactElement<HTMLElement, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>) => React.ReactNode) | undefined;
            role?: string | undefined;
            showLessItems?: boolean | undefined;
        };
        isRowSelect?: boolean | undefined;
        scrollWidth?: string | number | undefined;
        scrollHeight?: string | number | undefined;
        showPagination?: boolean | undefined;
        singleExanded?: boolean | undefined;
        total?: number | undefined;
        rowKey?: string | undefined;
        rowSelection: TableRowSelection<T> | {
            selectedRowKeys: string[];
            onChange: (selectedRowKeys: any, selectedRows: any) => void;
            onSelect: (record: any, selected: any, selectedRows: any, nativeEvent: any) => void;
            onSelectAll: (selected: any, selectedRows: any, changeRows: any) => void;
            onSelectInvert: (selectedRows: any) => void;
        } | {
            selectedRowKeys: string[];
            onChange: (selectedRowKeys: any, selectedRows: any) => void;
            onSelect: (record: any, selected: any, selectedRows: any, nativeEvent: any) => void;
            onSelectAll: (selected: any, selectedRows: any, changeRows: any) => void;
            onSelectInvert: (selectedRows: any) => void;
            type?: "checkbox" | "radio" | undefined;
            getCheckboxProps?: ((record: T) => Object) | undefined;
            onSelectMultiple?: ((selected: boolean, selectedRows: T[], changeRows: T[]) => void) | undefined;
            selections?: boolean | import("antd/es/table/interface").SelectionItem[] | undefined;
            hideDefaultSelections?: boolean | undefined;
            fixed?: boolean | undefined;
            columnWidth?: string | number | undefined;
            selectWay?: "onSelect" | "onSelectMultiple" | "onSelectAll" | "onSelectInvert" | undefined;
            columnTitle?: React.ReactNode;
        };
        onPageChange?: ((currentPage: number, size: number) => void) | undefined;
        prefixCls?: string | undefined;
        dropdownPrefixCls?: string | undefined;
        size?: "small" | "default" | "middle" | undefined;
        dataSource?: T[] | undefined;
        components?: import("antd/es/table/interface").TableComponents | undefined;
        columns?: import("antd/es/table/interface").ColumnProps<T>[] | undefined;
        rowClassName?: ((record: T, index: number) => string) | undefined;
        expandedRowRender?: ((record: T, index: number, indent: number, expanded: boolean) => React.ReactNode) | undefined;
        defaultExpandAllRows?: boolean | undefined;
        defaultExpandedRowKeys?: string[] | number[] | undefined;
        expandIcon?: ((props: import("antd/es/table/interface").ExpandIconProps<T>) => React.ReactNode) | undefined;
        expandIconAsCell?: boolean | undefined;
        expandIconColumnIndex?: number | undefined;
        expandRowByClick?: boolean | undefined;
        onExpand?: ((expanded: boolean, record: T) => void) | undefined;
        onChange?: ((pagination: import("antd/es/pagination/Pagination").PaginationConfig, filters: Record<keyof T, string[]>, sorter: import("antd/es/table/interface").SorterResult<T>, extra: import("antd/es/table/interface").TableCurrentDataSource<T>) => void) | undefined;
        loading?: boolean | import("antd/es/spin").SpinProps | undefined;
        locale?: import("antd/es/table/interface").TableLocale | undefined;
        indentSize?: number | undefined;
        onRowClick?: ((record: T, index: number, event: Event) => void) | undefined;
        onRow?: ((record: T, index: number) => any) | undefined;
        onHeaderRow?: ((columns: import("antd/es/table/interface").ColumnProps<T>[], index: number) => any) | undefined;
        useFixedHeader?: boolean | undefined;
        bordered?: boolean | undefined;
        showHeader?: boolean | undefined;
        footer?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        title?: ((currentPageData: Object[]) => React.ReactNode) | undefined;
        scroll: {
            x?: string | number | boolean | undefined;
            y?: string | number | boolean | undefined;
        } | {
            x: string | number | undefined;
            y: string | number | undefined;
        };
        childrenColumnName?: string | undefined;
        bodyStyle?: React.CSSProperties | undefined;
        className?: string | undefined;
        style?: React.CSSProperties | undefined;
        children?: React.ReactNode;
        sortDirections?: import("antd/es/table/interface").SortOrder[] | undefined;
        selectedRowKeys: string[];
        selectedRows: Object[];
    };
    render(): JSX.Element;
    buildRowSelection: () => {
        rowSelection: {
            selectedRowKeys: string[];
            onChange: (selectedRowKeys: any, selectedRows: any) => void;
            onSelect: (record: any, selected: any, selectedRows: any, nativeEvent: any) => void;
            onSelectAll: (selected: any, selectedRows: any, changeRows: any) => void;
            onSelectInvert: (selectedRows: any) => void;
        } | {
            selectedRowKeys: string[];
            onChange: (selectedRowKeys: any, selectedRows: any) => void;
            onSelect: (record: any, selected: any, selectedRows: any, nativeEvent: any) => void;
            onSelectAll: (selected: any, selectedRows: any, changeRows: any) => void;
            onSelectInvert: (selectedRows: any) => void;
            type?: "checkbox" | "radio" | undefined;
            getCheckboxProps?: ((record: T) => Object) | undefined;
            onSelectMultiple?: ((selected: boolean, selectedRows: T[], changeRows: T[]) => void) | undefined;
            selections?: boolean | import("antd/es/table/interface").SelectionItem[] | undefined;
            hideDefaultSelections?: boolean | undefined;
            fixed?: boolean | undefined;
            columnWidth?: string | number | undefined;
            selectWay?: "onSelect" | "onSelectMultiple" | "onSelectAll" | "onSelectInvert" | undefined;
            columnTitle?: React.ReactNode;
        };
    };
    setSelectedRowKeys: (selectedRowKeys?: never[]) => void;
    setSelectRows: (selectedRows?: any[]) => void;
    clearSelectRowKeys: () => void;
    resetPagination: (params: any) => void;
    resetExpanded: (expandedRowKeys?: never[]) => void;
    buildPagination: () => {
        pagination: {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            total: number;
            showTotal: (total: any) => string;
            showSizeChanger: boolean;
            showQuickJumper: boolean;
            current: number;
            pageSize: number;
        } | {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            total: number;
            showTotal: (total: any) => string;
            showSizeChanger: boolean;
            showQuickJumper: boolean;
            current: number;
            pageSize: number;
        } | {
            onChange: (page: any, pageSize: any) => void;
            onShowSizeChange: (currentPage: any, size: any) => void;
            position?: "both" | "top" | "bottom" | undefined;
            total: number;
            defaultCurrent?: number | undefined;
            current: number;
            defaultPageSize?: number | undefined;
            pageSize: number;
            hideOnSinglePage?: boolean | undefined;
            showSizeChanger: boolean;
            pageSizeOptions?: string[] | undefined;
            showQuickJumper: boolean | {
                goButton?: React.ReactNode;
            };
            showTotal: ((total: number, range: [number, number]) => React.ReactNode) | ((total: any) => string);
            size?: string | undefined;
            simple?: boolean | undefined;
            style?: React.CSSProperties | undefined;
            locale?: Object | undefined;
            className?: string | undefined;
            prefixCls?: string | undefined;
            selectPrefixCls?: string | undefined;
            itemRender?: ((page: number, type: "next" | "prev" | "page" | "jump-prev" | "jump-next", originalElement: React.ReactElement<HTMLElement, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>) => React.ReactNode) | undefined;
            role?: string | undefined;
            showLessItems?: boolean | undefined;
        };
    };
}
export {};
