"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = NoticeList;

var React = _interopRequireWildcard(require("react"));

var _avatar = _interopRequireDefault(require("antd/es/avatar"));

var _list = _interopRequireDefault(require("antd/es/list"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var preCls = 'ant-pro-noticelist';
var Ilist = _list["default"];

function NoticeList(_ref) {
  var _ref$data = _ref.data,
      data = _ref$data === void 0 ? [] : _ref$data,
      _onClick = _ref.onClick,
      onClear = _ref.onClear,
      title = _ref.title,
      locale = _ref.locale,
      emptyText = _ref.emptyText,
      emptyImage = _ref.emptyImage;

  if (data.length === 0) {
    return React.createElement("div", {
      className: "".concat(preCls, "-notFound")
    }, emptyImage ? React.createElement("img", {
      src: emptyImage,
      alt: "not found"
    }) : null, React.createElement("div", null, emptyText || locale.emptyText));
  }

  return React.createElement("div", null, React.createElement(Ilist, {
    className: preCls
  }, data.map(function (item, i) {
    var itemCls = (0, _classnames["default"])('item', _defineProperty({}, 'read', item.read));
    return React.createElement(Ilist.Item, {
      className: itemCls,
      key: item.key || i,
      onClick: function onClick() {
        return _onClick(item);
      }
    }, React.createElement(_list["default"].Item.Meta, {
      className: 'meta',
      avatar: item.avatar ? React.createElement(_avatar["default"], {
        className: 'avatar',
        src: item.avatar
      }) : null,
      title: React.createElement("div", {
        className: 'title'
      }, item.title, React.createElement("div", {
        className: 'extra'
      }, item.extra)),
      description: React.createElement("div", null, React.createElement("div", {
        className: 'description',
        title: item.description
      }, item.description), React.createElement("div", {
        className: 'datetime'
      }, item.datetime))
    }));
  })), React.createElement("div", {
    className: "".concat(preCls, "-clear"),
    onClick: onClear
  }, locale.clear, title));
}