"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var React = _interopRequireWildcard(require("react"));

var _badge = _interopRequireDefault(require("../badge"));

var _icon = _interopRequireDefault(require("../icon"));

var _popover = _interopRequireDefault(require("../popover"));

var _spin = _interopRequireDefault(require("../spin"));

var _tabs = _interopRequireDefault(require("../tabs"));

var _utils = require("../_util/utils");

var _NoticeList = _interopRequireDefault(require("./NoticeList"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var preCls = 'ant-pro-popover';
var TabPane = _tabs["default"].TabPane;

var NoticeIcon =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(NoticeIcon, _PureComponent);

  function NoticeIcon(props) {
    var _this;

    _classCallCheck(this, NoticeIcon);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(NoticeIcon).call(this, props));

    _this.onItemClick = function (item, tabProps) {
      var onItemClick = _this.props.onItemClick;
      onItemClick(item, tabProps);
    };

    _this.onTabChange = function (tabType) {
      _this.setState({
        tabType: tabType
      });

      var onTabChange = _this.props.onTabChange;
      onTabChange(tabType);
    };

    var tabType = '';

    if (props.children && props.children[0]) {
      tabType = props.children[0].props.title;
    }

    _this.state = {
      tabType: tabType
    };
    return _this;
  }

  _createClass(NoticeIcon, [{
    key: "getNotificationBox",
    value: function getNotificationBox() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          loading = _this$props.loading,
          locale = _this$props.locale,
          _onClear = _this$props.onClear;

      if (!children) {
        return null;
      }

      var panes = React.Children.map(children, function (child) {
        var title = child.props.list && child.props.list.length > 0 ? "".concat(child.props.title, " (").concat(child.props.list.length, ")") : child.props.title;
        return React.createElement(TabPane, {
          tab: title,
          key: child.props.title
        }, React.createElement(_NoticeList["default"], _extends({}, child.props, {
          data: child.props.list,
          onClick: function onClick(item) {
            return _this2.onItemClick(item, child.props);
          },
          onClear: function onClear() {
            return _onClear(child.props.title);
          },
          title: child.props.title,
          locale: locale
        })));
      });
      return React.createElement(_spin["default"], {
        spinning: loading,
        delay: 0
      }, React.createElement(_tabs["default"], {
        className: "".concat(preCls, "-tabs"),
        onChange: this.onTabChange
      }, panes));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          count = _this$props2.count,
          popupAlign = _this$props2.popupAlign,
          onPopupVisibleChange = _this$props2.onPopupVisibleChange,
          popupVisible = _this$props2.popupVisible;
      var noticeButtonClass = (0, _classnames["default"])(className, "".concat(preCls, "-noticeButton"));
      var notificationBox = this.getNotificationBox();
      var trigger = React.createElement("span", {
        className: noticeButtonClass
      }, React.createElement(_badge["default"], {
        count: count,
        className: "".concat(preCls, "-badge")
      }, React.createElement(_icon["default"], {
        type: "bell",
        className: "".concat(preCls, "-icon")
      })));

      if (!notificationBox) {
        return trigger;
      }

      var popoverProps = {};

      if ('popupVisible' in this.props) {
        popoverProps.visible = popupVisible;
      }

      return React.createElement(_popover["default"], _extends({
        placement: "bottomRight",
        content: notificationBox,
        popupClassName: preCls,
        trigger: "click",
        arrowPointAtCenter: true,
        popupAlign: popupAlign,
        onVisibleChange: onPopupVisibleChange
      }, popoverProps), trigger);
    }
  }]);

  return NoticeIcon;
}(React.PureComponent);

exports["default"] = NoticeIcon;
NoticeIcon.Tab = TabPane;
NoticeIcon.defaultProps = {
  onItemClick: function onItemClick() {},
  onPopupVisibleChange: function onPopupVisibleChange() {},
  onTabChange: function onTabChange() {},
  onClear: function onClear() {},
  loading: false,
  locale: {
    emptyText: (0, _utils.intlFormat)('jlt.jltd.noDataAvailableForTheTimeBeing', '暂无数据'),
    clear: (0, _utils.intlFormat)('jlt.jltd.Empty', '清空')
  },
  emptyImage: 'https://gw.alipayobjects.com/zos/rmsportal/wAhyIChODzsoKIOBHcBk.svg'
};