"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _jsBigDecimal = _interopRequireDefault(require("js-big-decimal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
数量精度：QUANTITY_SCALE INT(8)
重量精度：WEIGHT_SCALE INT(8)
长宽高精度：SIZE_SCALE INT(8)
体积精度：VOLUME_SCALE INT(8)
商品单价精度：SKU_PRICE_SCALE INT(8)
金额精度：AMOUNT_SCALE INT(8)
精度舍入规则：ROUNDING_MODE INT(8) */
// @ts-ignore
window.jlt = window.jlt || {};
window.jlt.scale = {
  'QUANTITY_SCALE': 2,
  'WEIGHT_SCALE': 2,
  'SIZE_SCALE': 2,
  'VOLUME_SCALE': 2,
  'SKU_PRICE_SCALE': 2,
  'AMOUNT_SCALE': 2,
  'ROUNDING_MODE': 2
};

function isNotCompleteNumber(num) {
  return isNaN(num) || num === '' || num === null || num && num.toString().indexOf('.') === num.toString().length - 1;
}

var toFixed = function toFixed(numvalue, precision) {
  if (isNotCompleteNumber(numvalue)) {
    return numvalue;
  } // const des = `${numvalue}`;
  // if (des.length === 15 && des.indexOf('.') === -1) {
  //   return des;
  // }
  // if (des.length === 14 && des.indexOf('.') === -1) {
  //   return des;
  // }


  var num = new _jsBigDecimal["default"]("".concat(numvalue)); // @ts-ignore 默认四舍五入

  var mode = _jsBigDecimal["default"].RoundingModes.HALF_UP; // @ts-ignore 向上取舍

  if (window.ROUNDING_MODE === 0) {
    mode = _jsBigDecimal["default"].RoundingModes.UP;
  } // @ts-ignore 向下取舍


  if (window.ROUNDING_MODE === 1) {
    mode = _jsBigDecimal["default"].RoundingModes.DOWN;
  } // 加上精度补零超出最长理长度情进行重新计算精度


  var precisionFixed = precision; // if (des.indexOf('.') > 0) {
  //   const desLength = des.split('.')[0].length;
  //   precisionFixed = 14 - desLength < precision ? 14 - desLength : precision;
  //   return num.round(precisionFixed, mode).value;
  // }
  // precisionFixed = 14 - des.length < precision ? 14 - des.length : precision;

  var ret = num.round(precisionFixed, mode); // "123.6"
  // 0.00001*0.00001 ==== 0.00001

  var minValue = "".concat(0 .toFixed(precision).slice(0, 0 .toFixed(precision).length - 1), "1");

  if (Number(ret.value) === 0 && Number(numvalue) !== 0) {
    return minValue;
  }

  return ret.value;
};

var _default = {
  toFixed: toFixed,
  QUANTITY_SCALE: window.jlt.scale.QUANTITY_SCALE,
  WEIGHT_SCALE: window.jlt.scale.WEIGHT_SCALE,
  SIZE_SCALE: window.jlt.scale.SIZE_SCALE,
  VOLUME_SCALE: window.jlt.scale.VOLUME_SCALE,
  SKU_PRICE_SCALE: window.jlt.scale.SKU_PRICE_SCALE,
  AMOUNT_SCALE: window.jlt.scale.AMOUNT_SCALE,
  ROUNDING_MODE: window.jlt.scale.ROUNDING_MODE
};
/* import {numberUtils} from "jltd";
numberUtils.SKU_PRICE_SCALE=2;
numberUtils.toFixed(12313.3333,numberUtils.SKU_PRICE_SCALE); */

exports["default"] = _default;