"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _dva = require("dva");

var _router = require("dva/router");

var _button = _interopRequireDefault(require("antd/es/button"));

var _Icon = _interopRequireDefault(require("antd/es/Icon"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var React = _interopRequireWildcard(require("react"));

var _LocaleReceiver = _interopRequireDefault(require("../locale-provider/LocaleReceiver"));

var _zh_CN = _interopRequireDefault(require("../locale-provider/zh_CN"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var PureComponent = React.PureComponent;

var PageHeader =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(PageHeader, _PureComponent);

  function PageHeader() {
    var _this;

    _classCallCheck(this, PageHeader);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PageHeader).apply(this, arguments));

    _this.backOnClick = function () {
      _this.props.dispatch(_router.routerRedux.goBack());
    };

    _this.renderTitle = function (title) {
      if (!title) {
        return null;
      }

      return React.createElement("div", {
        className: (0, _classnames["default"])('title_block')
      }, React.createElement("div", {
        className: (0, _classnames["default"])('blue_block')
      }), React.createElement("h1", {
        className: (0, _classnames["default"])('title_text')
      }, title));
    };

    return _this;
  }

  _createClass(PageHeader, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          title = _this$props.title,
          showBackBtn = _this$props.showBackBtn,
          className = _this$props.className;
      var clsString = (0, _classnames["default"])('pageHeader', className);

      var renderBack = function renderBack(locale) {
        return showBackBtn ? React.createElement(_button["default"], {
          type: "ghost",
          onClick: _this2.backOnClick
        }, React.createElement(_Icon["default"], {
          type: "rollback"
        }), locale.backText) : null;
      };

      return React.createElement("div", {
        className: clsString
      }, React.createElement("div", {
        className: (0, _classnames["default"])('page_row')
      }, this.renderTitle(title)), React.createElement("div", {
        className: (0, _classnames["default"])('page_row')
      }, showBackBtn && React.createElement(_button["default"], {
        type: "ghost",
        onClick: this.backOnClick
      }, React.createElement(_LocaleReceiver["default"], {
        componentName: "PageHeader",
        defaultLocale: _zh_CN["default"].JForm
      }, renderBack))));
    }
  }]);

  return PageHeader;
}(PureComponent);

PageHeader.contextTypes = {
  routes: _propTypes["default"].array,
  params: _propTypes["default"].object,
  location: _propTypes["default"].object
};

var _default = (0, _dva.connect)()(PageHeader);

exports["default"] = _default;