"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _pagination = _interopRequireDefault(require("../pagination"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// 分页 props 可选: defaultCurrent 当前分页默认是1 pageSize 分页条数 默认为全局配置的PageSize
// onPageSizeChange  pageSize 变化的回调 className 必须: onChange 页码改变的回调 total 总数
function showTotal(total) {
  return "\u603B\u5171 ".concat(total, " \u6761");
}

var Paginationcomponent =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Paginationcomponent, _React$Component);

  function Paginationcomponent(props) {
    var _this;

    _classCallCheck(this, Paginationcomponent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Paginationcomponent).call(this, props));

    _this.onChange = function (page, pageSize) {
      _this.setState({
        current: page
      }, function () {
        var onChange = _this.props.onChange;
        onChange(page, pageSize);
      });
    };

    _this.onPageSizeChange = function (current, size) {
      _this.setState({
        pageSize: size,
        current: current
      }, function () {
        var onPageSizeChange = _this.props.onPageSizeChange;
        var pageSize = _this.state.pageSize;

        if (onPageSizeChange) {
          onPageSizeChange(pageSize);
        }
      });
    };

    var defaultCurrent = props.defaultCurrent,
        pageSize = props.pageSize;
    _this.state = {
      current: defaultCurrent || 1,
      pageSize: pageSize || 10
    };
    return _this;
  }

  _createClass(Paginationcomponent, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.current && nextProps.current !== this.state.current) {
        this.setState({
          current: nextProps.current
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          total = _this$props.total;
      var _this$state = this.state,
          current = _this$state.current,
          pageSize = _this$state.pageSize; // const pageSize = Math.ceil(total /);

      return React.createElement("div", {
        className: (0, _classnames["default"])(className, 'self-pagination-style')
      }, React.createElement(_pagination["default"], {
        current: current,
        total: total,
        pageSize: pageSize,
        onChange: this.onChange,
        showSizeChanger: true,
        showQuickJumper: true,
        showTotal: showTotal,
        onShowSizeChange: this.onPageSizeChange,
        pageSizeOptions: this.props.pageSizeOptions || ['10', '20', '30', '40']
      }));
    }
  }]);

  return Paginationcomponent;
}(React.Component);

var _default = Paginationcomponent;
exports["default"] = _default;