"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Result;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _icon = _interopRequireDefault(require("../icon"));

var _Success = _interopRequireDefault(require("./Success"));

var _Error = _interopRequireDefault(require("./Error"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  }
  return t;
};

var preCls = 'ant-result';

function Result(_a) {
  var className = _a.className,
      type = _a.type,
      title = _a.title,
      description = _a.description,
      extra = _a.extra,
      actions = _a.actions,
      restProps = __rest(_a, ["className", "type", "title", "description", "extra", "actions"]);

  var iconMap = {
    error: React.createElement(_icon["default"], {
      className: "error",
      type: "close-circle"
    }),
    success: React.createElement(_icon["default"], {
      className: "success",
      type: "check-circle"
    })
  };
  var clsString = (0, _classnames["default"])(preCls, className);
  return React.createElement("div", _extends({
    className: clsString
  }, restProps), React.createElement("div", {
    className: "icon"
  }, iconMap[type]), React.createElement("div", {
    className: "title"
  }, title), description && React.createElement("div", {
    className: "description"
  }, description), extra && React.createElement("div", {
    className: "extra"
  }, extra), actions && React.createElement("div", {
    className: "actions"
  }, actions));
} // @ts-ignore


Result.resultRouter = function (app, dynamicWrapper) {
  return {
    '/result/success': {
      // @ts-ignore
      component: dynamicWrapper(app, [], function () {
        return _Success["default"];
      })
    },
    '/result/fail': {
      // @ts-ignore
      component: dynamicWrapper(app, [], function () {
        return _Error["default"];
      })
    }
  };
};