"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.getMenuMatchKeys = exports.getFlatMenuKeys = void 0;

var _jsonpath = _interopRequireDefault(require("jsonpath/jsonpath.min"));

var React = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _icon = _interopRequireDefault(require("../icon"));

var _jIcon = _interopRequireDefault(require("../j-icon"));

var _layout = _interopRequireDefault(require("../layout"));

var _menu = _interopRequireDefault(require("../menu"));

var _pathTools = require("../_util/pathTools");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var pathToRegexp = require('path-to-regexp');

var Sider = _layout["default"].Sider;
var SubMenu = _menu["default"].SubMenu;
var preCls = 'ant-sidermenu'; // Allow menu.js config icon as string or ReactNode
//   icon: 'setting',
//   icon: 'http://demo.com/icon.png',
//   icon: <Icon type="setting" />,

var getIcon = function getIcon(icon) {
  if (typeof icon === 'string') {
    if (icon.indexOf('http') === 0) {
      return React.createElement("img", {
        src: icon,
        alt: "icon",
        className: "".concat(preCls, "-icon sider-menu-item-img")
      });
    }

    return React.createElement(_icon["default"], {
      type: icon
    });
  }

  return icon;
};
/**
 * Recursively flatten the data
 * [{path:string},{path:string}] => [path,path2]
 * @param  menu
 */


var getFlatMenuKeys = function getFlatMenuKeys(menu) {
  return menu.reduce(function (keys, item) {
    keys.push(item.path);

    if (item.children) {
      return keys.concat(getFlatMenuKeys(item.children));
    }

    return keys;
  }, []);
};
/**
 * Find all matched menu keys based on paths
 * @param  flatMenuKeys: [/abc, /abc/:id, /abc/:id/info]
 * @param  paths: [/abc, /abc/11, /abc/11/info]
 */


exports.getFlatMenuKeys = getFlatMenuKeys;

var getMenuMatchKeys = function getMenuMatchKeys(flatMenuKeys, paths) {
  return paths.reduce(function (matchKeys, path) {
    return matchKeys.concat(flatMenuKeys.filter(function (item) {
      return pathToRegexp(item).test(path);
    }));
  }, []);
};

exports.getMenuMatchKeys = getMenuMatchKeys;

var SiderMenu =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(SiderMenu, _React$PureComponent);

  function SiderMenu(props) {
    var _this;

    _classCallCheck(this, SiderMenu);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SiderMenu).call(this, props));

    _this.getPath = function (path) {
      var val = "".concat(path);

      if (val.indexOf('#') > 0) {
        val = val.split('#')[1];
      }

      return val;
    };
    /**
     * 判断是否是http链接.返回 Link 或 a
     * Judge whether it is http link.return a or Link
     * @memberof SiderMenu
     */


    _this.getMenuItemPath = function (item) {
      var itemPath = _this.conversionPath(item.path);

      var icon = getIcon(item.icon);
      var target = item.target,
          name = item.name; // Is it a http link

      if (/^https?:\/\//.test(itemPath)) {
        return React.createElement("a", {
          href: itemPath,
          target: target
        }, icon, React.createElement("span", null, name));
      }

      var _this$props = _this.props,
          location = _this$props.location,
          isMobile = _this$props.isMobile,
          onCollapse = _this$props.onCollapse;
      return (
        /*  <a
        href={`#${itemPath}`}
        target={target}
        onClick={
          isMobile
            ? () => {
                onCollapse(true);
              }
            : undefined
        }
        >
        {icon}
        <span>{name}</span>
        </a> */
        React.createElement(_reactRouterDom.Link, {
          title: name,
          to: itemPath,
          target: target,
          replace: itemPath === location.pathname,
          onClick: isMobile ? function () {
            onCollapse(true);
          } : undefined
        }, icon, React.createElement("span", null, name))
      );
    };
    /**
     * get SubMenu or Item
     */


    _this.getSubMenuOrItem = function (item) {
      if (item.children && item.children.some(function (child) {
        return child.name;
      })) {
        var childrenItems = _this.getNavMenuItems(item.children); // 当无子菜单时就不展示菜单


        if (childrenItems && childrenItems.length > 0) {
          return React.createElement(SubMenu, {
            title: item.icon ? React.createElement("span", null, getIcon(item.icon), React.createElement("span", {
              title: item.name
            }, item.name)) : item.name,
            key: item.path
          }, childrenItems);
        }

        return null;
      }

      return React.createElement(_menu["default"].Item, {
        key: item.path
      }, _this.getMenuItemPath(item));
    };
    /**
     * 获得菜单子节点
     * @memberof SiderMenu
     */


    _this.getNavMenuItems = function (menusData) {
      if (!menusData) {
        return [];
      }

      return menusData.filter(function (item) {
        return item.name && !item.hideInMenu;
      }).map(function (item) {
        // make dom
        var ItemDom = _this.getSubMenuOrItem(item);

        return _this.checkPermissionItem(item.authority, ItemDom);
      }).filter(function (item) {
        return item;
      });
    }; // Get the currently selected menu


    _this.getSelectedMenuKeys = function () {
      var pathname = _this.props.location.pathname;
      return getMenuMatchKeys(_this.flatMenuKeys, (0, _pathTools.urlToList)(pathname));
    }; // conversion Path
    // 转化路径


    _this.conversionPath = function (path) {
      if (path && path.indexOf('http') === 0) {
        return path;
      }

      return "/".concat(path || '').replace(/\/+/g, '/');
    }; // permission to check


    _this.checkPermissionItem = function (authority, ItemDom) {
      var Authorized = _this.props.Authorized;

      if (Authorized && Authorized.check) {
        var check = Authorized.check;
        return check(authority, ItemDom);
      }

      return ItemDom;
    };

    _this.isMainMenu = function (key) {
      var menuData = _this.props.menuData;
      return menuData.some(function (item) {
        return key && (item.key === key || item.path === key);
      });
    };

    _this.handleOpenChange = function (openKeys) {
      var lastOpenKey = openKeys[openKeys.length - 1];
      var moreThanOne = openKeys.filter(function (openKey) {
        return _this.isMainMenu(openKey);
      }).length > 1;

      _this.setState({
        openKeys: moreThanOne ? [lastOpenKey] : _toConsumableArray(openKeys)
      });
    };

    _this.handleClick = function (_ref) {
      var keyPath = _ref.keyPath;

      _this.setState({
        selectedKeys: keyPath,
        openKeys: keyPath
      });
    };

    _this.toggle = function () {
      var _this$props2 = _this.props,
          collapsed = _this$props2.collapsed,
          onCollapse = _this$props2.onCollapse;
      onCollapse(!collapsed);
    };

    _this.flatMenuKeys = getFlatMenuKeys(props.menuData);
    _this.state = {
      menuData: props.menuData || [],
      openKeys: _this.getDefaultCollapsedSubMenus(props),
      collapsed: false
    };
    return _this;
  }

  _createClass(SiderMenu, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var location = this.props.location;

      if (nextProps.location.pathname !== location.pathname || "".concat(nextProps.menuData) !== "".concat(this.state.menuData)) {
        if (nextProps.location.pathname.indexOf('importTemplate') > 0) {
          return;
        }

        this.setState({
          openKeys: this.getDefaultCollapsedSubMenus(nextProps)
        });
      }
    }
    /**
     * Convert pathname to openKeys
     * /list/search/articles = > ['list','/list/search']
     * @param  props
     */

    /*  getDefaultCollapsedSubMenus(props: any) {
      const {
        location: { pathname },
      } =
        props || this.props;
      return getMenuMatchKeys(this.flatMenuKeys, urlToList(pathname));
    } */

  }, {
    key: "getDefaultCollapsedSubMenus",
    value: function getDefaultCollapsedSubMenus(props) {
      var _this2 = this;

      var menuData = props.menuData;

      var _ref2 = props || this.props,
          pathname = _ref2.location.pathname;

      var parentPathname = pathname.substring(0, pathname.lastIndexOf('/'));

      var nodes = _jsonpath["default"].nodes(menuData, '$..path');

      var fd = nodes.find(function (value) {
        var val = "".concat(value.value);

        if (val.indexOf('#') > 0) {
          val = val.split('#')[1];
        }

        return val.toLowerCase() === pathname.toLowerCase();
      });

      if (!fd) {
        fd = nodes.find(function (value) {
          var val = "".concat(value.value);

          if (val.indexOf('#') > 0) {
            val = val.split('#')[1];
          }

          return val.toLowerCase() === parentPathname.toLowerCase();
        });
      }

      if (!fd) {
        return [];
      }

      var fdf = fd.path.filter(function (val) {
        if (typeof val === 'number') {
          return true;
        }

        return false;
      });
      var keys = fdf.map(function (val, i) {
        switch (i) {
          case 0:
            return _this2.getPath(menuData[val].path);

          case 1:
            return _this2.getPath(menuData[fdf[0]].children[val].path);

          case 2:
            return _this2.getPath(menuData[fdf[0]].children[fdf[1]].children[val].path);

          default:
            return null;
        }
      }); // keys = keys.map((val: any) => val.toLowerCase());

      return keys;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var menuData = this.props.menuData;
      var _this$state = this.state,
          openKeys = _this$state.openKeys,
          collapsed = _this$state.collapsed; // Don't show popup menu when it is been collapsed

      var menuProps = collapsed ? {} : {
        openKeys: openKeys
      }; // if pathname can't match, use the nearest parent's key

      var selectedKeys = this.getSelectedMenuKeys();

      if (!selectedKeys.length) {
        selectedKeys = [openKeys[openKeys.length - 1]];
      }

      return React.createElement(Sider, {
        collapsible: true,
        collapsed: collapsed,
        breakpoint: "lg" // tslint:disable-next-line:no-shadowed-variable
        ,
        onCollapse: function onCollapse(collapsed) {
          setTimeout(function () {
            // tslint:disable-next-line:no-unused-expression
            window.JFiexdViewDom && window.JFiexdViewDom.forceUpdate();
          }, 100);

          _this3.setState({
            collapsed: collapsed
          });
        },
        trigger: React.createElement(_jIcon["default"], {
          type: "zhankaishousuodaohang",
          style: {
            fontSize: 22,
            color: '#0078d6'
          }
        }),
        width: 212,
        className: "".concat(preCls, "-sider layout-sider-menu")
      }, React.createElement(_menu["default"], _extends({
        key: "Menu",
        theme: "dark",
        mode: "inline"
      }, menuProps, {
        onOpenChange: this.handleOpenChange,
        onClick: this.handleClick,
        selectedKeys: selectedKeys,
        style: {
          padding: '16px 0',
          width: '100%'
        }
      }), this.getNavMenuItems(menuData)));
    }
  }]);

  return SiderMenu;
}(React.PureComponent);

exports["default"] = SiderMenu;