"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _table = _interopRequireDefault(require("../table"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function initTotalList(columns) {
  var totalList = [];
  columns.forEach(function (column) {
    if (column.needTotal) {
      totalList.push(_extends({}, column, {
        total: 0
      }));
    }
  });
  return totalList;
}

var StandardTable =
/*#__PURE__*/
function (_React$Component) {
  _inherits(StandardTable, _React$Component);

  function StandardTable(props) {
    var _this;

    _classCallCheck(this, StandardTable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(StandardTable).call(this, props));

    _this.handleRowSelectChange = function (selectedRowKeys, selectedRows) {
      var needTotalList = _toConsumableArray(_this.state.needTotalList);

      needTotalList = needTotalList.map(function (item) {
        return _extends({}, item, {
          total: selectedRows.reduce(function (sum, val) {
            return sum + parseFloat(val[item.dataIndex]);
          }, 0)
        });
      });

      _this.setState({
        selectedRows: selectedRows
      });

      if (_this.props.onSelectRow) {
        _this.props.onSelectRow(selectedRowKeys, selectedRows, 'select');
      }

      _this.setState({
        selectedRowKeys: selectedRowKeys
      });
    };

    _this.handleTableChange = function (pagination, filters, sorter) {
      _this.props.onChange(pagination, filters, sorter);
    };

    _this.cleanSelectedKeys = function () {
      _this.handleRowSelectChange([], []);
    };

    _this.setSelectedRowKeys = function (key) {
      if (!key || key === 'undefined') {
        console.warn("the rowKey ".concat(_this.props.rowKey, " \"").concat(key, "\" not exit "));
        return [];
      }

      var selectedRowKeys = _this.state.selectedRowKeys;
      var type = _this.props.type;

      if (type === 'radio') {
        return [key];
      }

      if (selectedRowKeys.length > 0 && selectedRowKeys.indexOf(key) >= 0) {
        selectedRowKeys.splice(selectedRowKeys.indexOf(key), 1);
        return selectedRowKeys;
      }

      selectedRowKeys.push(key);
      return selectedRowKeys;
    };

    _this.setRecord = function (list, keys, key) {
      return list.filter(function (item) {
        return keys.indexOf(item[key]) >= 0;
      });
    };

    var columns = props.columns;
    var needTotalList = initTotalList(columns);
    _this.state = {
      selectedRowKeys: [],
      needTotalList: needTotalList,
      selectedRows: [],
      reset: _this.props.reset
    };
    return _this;
  }

  _createClass(StandardTable, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var reset = this.state.reset;

      if (reset !== nextProps.reset) {
        this.setState({
          reset: nextProps.reset,
          selectedRowKeys: [],
          selectedRows: []
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          _this$props$prefixCls = _this$props.prefixCls,
          prefixCls = _this$props$prefixCls === void 0 ? 'ant-standardTable' : _this$props$prefixCls;
      var selectedRowKeys = this.state.selectedRowKeys;
      var _this$props2 = this.props,
          _this$props2$data = _this$props2.data,
          list = _this$props2$data.list,
          pagination = _this$props2$data.pagination,
          loading = _this$props2.loading,
          columns = _this$props2.columns,
          rowKey = _this$props2.rowKey,
          type = _this$props2.type,
          scroll = _this$props2.scroll;

      var paginationProps = _extends({
        showSizeChanger: true,
        showQuickJumper: true
      }, pagination);

      var rowSelection = {
        columnWidth: 50,
        selectedRowKeys: selectedRowKeys,
        type: type || 'type',
        onChange: this.handleRowSelectChange,
        getCheckboxProps: function getCheckboxProps(record) {
          return {
            disabled: record.disabled
          };
        }
      };
      var classes = (0, _classnames["default"])(prefixCls, className);
      return React.createElement("div", {
        className: classes
      }, React.createElement(_table["default"], {
        onRow: function onRow(record) {
          return {
            onClick: function onClick() {
              if (_this2.state.selectedRowKeys !== record[rowKey || 'id']) {
                var keys = _this2.setSelectedRowKeys(record[rowKey || 'id']);

                var rows = _this2.setRecord(list, keys, rowKey || 'id');

                _this2.props.onSelectRow(keys, rows, 'click');

                _this2.setState({
                  selectedRowKeys: keys
                });
              }
            },
            onDoubleClick: function onDoubleClick() {
              if (type !== 'radio') {
                return;
              }

              var keys = _this2.setSelectedRowKeys(record[rowKey || 'id']);

              var rows = _this2.setRecord(list, keys || [], rowKey || 'id');

              _this2.props.onSelectRow(keys || [], rows || [], 'doubleClick');

              _this2.setState({
                selectedRowKeys: keys
              });
            }
          };
        },
        loading: loading,
        scroll: scroll,
        rowKey: rowKey || 'id',
        rowSelection: rowSelection || null,
        dataSource: list,
        columns: columns,
        pagination: paginationProps,
        onChange: this.handleTableChange
      }));
    }
  }]);

  return StandardTable;
}(React.Component);

var _default = StandardTable;
exports["default"] = _default;